      SUBROUTINE BASDF
C
C     ******************************************************************
C     DEFINE KEY MODEL PARAMETERS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*80 LINE1,LINE2
C     ------------------------------------------------------------------
C0------OPEN FILES AND ASSIGN IUNIT VALUES.
C
C1------PRINT THE NAME OF THE PROGRAM.
      WRITE(IOUT,1)
    1 FORMAT(1H1,5X,'U.S. GEOLOGICAL SURVEY MODULAR',
     1      ' FINITE-DIFFERENCE GROUND-WATER FLOW MODEL')
C
C2------READ AND PRINT A HEADING.
      READ(IUREAL(INBAS),'(A)') HEADNG(1)
      READ(IUREAL(INBAS),'(A)') HEADNG(2)
      WRITE(IOUT,'(1X,/1X,A)') HEADNG(1)
      WRITE(IOUT,'(1X,A)') HEADNG(2)
C
C
C3------READ LINE SPECIFYING NUMBER OF LAYERS,ROWS,COLUMNS,STRESS
C3------PERIODS AND UNITS OF TIME CODE, BUT DON'T DECODE UNTIL IT IS
C3------DETERMINED THAT FREE OR FIXED FORMAT IS BEING USED.
      READ(IUREAL(INBAS),'(A)') LINE1
C
C4------READ OPTIONS RECORD AND LOOK FOR OPTIONS
      READ(IUREAL(INBAS),'(A)') LINE2
      IXSEC=0
      ICHFLG=0
      MODINP=0
      MODOUT=0
      LLOC=1
101   CALL URWORD(LINE2,LLOC,ISTART,ISTOP,1,N,R,IOUT,INBAS)
      IF(LINE2(ISTART:ISTOP).EQ.'XSECTION' .AND. NROW.EQ.1) THEN
         IXSEC=1
      ELSE IF(LINE2(ISTART:ISTOP).EQ.'CHTOCH') THEN
         ICHFLG=1
      ELSE IF(LINE2(ISTART:ISTOP).EQ.'FREE') THEN
         MODINP=1
         MODOUT=1
         WRITE(IOUT,4)
    4    FORMAT (1X,'THE FREE FORMAT OPTION HAS BEEN SELECTED')
      END IF
      IF(LLOC.LT.80) GO TO 101
      CALL IVLSAV('IXSEC',0,0,IXSEC)
      CALL IVLSAV('ICHFLG',0,0,ICHFLG)
C
C5------READ NUMBER OF LAYERS, ROWS, COLUMNS, STRESS PERIODS, AND
C5------ITMUNI USING FREE OR FIXED FORMAT.
      IF(MODINP.EQ.0) THEN
         READ(LINE1,'(5I10)') NLAY,NROW,NCOL,NPER,ITMUNI
      ELSE
         LLOC=1
         CALL URWORD(LINE1,LLOC,ISTART,ISTOP,2,NLAY,R,IOUT,INBAS)
         CALL URWORD(LINE1,LLOC,ISTART,ISTOP,2,NROW,R,IOUT,INBAS)
         CALL URWORD(LINE1,LLOC,ISTART,ISTOP,2,NCOL,R,IOUT,INBAS)
         CALL URWORD(LINE1,LLOC,ISTART,ISTOP,2,NPER,R,IOUT,INBAS)
         CALL URWORD(LINE1,LLOC,ISTART,ISTOP,2,ITMUNI,R,IOUT,INBAS)
      END IF
C
C6------PRINT # OF LAYERS, ROWS, COLUMNS AND STRESS PERIODS.
      WRITE(IOUT,5) NLAY,NROW,NCOL
    5 FORMAT(1X,I4,' LAYERS',I10,' ROWS',I10,' COLUMNS')
      IF(NLAY.GT.200) THEN
         WRITE(IOUT,*) ' Too many layers -- maximum is 200'
         CALL RDABRT
      END IF
      WRITE(IOUT,6) NPER
    6 FORMAT(1X,I3,' STRESS PERIOD(S) IN SIMULATION')
      IF(NPER.GT.MXPER) THEN
         WRITE(IOUT,*) ' Too many stress periods -- maximum is',MXPER
         CALL RDABRT
      END IF
      IF(NPER.LT.1) THEN
         WRITE(IOUT,*) ' There must be at least 1 stress period'
         CALL RDABRT
      END IF
C
C7------SELECT AND PRINT A MESSAGE SHOWING TIME UNITS AND OTHER OPTIONS.
      IF(ITMUNI.LT.0 .OR. ITMUNI.GT.5) ITMUNI=0
      CALL IVLSAV('ITMUNI',0,0,ITMUNI)
      IF(ITMUNI.EQ.0) THEN
         WRITE(IOUT,9)
    9    FORMAT(1X,'MODEL TIME UNITS ARE UNDEFINED')
      ELSE IF(ITMUNI.EQ.1) THEN
         WRITE(IOUT,11)
   11    FORMAT(1X,'MODEL TIME UNIT IS SECONDS')
      ELSE IF(ITMUNI.EQ.2) THEN
         WRITE(IOUT,21)
   21    FORMAT(1X,'MODEL TIME UNIT IS MINUTES')
      ELSE IF(ITMUNI.EQ.3) THEN
         WRITE(IOUT,31)
   31    FORMAT(1X,'MODEL TIME UNIT IS HOURS')
      ELSE IF(ITMUNI.EQ.4) THEN
         WRITE(IOUT,41)
   41    FORMAT(1X,'MODEL TIME UNIT IS DAYS')
      ELSE
         WRITE(IOUT,51)
   51    FORMAT(1X,'MODEL TIME UNIT IS YEARS')
      END IF
      IF(IXSEC.NE.0) WRITE(IOUT,106)
106   FORMAT(1X,'CROSS SECTION OPTION IS SPECIFIED')
      IF(ICHFLG.NE.0) WRITE(IOUT,107)
107   FORMAT(1X,
     1    'CALCULATE FLOW BETWEEN ADJACENT CONSTANT-HEAD CELLS')
C
C
C8------RETURN
      RETURN
      END
      SUBROUTINE BASAL()
C     ******************************************************************
C     ALLOCATE SPACE FOR BASIC MODEL ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
C
C1------PRINT A MESSAGE IDENTIFYING THE PACKAGE.
      WRITE(IOUT,1)INBAS
    1 FORMAT(1X,/1X,'BAS -- BASIC MODEL PACKAGE,',
     2' INPUT READ FROM UNIT',I3)
C
C2------READ & PRINT FLAG IAPART (RHS & BUFFER SHARE SPACE?) AND
C2------FLAG ISTRT (SHOULD STARTING HEADS BE KEPT FOR DRAWDOWN?).
      IF(MODINP.EQ.0) READ(IUREAL(INBAS),'(2I10)') IAPART,ISTRT
      IF(MODINP.NE.0) READ(IUREAL(INBAS),*) IAPART,ISTRT
      IF(IAPART.NE.0) WRITE(IOUT,2)
    2 FORMAT(1X,
     1    'ARRAYS RHS AND BUFF WILL HAVE SEPARATE MEMORY ALLOCATIONS')
      IF(IAPART.EQ.0) WRITE(IOUT,3)
    3 FORMAT(1X,'ARRAYS RHS AND BUFF WILL SHARE MEMORY')
      IF(ISTRT.NE.0) WRITE(IOUT,4)
    4 FORMAT(1X,'INITIAL HEAD WILL BE KEPT THROUGHOUT THE SIMULATION')
      IF(ISTRT.EQ.0) WRITE(IOUT,5)
    5 FORMAT(1X,'INITIAL HEAD WILL NOT BE KEPT THROUGHOUT THE',
     1 ' SIMULATION, WHICH MEANS',/1X,'DRAWDOWN CANNOT BE CALCULATED')
C
C8------RETURN
      RETURN
C
      END
      SUBROUTINE BASRP()
C     ******************************************************************
C     READ AND INITIALIZE BASIC MODEL ARRAYS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME(2)
      EQUIVALENCE (IX,X)
      DIMENSION IX(LENX)
C
      DATA ANAME(1) /'          BOUNDARY ARRAY'/
      DATA ANAME(2) /'            INITIAL HEAD'/
C     ------------------------------------------------------------------
C  Get cross section code
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
C
C1------PRINT SIMULATION TITLE, CALCULATE # OF CELLS IN A LAYER.
      WRITE(IOUT,'(1H1,A)') HEADNG(1)
      WRITE(IOUT,'(1X,A)') HEADNG(2)
C
C2------READ BOUNDARY ARRAY(IBOUND) ONE LAYER AT A TIME.
      IF(IXSEC.EQ.0) THEN
         DO 100 K=1,NLAY
         KK=K
         CALL ARRMAK('IBOUND',KK,0,NCOL,NROW)
         CALL U2DINT(ANAME(1),NROW,NCOL,KK,INBAS,NARRAY,INBAS)
  100    CONTINUE
      ELSE
         CALL ARRMAK('IBOUND',0,0,NCOL,NLAY)
         CALL U2DINT(ANAME(1),NLAY,NCOL,-1,INBAS,NARRAY,INBAS)
      END IF
C
C3------READ AND PRINT HEAD VALUE TO BE PRINTED FOR NO-FLOW CELLS.
      IF(MODINP.EQ.0) READ(IUREAL(INBAS),'(F10.0)') HNOFLO
      IF(MODINP.NE.0) READ(IUREAL(INBAS),*) HNOFLO
      WRITE(IOUT,3) HNOFLO
    3 FORMAT(1X,/1X,'AQUIFER HEAD WILL BE SET TO ',1PG11.5,
     1       ' AT ALL NO-FLOW NODES (IBOUND=0).')
      CALL VALSAV('HNOFLO',0,0,HNOFLO)
C
C4------READ INITIAL HEADS.
      IF(IXSEC.EQ.0) THEN
         DO 300 K=1,NLAY
         KK=K
         CALL ARRMAK('SHEAD',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(2),NROW,NCOL,KK,INBAS,NARRAY,INBAS)
  300    CONTINUE
      ELSE
         CALL ARRMAK('SHEAD',0,0,NCOL,NLAY)
         CALL U2DREL(ANAME(2),NLAY,NCOL,-1,INBAS,NARRAY,INBAS)
      END IF
C
C9------RETURN
 1000 RETURN
      END
      SUBROUTINE BASST(KPER)
C     ******************************************************************
C     SETUP TIME PARAMETERS FOR NEW TIME PERIOD
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C     ------------------------------------------------------------------
C
C1------READ AND WRITE LENGTH OF STRESS PERIOD, NUMBER OF TIME STEPS AND
C1------TIME STEP MULTIPLIER.
      IF(MODINP.EQ.0) READ(IUREAL(INBAS),'(F10.0,I10,F10.0)')
     1                           PERLEN(KPER),NSTP(KPER),TSMULT(KPER)
      IF(MODINP.NE.0)
     1     READ(IUREAL(INBAS),*) PERLEN(KPER),NSTP(KPER),TSMULT(KPER)
      WRITE (IOUT,1) KPER,PERLEN(KPER),NSTP(KPER),TSMULT(KPER)
    1 FORMAT(1H1,27X,'STRESS PERIOD NO.',I4,', LENGTH =',G15.7/28X
     1,46('-')//30X,'NUMBER OF TIME STEPS =',I6
     2//31X,'MULTIPLIER FOR DELT =',F10.3)
C
C1A-----STOP IF NSTP LE 0, PERLEN LE 0., OR TSMULT LE 0.
      IF(NSTP(KPER).LE.0) THEN
         WRITE(IOUT,2)
    2    FORMAT(1X,/1X,'THERE MUST BE AT LEAST ONE TIME STEP')
         CALL RDABRT
      END IF
      ZERO=0.
      IF(PERLEN(KPER).LE.ZERO) THEN
         WRITE(IOUT,3)
    3    FORMAT(1X,/1X,'PERLEN MUST BE GREATER THAN 0.0')
         CALL RDABRT
      END IF
      IF(TSMULT(KPER).LE.ZERO) THEN
         WRITE(IOUT,4)
    4    FORMAT(1X,/1X,'TSMULT MUST BE GREATER THAN 0.0')
         CALL RDABRT
      END IF
C
C5------RETURN
      RETURN
      END
      SUBROUTINE SBASO(INUNIT,CUNIT)
C
C     ******************************************************************
C     OPEN FILES.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*4 CUNIT(40)
      CHARACTER*80 LINE
      CHARACTER*11 FMTARG
C     ---------------------------------------------------------------
C
C2------READ A LINE; IGNORE BLANK LINES.
10    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 10
      IOPN=0
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
      IF(IU.LE.0 .OR. IU.GT.MXFNAM) THEN
         WRITE(IOUT,*) ' File unit out of range:',IU
         CALL RDABRT
      END IF
C
C4------CHECK FOR A VALID FILE TYPE.
      FMTARG='FORMATTED'
C
C4A-----CHECK FOR FILE-TYPE "LIST".
      IF(LINE(ITYP1:ITYP2).EQ.'LIST') THEN
         IF(ILOUT.NE.0) THEN
            WRITE(IOUT,*) ' Duplicate definition of LIST file'
            CALL RDABRT
         END IF
         ILOUT=IU
         IFNUSE(IU)=IU
C
C4B-----CHECK FOR "BAS" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'BAS') THEN
         IF(INBAS.NE.0) THEN
            WRITE(IOUT,*) ' Duplicate BAS Package file type'
            CALL RDABRT
         END IF
         INBAS=IU
         IOPN=1
         IFNUSE(IU)=IU
C
C4C-----CHECK FOR "UNFORMATTED" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA(BINARY)') THEN
         FMTARG='UNFORMATTED'
         IFNUSE(IU)=-1
C
C4D-----CHECK FOR "FORMATTED FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA') THEN
         FMTARG='FORMATTED'
         IFNUSE(IU)=-1
C
C4E-----CHECK FOR MAJOR OPTIONS.
      ELSE
         DO 20 I=1,40
            IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
               IF(IUNIT(I).NE.0) THEN
                  WRITE(IOUT,*) ' Duplicate package file type:',CUNIT(I)
                  CALL RDABRT
               END IF
               IUNIT(I)=IU
               IOPN=1
               IFNUSE(IU)=IU
               GO TO 30
            END IF
20       CONTINUE
         IFNUSE(IU)=-1
30       CONTINUE
      END IF
C
C5------DETERMINE FILE NAME AND THE ACCESS METHOD (DIRECT OR
C5------SEQUENTIAL).  WRITE ITS NAME AND OPEN IT.
      IF(IUCASE.EQ.0) THEN
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUT,INUNIT)
      ELSE
         CALL URWORD(LINE,LLOC,INAM1,INAM2,1,N,R,IOUT,INUNIT)
      END IF
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INUNIT)
      IF(LINE(ISTART:ISTOP).EQ.'DIRECT') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRECL,R,IOUT,INUNIT)
         WRITE(IOUT,35) LINE(INAM1:INAM2),
     1     LINE(ITYP1:ITYP2),IU,IRECL
35       FORMAT(1X,/1X,'OPENING ',A,/
     1   1X,'FILE TYPE:',A,'   UNIT',I4,'   DIRECT ACCESS',I10)
         IF(IOPN.NE.0) THEN
            CALL REALUN(IU)
            OPEN(UNIT=IUREAL(IU),FILE=LINE(INAM1:INAM2),
     1      FORM=FMTARG,ACCESS='DIRECT',RECL=IRECL)
         END IF
      ELSE
         WRITE(IOUT,36) LINE(INAM1:INAM2),
     1     LINE(ITYP1:ITYP2),IU
36       FORMAT(1X,/1X,'OPENING ',A,/
     1     1X,'FILE TYPE:',A,'   UNIT',I4)
         IF(IOPN.NE.0) THEN
            CALL REALUN(IU)
            OPEN(UNIT=IUREAL(IU),FILE=LINE(INAM1:INAM2),
     1      FORM=FMTARG,ACCESS='SEQUENTIAL')
         END IF
      END IF
C
C6------PUT FILE NAME INTO TABLE OF FILE NAMES.
      IF(FILTYP(IU).NE.' ') THEN
         WRITE(IOUT,*) ' ATTEMPT TO OPEN A FILE ON A PREVIOUSLY',
     1        ' DEFINED UNIT'
         WRITE(IOUT,*) ' THE CONFLICT IS ON UNIT',IU
         CALL RDABRT
      END IF
      DO 40 I=1,MXFNAM
      IF(FILNAM(I).EQ.LINE(INAM1:INAM2)) THEN
         WRITE(IOUT,*) ' Duplicate file name:'
         WRITE(IOUT,*) FILNAM(I)
         CALL RDABRT
      END IF
40    CONTINUE
      FILTYP(IU)=LINE(ITYP1:ITYP2)
      FILNAM(IU)=LINE(INAM1:INAM2)
      GO TO 10
C
C7------END OF NAME FILE.
1000  WRITE(IOUT,*) ' MODINP:',MODINP
      CLOSE(UNIT=INUNIT)
      RETURN
C
      END
      SUBROUTINE SBASC()
C
C     ******************************************************************
C     CLOSE ALL FILES FROM WHICH AN EXISTING DATASET WAS READ.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
C
C  Only package files are read, so check each one and close those for
C  which there is a virtual unit.
      IF(INBAS.GT.0) CLOSE(UNIT=IUREAL(INBAS))
      DO 10 I=1,39
      IF(IUNIT(I).GT.0) CLOSE(UNIT=IUREAL(IUNIT(I)))
10    CONTINUE
C
      RETURN
      END
      SUBROUTINE BASED
C  *********************************************************************
C  Input BAS Package data
C  *********************************************************************
C
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C
      DIMENSION IBUF(2)
      DIMENSION IPER(MXPER)
C
C  Main BAS menu
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IOPT=1
10    CALL QRESP(MESSFL,301,1,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  MISCELLANEOUS -- Initialize screen
11       CALL Q1INIT(MESSFL,301,3)
C  Initialize values
         IMTYP=MODOUT+1
         CALL QSETOP(1,1,1,1,IMTYP)
         CALL QSTCTF(1,78,HEADNG(1))
         CALL QSTCTF(2,78,HEADNG(2))
         CALL VALGET('HNOFLO',0,0,ITYPE,HNOFLO)
         IF(ITYPE.NE.0) HNOFLO=999.99
         CALL QSETR(1,HNOFLO)
C  Activate user input
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 11
C  Store values
         CALL QGETOP(1,IMTYP)
         MODOUT=IMTYP-1
         CALL QGETR(1,HNOFLO)
         CALL VALSAV('HNOFLO',0,0,HNOFLO)
         IBUF(1)=78
         IBUF(2)=78
         CALL QGETCT(2,IBUF,156,HEADNG)
C
      ELSE IF(IOPT.EQ.2) THEN
C  IBOUND -- Check if cross section or not
         IF(IXSEC.NE.0) THEN
            CALL U2DIN('MODFLOW IBOUND (cross section)','IBOUND',0,0,
     1                  NCOL,NLAY,INBAS)
C
C  Not a cross section -- set default to layer 1
         ELSE
            ILAY=1
C  Prompt for layer number
20          IF(NLAY.GT.1) CALL ULAYIN('IBOUND',ILAY)
C  If layer 0 is returned, then done entering IBOUND
            IF(ILAY.GT.0) THEN
C  Layer > 0, get control record
               CALL U2DIN('MODFLOW IBOUND','IBOUND',ILAY,0,NCOL,NROW,
     1                   INBAS)
               IF(IUNIT(40).GT.0) THEN
                   CALL IBNDCK(ILAY,IERR)
                   IF(IERR.NE.0) CALL PMXTXI(MESSFL,308,9,10,1,0,1,ILAY)
               END IF
C  Now see if another layer is desired -- set default to layer+1
               ILAY=ILAY+1
               IF(ILAY.GT.NLAY) ILAY=1
               IF(NLAY.GT.1) GO TO 20
            END IF
         END IF
C
      ELSE IF(IOPT.EQ.3) THEN
C  Initial head -- Check if cross section or not
         IF(IXSEC.NE.0) THEN
               CALL U2DIN('INITIAL HEAD for X section (SHEAD)','SHEAD',
     1                  0,0,NCOL,NLAY,INBAS)
         ELSE
C  Not a cross section -- set default layer to layer 1
            ILAY=1
C  Prompt for layer layer number
30          IF(NLAY.GT.1) CALL ULAYIN('INITIAL HEAD (SHEAD)',ILAY)
C  If layer 0 is returned, then done entering INITIAL HEAD
            IF(ILAY.GT.0) THEN
C  Layer > 0, get control record
               CALL U2DIN('INITIAL HEAD (SHEAD)','SHEAD',ILAY,0,NCOL,
     1                    NROW,INBAS)
C  Now see if another layer is desired -- set default to layer+1
               ILAY=ILAY+1
               IF(ILAY.GT.NLAY) ILAY=1
               IF(NLAY.GT.1) GO TO 30
            END IF
         END IF
C
      ELSE IF(IOPT.EQ.4) THEN
C  Stress period parameters
C  Determine current time option so the new value can be compared to it
         ITMOLD=3
         IF(ISS.NE.0) THEN
            ITMOLD=1
            IF(NPER.GT.1 .OR. PERLEN(1).NE.1.0) ITMOLD=2
         END IF
C  Initialize the steady state/transient screen
41       CALL Q1INIT(MESSFL,301,4)
C  Set initial values according to current values
         CALL IVLGET('ITMUNI',0,0,ITYPE,ITMUNI)
         IF(ITYPE.NE.0) ITMUNI=0
         ITMUNI=ITMUNI+1
         CALL QSTCOB(1,1,ITMUNI)
         CALL QSETOP(1,1,1,1,ITMOLD)
         CALL QSETI(1,NPER)
C  Activate the screen
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 41
C  Get time unit
         CALL QGTCOB(1,1,ITMUNI)
         ITMUNI=ITMUNI-1
         CALL IVLSAV('ITMUNI',0,0,ITMUNI)
C  Get the selected option
         CALL QGETOP(1,ITMOPT)
         IF(ITMOPT.EQ.1) THEN
C  Simple Steady state -- assign values
            ISS=1
            NPER=1
            PERLEN(1)=1.
            NSTP(1)=1
            TSMULT(1)=1.
         ELSE IF(ITMOPT.EQ.2) THEN
C  Complex steady state
            ISS=1
            CALL QGETI(1,NPER)
         ELSE
C  Transient
            ISS=0
            CALL QGETI(1,NPER)
         END IF
C  Unless simple steady state, get the stress period data
         IF(ITMOPT.GT.1) THEN
C  Set the Stress period counter.
            DO 54 I=1,NPER
            IPER(I)=I
54          CONTINUE
C  Set intial stress period parameters -- Make them undefined unless
C  there were already transient values assigned.
            IF(ITMOLD.NE.ITMOPT) THEN
C  Previously a different time option -- make the values for 10 periods
C  undefined so user will have to define them before leaving the screen).
               DO 55 I=1,10
               NSTP(I)=-999
               PERLEN(I)=-999.
               TSMULT(I)=1.
55             CONTINUE
            END IF
C  Initialize screen
56          IF(ITMOPT.EQ.3) CALL Q2INIT(MESSFL,301,5)
            IF(ITMOPT.EQ.2) CALL Q2INIT(MESSFL,301,8)
C  Send initial values to screen
            CALL Q2STIB(1,1,NPER,IPER)
            IF(ITMOPT.EQ.3) CALL Q2STIB(1,2,NPER,NSTP)
            CALL Q2STRB(1,1,NPER,PERLEN)
            IF(ITMOPT.EQ.3) CALL Q2STRB(1,2,NPER,TSMULT)
C  Activate the screen
            CALL Q2EDIT(NPER,IRET)
            IF(IRET.EQ.-1) GO TO 56
C  Retrieve the edited values
            IF(ITMOPT.EQ.3) CALL Q2GTIB(1,2,NPER,NSTP)
            CALL Q2GTRB(1,1,NPER,PERLEN)
            IF(ITMOPT.EQ.3) CALL Q2GTRB(1,2,NPER,TSMULT)
C  If complex steady state, set TSMULT and NSTP
            IF(ITMOPT.EQ.2) THEN
               DO 60 I=1,NPER
               TSMULT(I)=1.
               NSTP(I)=1
60             CONTINUE
            END IF
         END IF
C
C  Check for undefined data
      ELSE IF(IOPT.EQ.5) THEN
         CALL BASSV(IUNDEF,-1,NPER)
C
      ELSE
         CALL BASSV(IUNDEF,1,NPER)
         RETURN
      END IF
C
      IOPT=IOPT+1
      GO TO 10
      END
      SUBROUTINE BASSV(IUNDEF,IWRFLG,NNPER)
C     ******************************************************************
C     SAVE DATA FOR BAS PACKAGE
C       NNPER is the value of NPER that is written in the 3rd record.
C       The possibility of having NNPER differ from NPER is included
C       for use with MODFLOWP.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
      DIMENSION IUNITR(24)
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      NMISS=0
C  BAS Package is always active, so don't check for inactive
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.INBAS) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(INBAS)=INBAS
C
      IF(IUREAL(INBAS).EQ.0) IUREAL(INBAS)=5
      IF(IUREAL(ILOUT).EQ.0) IUREAL(ILOUT)=6
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.BAS',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(INBAS),UNIT=IFIL)
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      CALL IVLGET('ICHFLG',0,0,ITYPE,ICHFLG)
      IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') HEADNG(1)
      IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') HEADNG(2)
      CALL IVLGET('ITMUNI',0,0,ITYPE,ITMUNI)
      IF(ITYPE.NE.0) ITMUNI=0
      IF(IWRFLG.GT.0) WRITE(IFIL,'(5I10,A)') NLAY,NROW,NCOL,NNPER,
     1   ITMUNI,'  NLAY,NROW,NCOL,NPER,ITMUNI'
      IF(IWRFLG.GT.0) THEN
         IF(MODOUT.EQ.0) THEN
C  Original model -- write IUNIT
            DO 7 I=1,24
            IUNITR(I)=0
            IF(IUNIT(I).NE.0) THEN
               IF(IUREAL(IUNIT(I)).LE.0) CALL REALUN(IUNIT(I))
               IUNITR(I)=IUREAL(IUNIT(I))
            END IF
7           CONTINUE
            IF(IXSEC.EQ.0) WRITE(IFIL,'(24I3)') (IUNITR(I),I=1,24)
C  Although the original model cannot read x-section data, write the
C  option into the IUNIT record if it is set.  This will cause MODFLOW
C  to abort, but subsequent use of MFI will still recognize the X-section
C  option.
            IF(IXSEC.NE.0) WRITE(IFIL,'(A,24I3)')
     1                              'XSECTION ',(IUNITR(I),I=1,24)
         ELSE
C  New model -- write options record
            LL=4
            LINE(1:LL)='FREE'
            IF(ICHFLG.NE.0) THEN
               LINE(LL+1:LL+7)= ' CHTOCH'
               LL=LL+7
            END IF
            IF(IXSEC.NE.0) THEN
               LINE(LL+1:LL+9)= ' XSECTION'
               LL=LL+9
            END IF
            IF(LL.EQ.0) WRITE(IFIL,'(A)') 'NO OPTIONS'
            IF(LL.GT.0) WRITE(IFIL,'(A)') LINE(1:LL)
         END IF
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)') IAPART,ISTRT,
     1          '  IAPART,ISTRT'
C
      IF(IXSEC.EQ.0) THEN
         DO 10 K=1,NLAY
         KK=K
         CALL U2DISV('IBOUND',KK,0,IUNDEF,IFIL,INBAS)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I10)') 'IBOUND    ',KK
         END IF
10       CONTINUE
      ELSE
         CALL U2DISV('IBOUND',0,0,IUNDEF,IFIL,INBAS)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') 'IBOUND              '
         END IF
      END IF
C
      CALL VALGET('HNOFLO',0,0,ITYPE,HNOFLO)
      IF(ITYPE.NE.0) HNOFLO=999.99
      IF(IWRFLG.GT.0) THEN
         IF(ABS(HNOFLO).LE.999999. .AND. ABS(HNOFLO).GE.100.) THEN
            WRITE(IFIL,'(F10.2,A)') HNOFLO,'  HNOFLO'
         ELSE
            WRITE(IFIL,'(1P,E10.3,A)') HNOFLO,'  HNOFLO'
         END IF
      END IF
C
      IF(IXSEC.EQ.0) THEN
         DO 20 K=1,NLAY
         KK=K
         CALL U2DRSV('SHEAD',KK,0,IUNDEF,IFIL,INBAS,'SHEAD',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I8)') 'INITIAL HEAD',KK
         END IF
20       CONTINUE
      ELSE
         CALL U2DRSV('SHEAD',0,0,IUNDEF,IFIL,INBAS,'SHEAD',0)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A)') 'INITIAL HEAD        '
         END IF
      END IF
C
      IF(IWRFLG.GT.0) THEN
         DO 30 N=1,NPER
         WRITE(IFIL,'(1P,E10.3,I10,E10.3,A)')
     1     PERLEN(N),NSTP(N),TSMULT(N),'  PERLEN,NSTP,TSMULT'
30       CONTINUE
      END IF
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.0) THEN
            CALL DSPTXT(MESSFL,301,6,CTEXT,NMISS,20)
            IUNDEF=1
         ELSE
            CALL PRNTXT(MESSFL,301,7)
         END IF
      END IF
C
      CALL FNMRMV
      RETURN
      END
