      SUBROUTINE DRNAL(IBDSAM,INMP)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR DRAINS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      CHARACTER*90 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(3)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NDRAIN.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'DRN -- DRAIN PACKAGE,',
     1       ' INPUT READ FROM UNIT',I3)
C
C2------READ MAXIMUM NUMBER OF DRAINS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      READ(IUREAL(IN),'(A)') LINE
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXDRN,IDRNCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXDRN,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDRNCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXDRN
    3 FORMAT(1H ,'MAXIMUM OF',I5,' DRAINS')
      IF(IDRNCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IDRNCB.GT.0) WRITE(IOUT,8) IDRNCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(IDRNCB.LT.0) IDRNCB=-1
      IUNIT2(3)=IDRNCB
      IF(IDRNCB.GT.0) THEN
         IF(FILTYP(IDRNCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IDRNCB)=IUNIT(12)
         ELSE IF(FILTYP(IDRNCB).EQ.' ') THEN
            IUNIT2(3)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(3).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(3).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IDRNCB.NE.0) IBDSAM=IDRNCB
      ELSE
         IF(IBDSAM.NE.IDRNCB) IBDSAM=0
      END IF
C
C-------Process auxiliary parameters
      DRNAUX(1)=' '
      NAUX=0
20    CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1   LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.EQ.0) THEN
            NAUX=1
            IF(LINE(ISTART:ISTOP).EQ.'IFACE') THEN
               DRNAUX(1)='IFACE'
               WRITE(IOUT,22) DRNAUX(1)
            ELSE
               IF(INMP.EQ.0) THEN
                  NAUX=2
                  DRNAUX(NAUX)=LINE(ISTART:ISTOP)
                  WRITE(IOUT,22) DRNAUX(NAUX)
               ELSE
                  WRITE(IOUT,22) LINE(ISTART:ISTOP)
                  WRITE(IOUT,*) 'When MODPATH is used, the 1st',
     1                   ' AUXILIARY parameter must be "IFACE"'
                  CALL RDABRT
               END IF
            END IF
         ELSE IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            DRNAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,22) DRNAUX(NAUX)
22          FORMAT(1X,'AUXILIARY DRAIN PARAMETER: ',A)
         ELSE
            WRITE(IOUT,*) ' Too many auxiliary parameters for MFI'
            CALL RDABRT
         END IF
         GO TO 20
      ELSE IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE') THEN
         GO TO 20
      END IF
C  Allow use of MODPATH without an explicit IFACE auxiliary parameter -- turn
C  the IFACE parameter on if MODPATH is active.
      IF(INMP.NE.0) DRNAUX(1)='IFACE'
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE DRNRP(KPER,IWARN)
C     ******************************************************************
C     READ DRAIN HEAD, CONDUCTANCE AND BOTTOM ELEVATION
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      CHARACTER*10 CMAX
C     ------------------------------------------------------------------
      IN=IUNIT(3)
C
C1------READ ITMP (NUMBER OF DRAINS OR FLAG TO REUSE DATA).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') ITMP
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ITMP
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) ' Undefined drain data for stress period'
         RETURN
      END IF
      CALL LSTMAK('DRAI',0,KPER,8)
      ARRCON(NARRAY)=1.
      IARRDA(1,NARRAY)=-2
C
C2------TEST ITMP.
      IF(ITMP.GE.0)GO TO 50
C
C2A-----IF ITMP <0 THEN REUSE DATA FROM LAST STRESS PERIOD.
      WRITE(IOUT,7)
    7 FORMAT(1X,/1X,'REUSING DRAINS FROM LAST STRESS PERIOD')
      IF(KPER.EQ.1) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED DRAIN DATA'
         CALL RDABRT
      END IF
      NDRAIN=-1
      CALL IVLSAV('DRAI',0,KPER,NDRAIN)
      RETURN
C
C3------IF ITMP=> ZERO THEN IT IS THE NUMBER OF DRAINS.
   50 NDRAIN=ITMP
      IF(ITMP.GT.MXLIST*10) THEN
         ITMP=MXLIST*10
         WRITE(CMAX,'(I10)') ITMP
         WRITE(IOUT,'(A)')
     1' WARNING -- Truncating drains -- maximum number is'//CMAX
         IWARN=IWARN+1
         IF(NMISS.LT.45) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)=
     1      ' WARNING -- Truncating drains -- maximum number is'//CMAX
         END IF
      END IF
      CALL IVLSAV('DRAI',0,KPER,ITMP)
C
C5------PRINT NUMBER OF DRAINS IN THIS STRESS PERIOD.
  100 WRITE(IOUT,101)NDRAIN
  101 FORMAT(1X,//1X,I5,' DRAINS')
C
C6------IF THERE ARE NO DRAINS THEN RETURN.
      IF(NDRAIN.EQ.0) RETURN
C
C7------READ AND PRINT DATA FOR EACH DRAIN.
      CALL LSTRD(NDRAIN,NARRAY,X(IARRDA(2,NARRAY)),IN,
     1 'DRAIN NO. LAYER   ROW   COL  ELEVATION    CONDUCTANCE',
     2  DRNAUX,3)
C
C8------RETURN.
      RETURN
      END
      SUBROUTINE DRNED
C     ******************************************************************
C     EDIT DRAIN DATA
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
      CHARACTER*8 LABEL(5,2)
      DATA LABEL/' ',    ' ',  ' ',     ' ',    ' ',
     1           'LAYER','ROW','COLUMN','ELEV.','COND.'/
C     ------------------------------------------------------------------
C
C  Set IUNIT if not already set
      IF(IUNIT(3).EQ.0) THEN
         CALL FINDUN(13,IU,'DRN')
         IUNIT(3)=IU
         IUNIT2(3)=0
      END IF
C
C  Main DRN menu -- select the desired stress period -- default is 1
      KPER=1
10    CALL UPERIN('Drain Data',KPER)
C  Return if "previous" was selected
      IF(KPER.EQ.0) THEN
         CALL DRNSV(IUNDEF,1)
         RETURN
      END IF
C  Set up to get drain data for a stress period.
C  If array does not already exist, create array.
      CALL IVLGET('DRAI',0,KPER,NAR,NDRAIN)
      IF(NAR.LE.0) THEN
         CALL LSTMAK('DRAI',0,KPER,8)
         IARRDA(1,NARRAY)=-2
         ARRCON(NARRAY)=1.
         NDRAIN=0
         NAR=NARRAY
      END IF
C
C  Get new data
      IMETH=1
      IF(KPER.GT.1) THEN
         IF(NDRAIN.LT.0) IMETH=2
         CALL QRESP(MESSFL,307,4,IMETH)
      END IF
      IF(IMETH.EQ.1) THEN
         LOC=IARRDA(2,NAR)
         CALL SSLST(X(LOC),NDRAIN,LABEL,5,NAR,DRNAUX,3)
      ELSE
         NDRAIN=-1
      END IF
      CALL IVLSAV('DRAI',0,KPER,NDRAIN)
C
C  Ask for another stress period
      KPER=KPER+1
      IF(KPER.GT.NPER) KPER=1
      IF(NPER.GT.1) GO TO 10
C
C  End of DRAIN data input
      CALL DRNSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE DRNSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR DRAIN PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
C     ------------------------------------------------------------------
      IF(IUNIT(3).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IF(IUREAL(IUNIT(3)).EQ.0) CALL REALUN(IUNIT(3))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.DRN',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(3)),UNIT=IFIL)
C
C  Find undefined data and maximum number of drains in all periods
      CALL LSTMAX('DRAI',IWRFLG,IUNDEF,MXDRN,'DRN')
      IF(IWRFLG.LE.0) RETURN
C
C  Write the data
      IDRNCB=IBUDUN
      IF(IBUDUN.EQ.0) IDRNCB=IUNIT2(3)
      ITMPUN=IDRNCB
      IF(ITMPUN.GT.0) THEN
         IF(IUREAL(ITMPUN).EQ.0) CALL REALUN(ITMPUN)
         ITMPUN=IUREAL(ITMPUN)
      END IF
C
C  Write data for each stress period
      CALL LSTSAV('DRAI',IFIL,MXDRN,ITMPUN,DRNAUX,3,'    MXDRN IDRNCB')
C
      CLOSE(UNIT=IFIL)
      RETURN
      END
