      SUBROUTINE EVTAL(IBDSAM)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR EVAPOTRANSPIRATION
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(5)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'EVT -- EVAPOTRANSPIRATION PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C2------READ NEVTOP AND IEVTCB.
      IF(MODINP.EQ.0) THEN
         READ(IUREAL(IN),'(A)') LINE
         READ(LINE,'(2I10)') NEVTOP,IEVTCB
         LLOC=21
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IFAEVT,R,-1,IN)
         IF(IFAEVT.GT.1 .OR. IFAEVT.LT.0) IFAEVT=0
      ELSE
         READ(IUREAL(IN),'(A)') LINE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NEVTOP,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IEVTCB,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IFAEVT,R,-1,IN)
         IF(IFAEVT.GT.1 .OR. IFAEVT.LT.0) IFAEVT=0
      END IF
C
C3------CHECK TO SEE THAT OPTION IS LEGAL.
      IF(NEVTOP.GE.1.AND.NEVTOP.LE.2)GO TO 200
C
C3A-----IF ILLEGAL PRINT A MESSAGE AND ABORT SIMULATION
      WRITE(IOUT,8)
    8 FORMAT(1X,'ILLEGAL OPTION CODE. SIMULATION ABORTING')
      CALL RDABRT
C
C4------IF OPTION IS LEGAL PRINT OPTION CODE.
  200 IF(NEVTOP.EQ.1) WRITE(IOUT,201)
  201 FORMAT(1X,'OPTION 1 -- EVAPOTRANSPIRATION TO TOP LAYER')
      IF(NEVTOP.EQ.2) WRITE(IOUT,202)
  202 FORMAT(1X,'OPTION 2 -- EVAPOTRANSPIRATION TO ONE SPECIFIED NODE',
     1   ' IN EACH VERTICAL COLUMN')
C
C5------IF CELL-BY-CELL FLOWS ARE TO BE SAVED, THEN PRINT UNIT NUMBER.
      IF(IEVTCB.GT.0) WRITE(IOUT,204) IEVTCB
  204 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
      CALL IVLSAV('NEVTOP',0,0,NEVTOP)
      CALL IVLSAV('IFAEVT',0,0,IFAEVT)
      IUNIT2(5)=IEVTCB
      IF(IEVTCB.LE.0) IUNIT2(5)=0
      IF(IEVTCB.GT.0) THEN
         IF(FILTYP(IEVTCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IEVTCB)=IUNIT(12)
         ELSE IF(FILTYP(IEVTCB).EQ.' ') THEN
            IUNIT2(5)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(5).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(5).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IEVTCB.NE.0) IBDSAM=IEVTCB
      ELSE
         IF(IBDSAM.NE.IEVTCB) IBDSAM=0
      END IF
C
C9------RETURN
      RETURN
      END
      SUBROUTINE EVTRP(KPER)
C
C     ******************************************************************
C     READ EVAPOTRANSPIRATION DATA
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME(4)
C
      DATA ANAME(1) /'          ET LAYER INDEX'/
      DATA ANAME(2) /'              ET SURFACE'/
      DATA ANAME(3) /' EVAPOTRANSPIRATION RATE'/
      DATA ANAME(4) /'        EXTINCTION DEPTH'/
C     ------------------------------------------------------------------
      IN=IUNIT(5)
      CALL IVLGET('NEVTOP',0,0,ITYPE,NEVTOP)
C
C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
      IF(NEVTOP.EQ.2) THEN
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(4I10)')
     1                                      INSURF,INEVTR,INEXDP,INIEVT
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INSURF,INEVTR,INEXDP,INIEVT
      ELSE
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(3I10)') INSURF,INEVTR,INEXDP
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INSURF,INEVTR,INEXDP
      END IF
C
C2------TEST INSURF TO SEE WHERE SURFACE ELEVATION IS COMING FROM.
      IF(INSURF.GE.0)GO TO 32
C
C2A-----IF INSURF<0 THEN REUSE SURFACE ELEVATION FROM LAST STRESS PERIOD
      WRITE(IOUT,3)
    3 FORMAT(1X,/1X,'REUSING SURF FROM LAST STRESS PERIOD')
      CALL VALGET('SURF',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED SURF DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('SURF',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 35
C
C2B-----IF INSURF=>0 THEN CALL U2DREL TO READ SURFACE ELEVATION.
32    CALL ARRMAK('SURF',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(2),NROW,NCOL,0,IN,NARRAY,IN)
C
C3------TEST INEVTR TO SEE WHERE MAX ET RATE IS COMING FROM.
   35 IF(INEVTR.GE.0) GO TO 37
C
C3A-----IF INEVTR<0 THEN REUSE MAX ET RATE FROM LAST STRESS PERIOD.
      WRITE(IOUT,4)
    4 FORMAT(1X,/1X,'REUSING EVTR FROM LAST STRESS PERIOD')
      CALL VALGET('EVTR',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED EVTR DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('EVTR',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 45
C
C3B-----IF INEVTR=>0 THEN CALL U2DREL TO READ MAX ET RATE.
   37 CALL ARRMAK('EVTR',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(3),NROW,NCOL,0,IN,NARRAY,IN)
C
C4------TEST INEXDP TO SEE WHERE EXTINCTION DEPTH IS COMING FROM.
   45 IF(INEXDP.GE.0) GO TO 47
C
C4A-----IF INEXDP<0 THEN REUSE EXTINCTION DEPTH FROM LAST STRESS PERIOD.
      WRITE(IOUT,5)
    5 FORMAT(1X,/1X,'REUSING EXDP FROM LAST STRESS PERIOD')
      CALL VALGET('EXDP',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED EXDP DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('EXDP',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 55
C
C4B-----IF INEXDP=>0 THEN CALL U2DREL TO READ EXTINCTION DEPTH.
   47 CALL ARRMAK('EXDP',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(4),NROW,NCOL,0,IN,NARRAY,IN)
C
C9------IF NEVTOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
   55 IF (NEVTOP.NE.2) RETURN
C
C9A-----IF INIEVT<0 THEN REUSE LAYER INDICATOR ARRAY.
      IF(INIEVT.GE.0)GO TO 58
      WRITE(IOUT,2)
    2 FORMAT(1X,/1X,'REUSING IEVT FROM LAST STRESS PERIOD')
      CALL VALGET('IEVT',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED IEVT DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('IEVT',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      RETURN
C
C9B-----IF INIEVT=>0 CALL U2DINT TO READ LAYER IND ARRAY(IEVT)
58    CALL ARRMAK('IEVT',0,KPER,NCOL,NROW)
      CALL U2DINT(ANAME(1),NROW,NCOL,0,IN,NARRAY,IN)
      RETURN
C
      END
      SUBROUTINE EVTED
C  *********************************************************************
C  Edit EVT Package data
C  *********************************************************************
C
      INCLUDE 'mfi.gbl'
C
      IF(IUNIT(5).EQ.0) THEN
         CALL FINDUN(15,IU,'EVT')
         IUNIT(5)=IU
         IUNIT2(5)=0
         CALL IVLSAV('IFAEVT',0,0,1)
      END IF
      CALL IVLGET('NEVTOP',0,0,ITYPE,NEVTOP)
      IF(ITYPE.NE.0) THEN
         NEVTOP=1
         CALL IVLSAV('NEVTOP',0,0,NEVTOP)
      END IF
C
C  Main EVT menu
      IOPT=1
10    IF(IUNIT(40).LE.0) CALL QRESP(MESSFL,303,1,IOPT)
      IF(IUNIT(40).GT.0) CALL QRESP(MESSFL,303,5,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Edit evapotranspiration option
         CALL QRESP(MESSFL,303,2,NEVTOP)
         CALL IVLSAV('NEVTOP',0,0,NEVTOP)
C
      ELSE IF(IOPT.EQ.2) THEN
C  Edit Evapotranspiration arrays -- get stress period
         KPER=1
15       CALL UPERIN('Evapotranspiration Data',KPER)
C  Done with ET arrays if "previous" was selected
         IF(KPER.EQ.0) GO TO 90
C
C  Choose which array to input
         IAR=1
20       CALL QRESP(MESSFL,303,NEVTOP+2,IAR)
C  If an array was selected, edit it and ask again
         IF(IAR.NE.3+NEVTOP) THEN
            IF(IAR.EQ.1) THEN
               CALL U2DIN('ET Surface (SURF)','SURF',0,KPER,NCOL,NROW,
     1               IUNIT(5))
            ELSE IF(IAR.EQ.2) THEN
               CALL U2DIN('Max ET Rate (EVTR)','EVTR',0,KPER,NCOL,NROW,
     1               IUNIT(5))
            ELSE IF(IAR.EQ.3) THEN
               CALL U2DIN('Extinction Depth (EXDP)','EXDP',0,KPER,NCOL,
     1               NROW,IUNIT(5))
            ELSE
               CALL U2DIN('ET Layers (IEVT)','IEVT',0,KPER,NCOL,NROW,
     1               IUNIT(5))
            END IF
            IAR=IAR+1
            GO TO 20
         END IF
C  Get another stress period if there's more than one.
         KPER=KPER+1
         IF(KPER.GT.NPER) KPER=1
         IF(NPER.GT.1) GO TO 15
C
      ELSE IF(IOPT.EQ.3 .AND. IUNIT(40).GT.0) THEN
C  EVT face
         CALL IVLGET('IFAEVT',0,0,ITYPE,IFAEVT)
         IF(ITYPE.NE.0) IFAEVT=0
         ICH=IFAEVT+1
         CALL QRESP(MESSFL,303,6,ICH)
         IFAEVT=ICH-1
         CALL IVLSAV('IFAEVT',0,0,IFAEVT)
C
      ELSE
C  End of EVT data input
         CALL EVTSV(IUNDEF,1)
         RETURN
      END IF
C
90    IOPT=IOPT+1
      GO TO 10
C
      END
      SUBROUTINE EVTSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR EVAPOTRANSPIRATION PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IF(IUNIT(5).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IHEAD=0
      NM=0
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(5)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(5))=IUNIT(5)
C
      IF(IUREAL(IUNIT(5)).EQ.0) CALL REALUN(IUNIT(5))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.EVT',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(5)),UNIT=IFIL)
      CALL IVLGET('NEVTOP',0,0,ITYPE,NEVTOP)
      IF(ITYPE.NE.0) NEVTOP=1
      IEVTCB=IBUDUN
      IF(IBUDUN.EQ.0) IEVTCB=IUNIT2(5)
      ITMP=IEVTCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
      IF(IWRFLG.GT.0) THEN
         IF(IUNIT(40).LE.0) WRITE(IFIL,'(2I10,A)') NEVTOP,ITMP,
     1          ' NEVTOP IEVTCB'
         IF(IUNIT(40).GT.0) THEN
            CALL IVLGET('IFAEVT',0,0,ITYPE,IFAEVT)
            IF(ITYPE.NE.0) IFAEVT=0
            WRITE(IFIL,'(3I10,A)') NEVTOP,ITMP,IFAEVT,
     1          ' NEVTOP IEVTCB ITOP'
         END IF
      END IF
C
C  Write data for each stress period
      DO 100 KPER=1,NPER
      INSURF=0
      CALL VALGET('SURF',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INSURF=-1
      END IF
      INEVTR=0
      CALL VALGET('EVTR',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INEVTR=-1
      END IF
      INEXDP=0
      CALL VALGET('EXDP',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INEXDP=-1
      END IF
      INIEVT=0
      IF(NEVTOP.EQ.2) THEN
         CALL VALGET('IEVT',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INIEVT=-1
         END IF
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(4I10,A)')
     1   INSURF,INEVTR,INEXDP,INIEVT,'  INSURF INEVTR INEXDP INIEVT'
      IF(INSURF.GE.0) THEN
         CALL U2DRSV('SURF',0,KPER,IUNDEF,IFIL,IUNIT(5),'SURF',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'SURF            ',KPER
            END IF
         END IF
      END IF
      IF(INEVTR.GE.0) THEN
         CALL U2DRSV('EVTR',0,KPER,IUNDEF,IFIL,IUNIT(5),'EVTR',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'EVTR            ',KPER
            END IF
         END IF
      END IF
      IF(INEXDP.GE.0) THEN
         CALL U2DRSV('EXDP',0,KPER,IUNDEF,IFIL,IUNIT(5),'EXDP',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'EXDP            ',KPER
            END IF
         END IF
      END IF
      IF(NEVTOP.EQ.2) THEN
         IF(INIEVT.GE.0) THEN
            CALL U2DISV('IEVT',0,KPER,IUNDEF,IFIL,IUNIT(5))
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
               NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'EVT')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'IEVT            ',KPER
               END IF
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(NM.EQ.0 .AND. IWRFLG.LT.0 .AND. NMISS.LT.45) THEN
         NMISS=NMISS+1
         CTEXT(NMISS)='ALL DATA ARE DEFINED FOR EVT PACKAGE'
      END IF
      IF(NM.NE.0) IUNDEF=1
      CALL FNMRMV
      RETURN
      END
