      SUBROUTINE GHBAL(IBDSAM,INMP)
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR BOUNDARIES
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      CHARACTER*90 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(7)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NBOUND.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'GHB -- GENERAL-HEAD-BOUNDARY PACKAGE,',
     1       ' INPUT READ FROM UNIT',I3)
C
C2------READ MAXIMUM NUMBER OF BOUNDARIES AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      READ(IUREAL(IN),'(A)') LINE
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXBND,IGHBCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXBND,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IGHBCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXBND
    3 FORMAT(1H ,'MAXIMUM OF',I5,' BOUNDARIES')
      IF(IGHBCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IGHBCB.GT.0) WRITE(IOUT,8) IGHBCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(IGHBCB.LT.0) IGHBCB=-1
      IUNIT2(7)=IGHBCB
      IF(IGHBCB.GT.0) THEN
         IF(FILTYP(IGHBCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IGHBCB)=IUNIT(12)
         ELSE IF(FILTYP(IGHBCB).EQ.' ') THEN
            IUNIT2(7)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(7).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(7).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IGHBCB.NE.0) IBDSAM=IGHBCB
      ELSE
         IF(IBDSAM.NE.IGHBCB) IBDSAM=0
      END IF
C
C-------Process auxiliary parameters
      GHBAUX(1)=' '
      NAUX=0
20    CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1   LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.EQ.0) THEN
            NAUX=1
            IF(LINE(ISTART:ISTOP).EQ.'IFACE') THEN
               GHBAUX(1)='IFACE'
               WRITE(IOUT,22) GHBAUX(1)
            ELSE
               IF(INMP.EQ.0) THEN
                  NAUX=2
                  GHBAUX(NAUX)=LINE(ISTART:ISTOP)
                  WRITE(IOUT,22) GHBAUX(NAUX)
               ELSE
                  WRITE(IOUT,22) LINE(ISTART:ISTOP)
                  WRITE(IOUT,*) 'When MODPATH is used, the 1st',
     1                   ' AUXILIARY parameter must be "IFACE"'
                  CALL RDABRT
               END IF
            END IF
         ELSE IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            GHBAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,22) GHBAUX(NAUX)
22          FORMAT(1X,'AUXILIARY GHB PARAMETER: ',A)
         ELSE
            WRITE(IOUT,*) ' Too many auxiliary parameters for MFI'
            CALL RDABRT
         END IF
         GO TO 20
      ELSE IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE') THEN
         GO TO 20
      END IF
C  Allow use of MODPATH without an explicit IFACE auxiliary parameter -- turn
C  the IFACE parameter on if MODPATH is active.
      IF(INMP.NE.0) GHBAUX(1)='IFACE'
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE GHBRP(KPER,IWARN)
C     ******************************************************************
C     READ GHB HEAD, CONDUCTANCE AND BOTTOM ELEVATION
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      CHARACTER*10 CMAX
C     ------------------------------------------------------------------
      IN=IUNIT(7)
C
C1------READ ITMP (NUMBER OF BOUNDARIES OR FLAG TO REUSE DATA).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') ITMP
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ITMP
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) ' Undefined GHB data for stress period'
         RETURN
      END IF
      CALL LSTMAK('BNDS',0,KPER,8)
      ARRCON(NARRAY)=1.
      IARRDA(1,NARRAY)=-2
C
C2------TEST ITMP.
      IF(ITMP.GE.0)GO TO 50
C
C2A-----IF ITMP <0 THEN REUSE DATA FROM LAST STRESS PERIOD.
      WRITE(IOUT,7)
    7 FORMAT(1X,/1X,'REUSING BOUNDARIES FROM LAST STRESS PERIOD')
      IF(KPER.EQ.1) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED GHB DATA'
         CALL RDABRT
      END IF
      NBOUND=-1
      CALL IVLSAV('BNDS',0,KPER,NBOUND)
      RETURN
C
C3------IF ITMP=> ZERO THEN IT IS THE NUMBER OF BOUNDARIES.
   50 NBOUND=ITMP
      IF(ITMP.GT.MXLIST*10) THEN
         ITMP=MXLIST*10
         WRITE(CMAX,'(I10)') ITMP
         WRITE(IOUT,'(A)')
     1' WARNING -- Truncating boundaries -- maximum number is'//CMAX
         IWARN=IWARN+1
         IF(NMISS.LT.45) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)=
     1' WARNING -- Truncating boundaries -- maximum number is'//CMAX
         END IF
      END IF
      CALL IVLSAV('BNDS',0,KPER,ITMP)
C
C5------PRINT NUMBER OF BOUNDARIES IN THIS STRESS PERIOD.
  100 WRITE(IOUT,101)NBOUND
  101 FORMAT(1X,//1X,I5,' BOUNDARIES')
C
C6------IF THERE ARE NO BOUNDARIES THEN RETURN.
      IF(NBOUND.EQ.0) RETURN
C
C7------READ AND PRINT DATA FOR EACH GHB.
      CALL LSTRD(NBOUND,NARRAY,X(IARRDA(2,NARRAY)),IN,
     1 'BOUND NO. LAYER   ROW   COL  BOUND HEAD   CONDUCTANCE',
     2   GHBAUX,3)
C
C8------RETURN.
      RETURN
      END
      SUBROUTINE GHBED
C     ******************************************************************
C     Edit GHB data
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
      CHARACTER*8 LABEL(5,2)
      DATA LABEL/' ',    ' ',  ' ',     ' ',   ' ',
     1           'LAYER','ROW','COLUMN','HEAD','COND.'/
C     ------------------------------------------------------------------
C
C  Set IUNIT if not already set
      IF(IUNIT(7).EQ.0) THEN
         CALL FINDUN(17,IU,'GHB')
         IUNIT(7)=IU
         IUNIT2(7)=0
      END IF
C
C  Main GHB menu -- select the desired stress period -- default is 1
      KPER=1
10    CALL UPERIN('General-Head Boundary Data',KPER)
C  Return if "previous" was selected
      IF(KPER.EQ.0) THEN
         CALL GHBSV(IUNDEF,1)
         RETURN
      END IF
C
C  Set up to get GHB data for a stress period.
C  If array does not already exist, create array.
      CALL IVLGET('BNDS',0,KPER,NAR,NBOUND)
      IF(NAR.LE.0) THEN
         CALL LSTMAK('BNDS',0,KPER,8)
         IARRDA(1,NARRAY)=-2
         ARRCON(NARRAY)=1.
         NBOUND=0
         NAR=NARRAY
      END IF
C
C  Get new data
      IMETH=1
      IF(KPER.GT.1) THEN
         IF(NBOUND.LT.0) IMETH=2
         CALL QRESP(MESSFL,307,4,IMETH)
      END IF
      IF(IMETH.EQ.1) THEN
         LOC=IARRDA(2,NAR)
C  Activate CONC as an AUX field if MOC is active
         IF(IUNIT(15).GT.0) THEN
            IF(GHBAUX(2).NE.'CONC' .AND. GHBAUX(2).NE.'CONCENTRATION'
     1              .AND. GHBAUX(3).NE.'CONC' .AND.
     2             GHBAUX(3).NE.'CONCENTRATION') THEN
               IF(GHBAUX(2).EQ.' ') THEN
                  GHBAUX(2)='CONC'
               ELSE IF(GHBAUX(3).EQ.' ') THEN
                  GHBAUX(3)='CONC'
               END IF
            END IF
         END IF
         CALL SSLST(X(LOC),NBOUND,LABEL,5,NAR,GHBAUX,3)
      ELSE
         NBOUND=-1
      END IF
      CALL IVLSAV('BNDS',0,KPER,NBOUND)
C
C  Ask for another stress period
      KPER=KPER+1
      IF(KPER.GT.NPER) KPER=1
      IF(NPER.GT.1) GO TO 10
C
C  End of GHB data input
      CALL GHBSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE GHBSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR GHB PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C     ------------------------------------------------------------------
      IF(IUNIT(7).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IF(IUREAL(IUNIT(7)).EQ.0) CALL REALUN(IUNIT(7))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.GHB',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(7)),UNIT=IFIL)
C  Find undefined data and maximum number of boundaries in all periods
      CALL LSTMAX('BNDS',IWRFLG,IUNDEF,MXBND,'GHB')
      IF(IWRFLG.LE.0) RETURN
C
C  Write the data
      IGHBCB=IBUDUN
      IF(IBUDUN.EQ.0) IGHBCB=IUNIT2(7)
      ITMPUN=IGHBCB
      IF(ITMPUN.GT.0) THEN
         IF(IUREAL(ITMPUN).EQ.0) CALL REALUN(ITMPUN)
         ITMPUN=IUREAL(ITMPUN)
      END IF
      CALL LSTSAV('BNDS',IFIL,MXBND,ITMPUN,GHBAUX,3,'    MXBND IGHBCB')
C
      CLOSE(UNIT=IFIL)
      RETURN
      END
