      SUBROUTINE MPNAM(INUNIT)
C     ******************************************************************
C     OPEN MODPATH FILES.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      PARAMETER (NSPEC=12)
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15),NCON(200)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      COMMON /MOCCOM/IUMOCL,IUMOC,IUCRC,IUCOBS,NSCOL,NSROW,NSLAY,
     1     ISLAY1,ISLAY2,ISROW1,ISROW2,ISCOL1,ISCOL2,
     2     NODISP,NPTPND,ICINFL,
     3     PNEWL(51),PNEWR(51),PNEWC(51),IZONE(MXCZON),ZONCON(MXCZON),
     4     ICOB(3,MXCOB),ICOBFL(MXCOB)
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      WRITE(IOUT,1)
    1 FORMAT(1X,/1X,70('*'),/1X,'Reading MODPATH name file')
C
C  Move virtual units 1-79 so they won't interfere with any MODPATH files.
C  ISTCB2 in the STR Package is a special case that must get adjusted much
C  like other budget units
      CALL IVLGET('ISTCB2',0,0,ITYPE,ISTCB2)
      IF(ITYPE.NE.0) ISTCB2=0
      CALL IVLGET('IOBSFL',0,0,ITYPE,IOBSFL)
      IF(ITYPE.NE.0) IOBSFL=0
      DO 8 I=1,79
      IF(FILNAM(I).NE.' ') THEN
C  Move unit I
         J1=I+100
         DO 6 J=J1,MXFNAM
         IF(FILNAM(J).EQ.' ') THEN
C  Move unit I to unit J
            FILNAM(J)=FILNAM(I)
            FILNAM(I)=' '
            FILTYP(J)=FILTYP(I)
            FILTYP(I)=' '
            IFNUSE(J)=IFNUSE(I)
            IFNUSE(I)=0
            DO 2 K=1,39
            IF(IUNIT(K).EQ.I) IUNIT(K)=J
            IF(IUNIT2(K).EQ.I) IUNIT2(K)=J
2           CONTINUE
            DO 4 N=1,NARRAY
            IF(IARRDA(1,N).EQ.I) IARRDA(1,N)=J
4           CONTINUE
            IF(IBUDUN.EQ.I) IBUDUN=J
            IF(IHEDUN.EQ.I) IHEDUN=J
            IF(IDDNUN.EQ.I) IDDNUN=J
            IF(INBAS.EQ.I) INBAS=J
            IF(ILOUT.EQ.I) ILOUT=J
            IF(IUMOCL.EQ.I) IUMOCL=J
            IF(IUMOC.EQ.I) IUMOC=J
            IF(IUCRC.EQ.I) IUCRC=J
            IF(IUCOBS.EQ.I) IUCOBS=J
            IF(IOBSFL.EQ.I) THEN
               IOBSFL=J
               CALL IVLSAV('IOBSFL',0,0,IOBSFL)
            END IF
            DO 5 N=1,MXCOB
            IF(ICOBFL(N).EQ.I) ICOBFL(N)=J
5           CONTINUE
            IF(ISTCB2.EQ.I) THEN
               ISTCB2=J
               CALL IVLSAV('ISTCB2',0,0,ISTCB2)
            END IF
            GO TO 8
         END IF
6        CONTINUE
C  No virtual units available to move to
         WRITE(IOUT,*)
     1        ' Not enough file units to allow MODPATH data to be read'
         CALL RDABRT
      END IF
8     CONTINUE
C
C  Finally, adjust the values of IFNUSE to reflect the new IUNIT values.
      IFNUSE(ILOUT)=ILOUT
      IFNOLD=IFNUSE(INBAS)
      DO 9 J=80,MXFNAM
      IF(IFNUSE(J).EQ.IFNOLD) IFNUSE(J)=INBAS
9     CONTINUE
C
      DO 12 I=1,39
      IF(IUNIT(I).NE.0) THEN
         IFNOLD=IFNUSE(IUNIT(I))
         DO 10 J=80,MXFNAM
         IF(IFNUSE(J).EQ.IFNOLD) IFNUSE(J)=IUNIT(I)
10       CONTINUE
      END IF
12    CONTINUE
C
      IF(IUMOC.GT.0) THEN
         IFNOLD=IFNUSE(IUMOC)
         DO 13 J=80,MXFNAM
         IF(IFNUSE(J).EQ.IFNOLD) IFNUSE(J)=IUMOC
13       CONTINUE
      END IF
C
C  Switch over to MODPATH file units
      CALL MPIUMK
C
C1------Initialize MPNAME
      DO 15 I=1,NSPEC
      MPNAME(I)=' '
15    CONTINUE
C
C2------READ A LINE; IGNORE BLANK LINES.
18    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 18
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
      IF(IU.LE.0 .OR. IU.GT.79) THEN
         WRITE(IOUT,*) ' File unit out of range (must be 1-79):',IU
         CALL RDABRT
      END IF
C
C4------DECODE THE FILE NAME
      IF(IUCASE.EQ.0) THEN
         CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUT,INUNIT)
      ELSE
         CALL URWORD(LINE,LLOC,INAM1,INAM2,1,N,R,IOUT,INUNIT)
      END IF
C
C5------CHECK FOR A VALID FILE TYPE.
C5A-----CHECK FOR SPECIAL FILE TYPES.
      DO 20 I=1,NSPEC
         IF(LINE(ITYP1:ITYP2).EQ.MPTYPE(I)) THEN
            IF(MPNAME(I).NE.' ') THEN
               WRITE(IOUT,*) ' Duplicate MODPATH file type:',
     1               LINE(ITYP1:ITYP2)
               CALL RDABRT
            END IF
            MPNAME(I)=LINE(INAM1:INAM2)
            WRITE(IOUT,19) MPTYPE(I),MPNAME(I)
19          FORMAT(1X,/1X,' MODPATH file type -- ',A,/1X,A)
            GO TO 18
         END IF
20    CONTINUE
C
C5B-----CHECK FOR FILE-TYPE "MAIN".
      IF(LINE(ITYP1:ITYP2).EQ.'MAIN') THEN
         IUNIT(40)=IU
         IFNUSE(IU)=IU
         CALL REALUN(IU)
         FILTYP(IU)='MP'
C
C5C-----CHECK FOR "DATA" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA') THEN
         IFNUSE(IU)=-1
         FILTYP(IU)='DATA'
         WRITE(IOUT,21) FILTYP(IU),LINE(INAM1:INAM2)
21       FORMAT(1X,/1X,' MODPATH file type -- ',A,/1X,A)
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA(BINARY)') THEN
         IFNUSE(IU)=-1
         FILTYP(IU)='DATA(BINARY)'
         WRITE(IOUT,21) FILTYP(IU),LINE(INAM1:INAM2)
C
C5D-----CHECK FOR "GUA" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'GUA') THEN
         IGUAUN=IU
         CALL REALUN(IU)
         FILTYP(IU)='GUA'
C
C5E-----Unknown file type -- ignore
      ELSE
         WRITE(IOUT,*) ' Ignored file type:',LINE(ITYP1:ITYP2)
         GO TO 18
      END IF
C
C6------PUT FILE NAME INTO TABLE OF FILE NAMES UNLESS IT IS A DUPLICATE
C6------UNIT OR NAME
      IF(FILNAM(IU).NE.' ') THEN
         WRITE(IOUT,*) ' ATTEMPT TO OPEN A FILE ON A PREVIOUSLY',
     1        ' DEFINED UNIT'
         WRITE(IOUT,*) ' THE CONFLICT IS ON UNIT',IU
         CALL RDABRT
      END IF
      DO 40 I=1,79
      IF(FILNAM(I).EQ.LINE(INAM1:INAM2)) THEN
         WRITE(IOUT,*) ' Duplicate file name:'
         WRITE(IOUT,*) FILNAM(I)
         CALL RDABRT
      END IF
40    CONTINUE
      FILNAM(IU)=LINE(INAM1:INAM2)
      GO TO 18
C
C7------END OF NAME FILE.
1000  IF(IUNIT(40).LE.0) THEN
         WRITE(IOUT,*) ' No MAIN MODPATH file in name file.'
         CALL RDABRT
      ELSE
         WRITE(IOUT,36) IUNIT(40),FILNAM(IUNIT(40))
36       FORMAT(1X,/1X,'OPENING MAIN MODPATH FILE ON UNIT',I4,':',/1X,A)
         OPEN(UNIT=IUREAL(IUNIT(40)),FILE=FILNAM(IUNIT(40)),
     1      FORM='FORMATTED',ACCESS='SEQUENTIAL')
      END IF
      IF(IGUAUN.GT.0) THEN
         IFNUSE(IGUAUN)=IUNIT(40)
         WRITE(IOUT,37) IGUAUN,FILNAM(IGUAUN)
37       FORMAT(1X,/1X,'OPENING MODPATH GUA FILE ON UNIT',I4,':',/1X,A)
         OPEN(UNIT=IUREAL(IGUAUN),FILE=FILNAM(IGUAUN),
     1      FORM='FORMATTED',ACCESS='SEQUENTIAL')
      END IF

      CLOSE(UNIT=INUNIT)
      RETURN
C
      END
      SUBROUTINE MPRP(IWARN)
C     ******************************************************************
C     READ MODPATH DATA
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /FLWCOM/LAYCON(200)
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C  Numeric common block for MODPATH
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15),NCON(200)
C  Character common block for MODPATH
      PARAMETER (NSPEC=12)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      CHARACTER*101 LINE
      DIMENSION DELZ(200),DELZCB(200)
      CHARACTER*5 CLAY
      CHARACTER*24 ANAME(10)
      DATA ANAME(1) /'                    DELR'/
      DATA ANAME(2) /'                    DELC'/
      DATA ANAME(3) /'               IBOUND-MP'/
      DATA ANAME(4) /'                     POR'/
      DATA ANAME(5) /'                   PORCB'/
      DATA ANAME(6) /'                     TOP'/
      DATA ANAME(7) /'                     BOT'/
      DATA ANAME(8) /'                    DELZ'/
      DATA ANAME(9) /'                  DELZCB'/
      DATA ANAME(10)/'         GRID UNIT ARRAY'/
C     ------------------------------------------------------------------
      INMP=IUNIT(40)
C
C1------PRINT A MESSAGE IDENTIFYING THE PACKAGE.
      WRITE(IOUT,1)INMP
    1 FORMAT(1X,/1X,'MODPATH MAIN DATA FILE,',
     2' INPUT READ FROM UNIT',I3,///)
C
C2------READ NUMBER OF LAYERS,ROWS,COLUMNS,STRESS PERIODS AND
C2------UNITS OF TIME CODE.
      READ(IUREAL(INMP),'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NC,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NR,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NL,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NCBL,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IGRID,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NP,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MAXSIZ,R,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,HNO,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,HD,IOUT,INMP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPART,R,IOUT,INMP)
C
C3------CHECK # OF LAYERS, ROWS, COLUMNS AND STRESS PERIODS.
      IF(NLAY.NE.NL) THEN
         WRITE(IOUT,*)
     1    'NUMBER OF LAYERS IS DIFFERENT THAN FOR MODFLOW:',NL
         CALL RDABRT
      END IF
      IF(NROW.NE.NR) THEN
         WRITE(IOUT,*)
     1    'NUMBER OF ROWS IS DIFFERENT THAN FOR MODFLOW:',NR
         CALL RDABRT
      END IF
      IF(NCOL.NE.NC) THEN
         WRITE(IOUT,*)
     1    'NUMBER OF COLUMNS IS DIFFERENT THAN FOR MODFLOW:',NC
         CALL RDABRT
      END IF
      IF(ISS.NE.0 .AND. NP.NE.0) THEN
         WRITE(IOUT,*)
     1    'MODFLOW IS STEADY STATE AND MODPATH IS TRANSIENT'
         WRITE(IOUT,*)
     1    'NPER IN MODPATH IS ',NP
         CALL RDABRT
      ELSE IF(ISS.EQ.0 .AND. NP.NE.NPER) THEN
         WRITE(IOUT,*)
     1    'NUMBER OF STRESS PERIODS IS DIFFERENT THAN FOR MODFLOW:',NP
         CALL RDABRT
      END IF
      IF(NCBL.GE.NLAY) THEN
         WRITE(IOUT,*)
     1    'NCBL is greater than or equal to NLAY:',NCBL
         CALL RDABRT
      END IF
C
C4------READ OPTIONS RECORD AND LOOK FOR OPTIONS
100   READ(IUREAL(INMP),'(A)') LINE
      MPXSEC=0
      MPCOMP=0
      MPBIN=0
      MPMETR=0
      MPWTOF=0
      MPWTDO=0
      MPWTDA=0
      LLOC=1
101   CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INBAS)
      IF(LINE(ISTART:ISTOP).EQ.'XSECTION' .AND. NROW.EQ.1) THEN
         WRITE(IOUT,*) 'CROSS SECTION OPTION IS SPECIFIED'
         MPXSEC=1
      ELSE IF(LINE(ISTART:ISTOP).EQ.'COMPACT') THEN
         MPCOMP=1
         WRITE(IOUT,*)
     1    'COMPACT OPTION FOR WRITING CELL LOCATIONS IS SPECIFIED'
      ELSE IF(LINE(ISTART:ISTOP).EQ.'BINARY') THEN
         MPBIN=1
         MPCOMP=0
         WRITE(IOUT,*)
     1  'BINARY OPTION FOR WRITING CELL LOCATIONS IS SPECIFIED'
      ELSE IF(LINE(ISTART:ISTOP).EQ.'METERS') THEN
         MPMETR=1
         WRITE(IOUT,*)
     1  'METERS OPTION IS SPECIFIED'
      ELSE IF(LINE(ISTART:ISTOP).EQ.'WT(OFF)') THEN
         MPWTOF=1
         WRITE(IOUT,*)
     1    'OPTION FOR DRAWING WATER TABLE IS OFF'
      ELSE IF(LINE(ISTART:ISTOP).EQ.'WT(DOTTED)') THEN
         MPWTDO=1
         MPWTOF=0
         WRITE(IOUT,*)
     1    'OPTION FOR DRAWING WATER TABLE AS A DOTTED LINE IS ON'
      ELSE IF(LINE(ISTART:ISTOP).EQ.'WT(DASHED)') THEN
         MPWTDA=1
         MPWTDO=0
         MPWTOF=0
         WRITE(IOUT,*)
     1    'OPTION FOR DRAWING WATER TABLE AS A DASHED LINE IS ON'
      END IF
      IF(LLOC.LT.101) GO TO 101
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.EQ.0) IXSEC=0
      IF(IXSEC.NE.MPXSEC) THEN
         IF(IXSEC.EQ.0) THEN
            WRITE(IOUT,*)
     1' MODPATH THINKS THIS IS A CROSS SECTION, BUT MODFLOW DOES NOT'
         ELSE
            WRITE(IOUT,*)
     1' MODFLOW THINKS THIS IS A CROSS SECTION, BUT MODPATH DOES NOT'
         END IF
         CALL RDABRT
      END IF
C
C5------Save values
      IF(MAXSIZ.LT.0) MAXSIZ=0
      CALL IVLSAV('MAXSIZ',0,0,MAXSIZ)
      IF(NPART.LT.0) NPART=0
      CALL IVLSAV('NPART',0,0,NPART)
      IF(NCBL.LT.0) NCBL=0
      CALL IVLSAV('MPCOMP',0,0,MPCOMP)
      CALL IVLSAV('MPBIN',0,0,MPBIN)
      CALL IVLSAV('MPMETR',0,0,MPMETR)
      CALL IVLSAV('MPWTOF',0,0,MPWTOF)
      CALL IVLSAV('MPWTDO',0,0,MPWTDO)
      CALL IVLSAV('MPWTDA',0,0,MPWTDA)
C
C6------READ AND IGNORE LAYCON
      READ(IUREAL(INMP),*) (IDUM,I=1,NLAY)
C
C7------Read confining bed codes
      IF(NCBL.GT.0) THEN
         READ(IUREAL(INMP),*) (NCON(I),I=1,NLAY)
         DO 140 I=1,NLAY
         IF(NCON(I).NE.0) NCON(I)=1
140      CONTINUE
         NCON(NLAY)=0
         WRITE(IOUT,*) 'Confining bed codes:'
         WRITE(IOUT,'(40I2)') (NCON(I),I=1,NLAY)
      ELSE
         DO 150 I=1,NLAY
         NCON(I)=0
150      CONTINUE
         WRITE(IOUT,*) ' No confining beds'
      END IF
C
C8------Read and ignore DELR and DELC
      CALL U2DRDM(ANAME(1),1,NCOL,0,INMP)
      CALL U2DRDM(ANAME(2),1,NROW,0,INMP)
C
C9------Define elevations of layers
      IF(IGRID.EQ.0) THEN
C  Startigraphic 3-D
         DO 160 K=1,NLAY
         KK=K
         IF(K.NE.1 .OR. LAYCON(1).NE.1) THEN
C  We need a TOP, but it may be available via an existing MODFLOW or
C  MODPATH array.
            IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) THEN
C  TOP comes from top of current layer of MODFLOW.
                  CALL U2DRDM(ANAME(6),NROW,NCOL,KK,INMP)
            ELSE IF(K.EQ.1) THEN
C  TOP is needed for layer 1, but it is not available from MODFLOW because
C  LAYCON is not 2 or 3.   Also, there is no chance to get it from the BOT
C  of the layer above, so must read it.
               CALL ARRMAK('TOP',KK,0,NCOL,NROW)
               CALL U2DREL(ANAME(6),NROW,NCOL,KK,INMP,NARRAY,INMP)
            ELSE
C  TOP is needed, but it is unavailable from current layer of MODFLOW.
C  See if it's available from BOT of layer above -- MODFLOW or MODPATH
               IF(NCON(K-1).EQ.0) THEN
C  No confining unit, so BOT can come from layer above -- it might be
C  from MDFLOW or MODPATH, but it doesn't matter which at these point.
                  CALL U2DRDM(ANAME(6),NROW,NCOL,KK,INMP)
               ELSE
C  Confining unit exists, so cannot get TOP from BOT in layer above.  Read
C  TOP
                  CALL ARRMAK('TOP',KK,0,NCOL,NROW)
                  CALL U2DREL(ANAME(6),NROW,NCOL,KK,INMP,NARRAY,INMP)
               END IF
            END IF
C  Top layer, and LAYCON is 1, so TOP is not needed and it is not in the
C  MODPATH file -- i.e. do nothing
         END IF
C  Read bottoms
         IF(LAYCON(K).EQ.0 .OR. LAYCON(K).EQ.2) THEN
            CALL ARRMAK('BOT',KK,0,NCOL,NROW)
            CALL U2DREL(ANAME(7),NROW,NCOL,KK,INMP,NARRAY,INMP)
         ELSE
C  BOT comes from MODFLOW
            CALL U2DRDM(ANAME(7),NROW,NCOL,KK,INMP)
         END IF
160      CONTINUE
      ELSE
C
C  Flat layers
         CALL ARRMAK('DELZ',0,0,NLAY,1)
         CALL U1DREL(ANAME(8),NLAY,INMP,NARRAY)
         IF(IARRDA(1,NARRAY).GT.0) THEN
            WRITE(IOUT,*)
     1     ' DELZ must be entirely contained in the MAIN data file'
            CALL RDABRT
         END IF
         CALL ARRMV(NARRAY,DELZ,NLAY)
         CALL ARRMAK('DELZCB',0,0,NLAY,1)
         CALL U1DREL(ANAME(9),NLAY,INMP,NARRAY)
         IF(IARRDA(1,NARRAY).GT.0) THEN
            WRITE(IOUT,*)
     1     ' DELZCB must be entirely contained in the MAIN data file'
            CALL RDABRT
         END IF
         CALL ARRMV(NARRAY,DELZCB,NLAY)
         READ(IUREAL(INMP),*) ZBL1
         WRITE(IOUT,*) ' Elevation of bottom of layer 1:',ZBL1
         DO 170 K=1,NLAY
         KK=K
         IF(K.EQ.1) THEN
            BT=ZBL1
            TP=ZBL1+DELZ(1)
         ELSE
            TP=BT
            IF(NCON(K-1).NE.0) TP=TP-DELZCB(K-1)
            BT=TP-DELZ(K)
         END IF
         IF(K.NE.1 .OR. LAYCON(1).NE.1) THEN
C  We need a TOP, but it may be available via an existing MODFLOW or
C  MODPATH array.
            IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) THEN
C  TOP comes from top of current layer of MODFLOW.
            ELSE IF(K.EQ.1) THEN
C  TOP is needed for layer 1, but it is not available from MODFLOW because
C  LAYCON is not 2 or 3.   Also, there is no chance to get it from the BOT
C  of the layer above, so must read it.
               CALL ARRMAK('TOP',KK,0,NCOL,NROW)
               ARRCON(NARRAY)=TP
            ELSE
C  TOP is needed, but it is unavailable from current layer of MODFLOW.
C  See if it's available from BOT of layer above -- MODFLOW or MODPATH
               IF(NCON(K-1).EQ.0) THEN
C  No confining unit, so BOT can come from layer above -- it might be
C  from MDFLOW or MODPATH, but it doesn't matter which at these point.
               ELSE
C  Confining unit exists, so cannot get TOP from BOT in layer above.  Read
C  TOP
                  CALL ARRMAK('TOP',KK,0,NCOL,NROW)
                  ARRCON(NARRAY)=TP
               END IF
            END IF
C  Top layer, and LAYCON is 1, so TOP is not needed and it is not in the
C  MODPATH file -- i.e. do nothing
         END IF
C  Define bottoms
         IF(LAYCON(K).EQ.0 .OR. LAYCON(K).EQ.2) THEN
            CALL ARRMAK('BOT',KK,0,NCOL,NROW)
            ARRCON(NARRAY)=BT
         END IF
170      CONTINUE
         
      END IF
C
C10-----READ BOUNDARY ARRAY(IBOUND-MP) ONE LAYER AT A TIME.
      IF(MPXSEC.EQ.0) THEN
         DO 200 K=1,NLAY
         KK=K
         CALL ARRMAK('IBNDMP',KK,0,NCOL,NROW)
         CALL U2DINT(ANAME(3),NROW,NCOL,KK,INMP,NARRAY,INMP)
         CALL IBNDCK(KK,IERR)
         IF(IERR.NE.0) THEN
            WRITE(CLAY,'(I5)') K
            WRITE(IOUT,'(A,A,A)')
     1       ' WARNING -- IBOUND for MODFLOW and MODPATH ',
     2       'are inconsistent in layer',CLAY
            IWARN=IWARN+1
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               CTEXT(NMISS)=' WARNING -- IBOUND for MODFLOW and '//
     1           'MODPATH are inconsistent in layer'//CLAY
            END IF
         END IF
  200    CONTINUE
      ELSE
         CALL ARRMAK('IBNDMP',0,0,NCOL,NLAY)
         CALL U2DINT(ANAME(3),NLAY,NCOL,-1,INMP,NARRAY,INMP)
C         CALL IBNDCK
      END IF
C
C11-----READ POROSITY AND CONFINING BED POROSITY ONE LAYER AT A TIME
      DO 300 K=1,NLAY
      KK=K
      CALL ARRMAK('POR',KK,0,NCOL,NROW)
      CALL U2DREL(ANAME(4),NROW,NCOL,KK,INMP,NARRAY,INMP)
      IF(NCON(K).NE.0) THEN
         CALL ARRMAK('PORCB',KK,0,NCOL,NROW)
         CALL U2DREL(ANAME(5),NROW,NCOL,KK,INMP,NARRAY,INMP)
      END IF
300   CONTINUE
C
C12-----Read stress period data if transient
      IF(ISS.EQ.0) THEN
         READ(IUREAL(INMP),*) TBEGIN
         WRITE(IOUT,*) 'Time at beginning of MODFLOW simulation:',TBEGIN
         CALL VALSAV('TBEGIN',0,0,TBEGIN)
C  Read stress period data and ignore
         DO 340 K=1,NPER
         READ(IUREAL(INMP),*)
340      CONTINUE
C  Read interval for storage of budget data
         READ(IUREAL(INMP),*) IBEGP,IBEGS,IENDP,IENDS
         CALL IVLSAV('IBEGP',0,0,IBEGP)
         CALL IVLSAV('IBEGS',0,0,IBEGS)
         CALL IVLSAV('IENDP',0,0,IENDP)
         CALL IVLSAV('IENDS',0,0,IENDS)
         ITFULL=0
         IF(IBEGP.EQ.1 .AND. IBEGS.EQ.1 .AND. IENDP.EQ.NPER .AND.
     1          IENDS.EQ.NSTP(NPER)) ITFULL=1
      ELSE
C  Set time interval to full when steady state
         ITFULL=1
      END IF
      CALL IVLSAV('ITFULL',0,0,ITFULL)
C
C  Read GUA file if used.
      IF(IGUAUN.GT.0) THEN
         READ(IUREAL(IGUAUN),'(A)') LINE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,I,R,IOUT,IGUAUN)
         IF(LINE(ISTART:ISTOP).EQ.'ZONES') THEN
            IGUAM=2
         ELSE IF(LINE(ISTART:ISTOP).EQ.'RANGES') THEN
            IGUAM=3
         ELSE
            WRITE(IOUT,*) ' Error in first line of GUA file'
            CALL RDABRT
         END IF
C  Read legend title
         READ(IUREAL(IGUAUN),'(A)') CLTITL
C  Read GUA array for each layer or for cross section
         IF(MPXSEC.EQ.0) THEN
            DO 345 K=1,NLAY
            KK=K
            IF(IGUAM.EQ.2) THEN
               CALL ARRMAK('IGUA',KK,0,NCOL,NROW)
               CALL U2DINT(ANAME(10),NROW,NCOL,KK,IGUAUN,NARRAY,INMP)
            ELSE
               CALL ARRMAK('RGUA',KK,0,NCOL,NROW)
               CALL U2DREL(ANAME(10),NROW,NCOL,KK,IGUAUN,NARRAY,INMP)
            END IF
  345       CONTINUE
         ELSE
            IF(IGUAM.EQ.2) THEN
               CALL ARRMAK('IGUA',0,0,NCOL,NLAY)
               CALL U2DINT(ANAME(10),NLAY,NCOL,-1,IGUAUN,NARRAY,INMP)
            ELSE
               CALL ARRMAK('RGUA',0,0,NCOL,NLAY)
               CALL U2DREL(ANAME(10),NLAY,NCOL,-1,IGUAUN,NARRAY,INMP)
            END IF
         END IF
C  Read ranges or legend text.
         IF(IGUAM.EQ.3) THEN
346         READ(IUREAL(IGUAUN),'(A)',END=347) LINE
            LLOC=1
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,N,R,IOUT,IGUAUN)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,RMIN,-1,IGUAUN)
            IF(LINE(ISTART:ISTOP) .EQ. '<') RMIN=-1.E30
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,RMAX,-1,IGUAUN)
            IF(LINE(ISTART:ISTOP) .EQ. '>') RMAX=1.E30
            IF(N.GT.0 .AND. N.LT.16) THEN
               GUAMIN(N)=RMIN
               GUAMAX(N)=RMAX
            ELSE
               WRITE(IOUT,'(A)')
     1         ' WARNING -- GUnumber outside the range 1-15 was ignored'
               IWARN=IWARN+1
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  CTEXT(NMISS)=
     1         ' WARNING -- GUnumber outside the range 1-15 was ignored'
               END IF
            END IF
            GO TO 346
347         CONTINUE
         ELSE
  348       READ(IUREAL(IGUAUN),'(A)',END=349) LINE
            LLOC=1
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,I,R,IOUT,IGUAUN)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,IGUAUN)
            IF(I.GT.0 .AND. I.LT.16 .AND. ISTART.LE.100) THEN
               ISTOP=ISTART+29
               IF(ISTOP.GT.100) ISTOP=100
               CLEGND(I)=LINE(ISTART:ISTOP)
            END IF
            GO TO 348
  349       CONTINUE
         END IF
      END IF
C
C13-----Close MODPATH main data & GUA files and eliminate any files that
C13-----were not used for input.  These would generally be "DATA" files
C13-----that MODFLOW provides, so MODPATH ignores them.  Also, if a file
C13-----is used by MODPATH, make sure MODFLOW is not using it also.
      CLOSE(UNIT=IUREAL(IUNIT(40)))
      IF(IGUAUN.GT.0) CLOSE(UNIT=IUREAL(IGUAUN))
      DO 350 I=1,79
      IF(IFNUSE(I).EQ.-1) THEN
         IFNUSE(I)=0
         FILNAM(I)=' '
         FILTYP(I)=' '
      ELSE IF(IFNUSE(I).GT.0) THEN
         DO 330 J=80,MXFNAM
         IF(FILNAM(J).EQ.FILNAM(I)) THEN
            WRITE(IOUT,*) ' MODPATH file conflicts with MODFLOW file:'
            WRITE(IOUT,*) FILNAM(I)
            CALL RDABRT
         END IF
330      CONTINUE
      END IF
350   CONTINUE
C
C  Finally, make sure TOPs and BOTs are not in shared files
         NSAVE=NMISS
         CALL CKTPBT()
         IF(NMISS.GT.NSAVE) THEN
            WRITE(IOUT,*) ' The following TOP and BOT arrays are not in'
            WRITE(IOUT,*) ' separate files.  The preprocessor requires'
            WRITE(IOUT,*) ' these arrays to be in separate files.'
            DO 360 I=NSAVE+1,NMISS
            WRITE(IOUT,'(A)') CTEXT(I)
360         CONTINUE
            CALL RDABRT
         END IF
C
C14-----RETURN
      RETURN
      END
      SUBROUTINE ARRMV(NAR,Z,N)
C  *********************************************************************
C  Move an mfi array to a regular array
C  *********************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION Z(N)
C
      IF(IARRDA(1,NAR).EQ.0 .OR. IARRDA(2,NAR).EQ.0) THEN
         DO 10 I=1,N
         Z(I)=ARRCON(NAR)
10       CONTINUE
      ELSE
         LOC=IARRDA(2,NAR)-1
         DO 20 I=1,N
         Z(I)=ARRCON(NAR)*X(I+LOC)
20       CONTINUE
      END IF
      RETURN
      END
      SUBROUTINE MPED
C  *********************************************************************
C  Edit MODPATH data
C  *********************************************************************
      INCLUDE 'mfi.gbl'
      PARAMETER (NSPEC=12)
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15),NCON(200)
      COMMON /FLWCOM/LAYCON(200)
      DIMENSION IDUM(200)
      CHARACTER*80 CBUF
      DIMENSION IOPVAL(4),MXSEL(2),MNSEL(2)
      CHARACTER*6 CMENU(5,8)
      DATA CMENU/'IBNDMP','POR   ','      ','      ','      ',
     1           'IBNDMP','POR   ','TOP   ','      ','      ',
     1           'IBNDMP','POR   ','BOT   ','      ','      ',
     1           'IBNDMP','POR   ','TOP   ','BOT   ','      ',
     1           'IBNDMP','POR   ','PORCB ','      ','      ',
     1           'IBNDMP','POR   ','TOP   ','PORCB ','      ',
     1           'IBNDMP','POR   ','BOT   ','PORCB ','      ',
     1           'IBNDMP','POR   ','TOP   ','BOT   ','PORCB '/
C  Switch to MODPATH's file units
      CALL MPIUMK
C
C  Activate MODPATH if not active already.
      IF(IUNIT(40).EQ.0) THEN
C  First make sure TOPs and BOTs are not in shared files.
         NMISS=0
         CALL CKTPBT()
         IF(NMISS.GT.0) THEN
            CALL DSPTXT(MESSFL,308,20,CTEXT,NMISS,78)
            CALL MFIUMK
            RETURN
         END IF
C  Ready to activate MODPATH
         CALL FINDUN(70,IU,'MP')
         IUNIT(40)=IU
         CALL IVLSAV('IFARCH',0,0,1)
         CALL IVLSAV('IFAEVT',0,0,1)
         DO 5 K=1,NLAY
         NCON(K)=0
5        CONTINUE
C  Initialize MPNAME
         DO 6 I=1,NSPEC
         MPNAME(I)=' '
6        CONTINUE
C  Copy IBOUND to IBNDMB if possible
         CALL IBNDCP
      END IF
      MODSAV=MODOUT
      MODOUT=1
C
C  Main MODPATH menu
      IOPT=1
10    CALL QRESP(MESSFL,308,1,IOPT)
C
15    IF(IOPT.EQ.1) THEN
C  MISCELLANEOUS -- Initialize the screen
         CALL IVLGET('MAXSIZ',0,0,ITYPE,MAXSIZ)
         IF(ITYPE.NE.0) MAXSIZ=0
         CALL IVLGET('NPART',0,0,ITYPE,NPART)
         IF(ITYPE.NE.0) NPART=0
         CALL IVLGET('MPCOMP',0,0,ITYPE,MPCOMP)
         IF(ITYPE.NE.0) MPCOMP=0
         CALL IVLGET('MPBIN',0,0,ITYPE,MPBIN)
         IF(ITYPE.NE.0) MPBIN=0
         CALL IVLGET('MPMETR',0,0,ITYPE,MPMETR)
         IF(ITYPE.NE.0) MPMETR=0
         CALL IVLGET('MPWTOF',0,0,ITYPE,MPWTOF)
         IF(ITYPE.NE.0) MPWTOF=0
         CALL IVLGET('MPWTDO',0,0,ITYPE,MPWTDO)
         IF(ITYPE.NE.0) MPWTDO=0
         CALL IVLGET('MPWTDA',0,0,ITYPE,MPWTDA)
         IF(ITYPE.NE.0) MPWTDA=0
         IOPVAL(1)=0
         IOPVAL(2)=0
         IOPVAL(3)=0
         MXSELT=3
         MXSEL(1)=3
         MNSEL(1)=0
         NSET=1
         NSEL=0
         IF(MPCOMP.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=1
         END IF
         IF(MPBIN.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=2
         END IF
         IF(MPMETR.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=3
         END IF
         IF(MPWTOF.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=4
         END IF
         IF(MPWTDO.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=5
         END IF
         IF(MPWTDA.NE.0) THEN
            NSEL=NSEL+1
            IOPVAL(NSEL)=6
         END IF
         IF(ISS.NE.0) THEN
            CALL Q1INIT(MESSFL,308,6)
            CALL QSETIB(1,1,NPART)
            CALL QSETIB(1,2,MAXSIZ)
         ELSE
            CALL Q1INIT(MESSFL,308,7)
            CALL VALGET('TBEGIN',0,0,ITYPE,TBEGIN)
            IF(ITYPE.NE.0) TBEGIN=0.
            CALL QSETR(1,TBEGIN)
            CALL IVLGET('ITFULL',0,0,ITYPE,ITFULL)
            IF(ITYPE.NE.0) ITFULL=1
            CALL IVLGET('IBEGP',0,0,ITYPE,IBEGP)
            IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IBEGP=1
            CALL QSETIB(1,1,IBEGP)
            CALL IVLGET('IBEGS',0,0,ITYPE,IBEGS)
            IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IBEGS=1
            CALL IVLGET('IENDP',0,0,ITYPE,IENDP)
            IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IENDP=NPER
            CALL IVLGET('IENDS',0,0,ITYPE,IENDS)
            IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IENDS=NSTP(NPER)
            IF(IENDP.GT.NPER) IENDP=NPER
            IF(IENDS.GT.NSTP(IENDP)) IENDS=NSTP(IENDP)
            IF(IBEGS.GT.NSTP(IBEGP)) IBEGS=NSTP(IBEGP)
            CALL QSETIB(1,2,IBEGS)
            CALL QSETIB(1,3,IENDP)
            CALL QSETIB(1,4,IENDS)
            CALL QSETIB(1,5,NPART)
            CALL QSETIB(1,6,MAXSIZ)
            NSET=2
            MXSEL(2)=1
            MNSEL(2)=1
            CALL IVLGET('ITFULL',0,0,ITYPE,ITFULL)
            IF(ITYPE.NE.0) ITFULL=1
            IOPVAL(4)=1
            IF(ITFULL.EQ.0) IOPVAL(4)=2
            MXSELT=4
         END IF
         CALL QSETOP(NSET,MXSELT,MXSEL,MNSEL,IOPVAL)
C  Activate the screen
         CALL Q1EDIT(IRET)
         IF(IRET.EQ.-1) GO TO 15
C  Retrieve edited values
         IF(ISS.NE.0) THEN
            CALL QGETIB(1,1,NPART)
            CALL QGETIB(1,2,MAXSIZ)
            CALL QGETOP(3,IOPVAL)
         ELSE
            CALL QGETOP(4,IOPVAL)
            CALL QGETR(1,TBEGIN)
            CALL VALSAV('TBEGIN',0,0,TBEGIN)
            IF(IOPVAL(4).EQ.1) THEN
               ITFULL=1
               IBEGP=1
               IBEGS=1
               IENDP=NPER
               IENDS=NSTP(NPER)
            ELSE
               CALL QGETIB(1,1,IBEGP)
               CALL QGETIB(1,2,IBEGS)
               CALL QGETIB(1,3,IENDP)
               CALL QGETIB(1,4,IENDS)
               IF(IBEGP.GT.NPER .OR. IENDP.GT.NPER .OR. IBEGP.GT.IENDP)
     1                   THEN
                  CALL PRNTXT(MESSFL,308,22)
                  GO TO 15
               END IF
               IF(IBEGP.EQ.IENDP .AND. IBEGS.GT.IENDS) THEN
                  CALL PRNTXT(MESSFL,308,22)
                  GO TO 15
               END IF
               IF(IBEGS.GT.NSTP(IBEGP) .OR. IENDS.GT.NSTP(IENDP)) THEN
                  CALL PRNTXT(MESSFL,308,22)
                  GO TO 15
               END IF
               ITFULL=0
            END IF
            CALL IVLSAV('ITFULL',0,0,ITFULL)
            CALL IVLSAV('IBEGP',0,0,IBEGP)
            CALL IVLSAV('IBEGS',0,0,IBEGS)
            CALL IVLSAV('IENDP',0,0,IENDP)
            CALL IVLSAV('IENDS',0,0,IENDS)
            CALL QGETIB(1,5,NPART)
            CALL QGETIB(1,6,MAXSIZ)
         END IF
         CALL IVLSAV('MAXSIZ',0,0,MAXSIZ)
         CALL IVLSAV('NPART',0,0,NPART)
         MPCOMP=0
         MPBIN=0
         MPMETR=0
         MPWTOF=0
         MPWTDO=0
         MPWTDA=0
         DO 17 I=1,3
         IF(IOPVAL(I).NE.0) THEN
            IF(IOPVAL(I).EQ.1) THEN
               MPCOMP=1
            ELSE IF(IOPVAL(I).EQ.2) THEN
               MPBIN=1
            ELSE IF(IOPVAL(I).EQ.3) THEN
               MPMETR=1
            ELSE IF(IOPVAL(I).EQ.4) THEN
               MPWTOF=1
            ELSE IF(IOPVAL(I).EQ.5) THEN
               MPWTDO=1
            ELSE IF(IOPVAL(I).EQ.6) THEN
               MPWTDA=1
            END IF
         END IF
17       CONTINUE
         CALL IVLSAV('MPCOMP',0,0,MPCOMP)
         CALL IVLSAV('MPBIN',0,0,MPBIN)
         CALL IVLSAV('MPMETR',0,0,MPMETR)
         CALL IVLSAV('MPWTOF',0,0,MPWTOF)
         CALL IVLSAV('MPWTDO',0,0,MPWTDO)
         CALL IVLSAV('MPWTDA',0,0,MPWTDA)
C
      ELSE IF(IOPT.EQ.2) THEN
C  Confining beds
         IF(NLAY.EQ.1) THEN
            CALL PRNTXT(MESSFL,308,3)
         ELSE
C  Edit NCON
            NLAYM1=NLAY-1
            DO 55 I=1,NLAYM1
            IDUM(I)=I
55          CONTINUE
C  Initialize screen
56          CALL Q2INIT(MESSFL,308,2)
C  Set initial values
            CALL Q2STIB(1,1,NLAYM1,IDUM)
            CALL Q2STIB(1,2,NLAYM1,NCON)
C  Activate screen
            CALL Q2EDIT(NLAYM1,IRET)
            IF(IRET.EQ.-1) GO TO 56
C  Process values
            CALL Q2GTIB(1,2,NLAYM1,NCON)
         END IF
C
      ELSE IF(IOPT.EQ.3) THEN
C  Edit ARRAYS -- First get layer number (default is 1)
         ILAY=1
C  Prompt for layer number
60       IF(NLAY.GT.1) CALL ULAYIN('MODPATH ARRAYS',ILAY)
C  If layer 0 is returned, then done entering MODPATH ARRAYS
         IF(ILAY.GT.0) THEN
            IAR=1
C  A layer has been selected -- choose which array
C  Add the layer number to the array menu
62          WRITE(CBUF,'(A,I4)') 'Arrays for layer',ILAY
            CALL ZBLDWR(20,CBUF,1,-1,ISTAT)
            CALL ZMNSST
C  Now calculate the array menu number
            IF(ILAY.LT.0 .OR. ILAY.GT.NLAY) ILAY=1
            ITOP=1
            IF(LAYCON(ILAY).EQ.2 .OR. LAYCON(ILAY).EQ.3) ITOP=0
            IF(ILAY.EQ.1 .AND. LAYCON(ILAY).EQ.1) ITOP=0
            IF(ILAY.NE.1) THEN
               IF(NCON(ILAY-1).EQ.0) ITOP=0
            END IF
            INCON=NCON(ILAY)
            IBOT=1
            IF(LAYCON(ILAY).EQ.1 .OR. LAYCON(ILAY).EQ.3) IBOT=0
            MENU=10+ 4*INCON + 2*IBOT + ITOP
            MC=MENU-9
C  Get array to edit
            CALL QRESP(MESSFL,308,MENU,IAR)
C  Check for DONE entering arrays
            IDONE=0
            IF(IAR.GT.5) THEN
               IDONE=1
            ELSE IF(CMENU(IAR,MC).EQ.' ') THEN
               IDONE=1
            END IF
            IF(IDONE.NE.0) THEN
C  No more arrays are wanted for this layer -- see if another layer
C  is desired -- set default to layer+1
               ILAY=ILAY+1
               IF(ILAY.GT.NLAY) ILAY=1
               IF(NLAY.GT.1) GO TO 60
               GO TO 90
            END IF
C  Edit the array.
            IF(IAR.EQ.1) THEN
C  The MODPATH IBOUND array has a different label than its array name.
C  This is because the array's name in the documentation is IBOUND,
C  but this is not allowed because MODFLOW has an array with the same
C  name.
               CALL U2DIN('MODPATH IBOUND',CMENU(IAR,MC),ILAY,0,NCOL,
     1                NROW,IUNIT(40))
               CALL IBNDCK(ILAY,IERR)
               IF(IERR.NE.0) CALL PMXTXI(MESSFL,308,9,10,1,0,1,ILAY)
            ELSE
64             CALL U2DIN(CMENU(IAR,MC),CMENU(IAR,MC),ILAY,0,NCOL,NROW,
     1                IUNIT(40))
C  Check for TOP or BOT not in single files
               IF(CMENU(IAR,MC).EQ.'TOP') THEN
                  CALL VALGET('TOP',ILAY,0,N,DUM)
                  IF(N.GT.0) THEN
                     IF(IARRDA(1,N).GT.0) THEN
                        CALL CKARFL(IARRDA(1,N),NAR)
                        IF(NAR.GT.1) THEN
                           CALL PRNTXT(MESSFL,308,21)
                           GO TO 64
                        END IF
                     END IF
                  END IF
               END IF
               IF(CMENU(IAR,MC).EQ.'BOT') THEN
                  CALL VALGET('BOT',ILAY,0,N,DUM)
                  IF(N.GT.0) THEN
                     IF(IARRDA(1,N).GT.0) THEN
                        CALL CKARFL(IARRDA(1,N),NAR)
                        IF(NAR.GT.1) THEN
                           CALL PRNTXT(MESSFL,308,21)
                           GO TO 64
                        END IF
                     END IF
                  END IF
               END IF
            END IF
C  See if another array is desired in same layer
            IAR=IAR+1
            GO TO 62
         END IF
C
      ELSE IF(IOPT.EQ.4) THEN
C  OPTIONAL FILES
         NN=NSPEC
         IF(ISS.NE.0) NN=NSPEC-1
C  Initialize screen
41       CALL Q2INIT(MESSFL,308,8)
C  Set initial values
         CALL Q2SCTF(1,16,NN,MPTYPE)
         CALL Q2SCTF(2,60,NN,MPNAME)
C  Activate screen
         CALL Q2EDIT(NN,IRET)
         IF(IRET.EQ.-1) GO TO41
C  Process data
         CALL Q2GCTF(2,60,NN,MPNAME)
C
      ELSE IF(IOPT.EQ.5) THEN
C  GUA menu
         IGUAOP=1
70       CALL QRESP(MESSFL,308,23,IGUAOP)
         IF(IGUAOP.EQ.1) THEN
C  Choose GUA method
            CALL QRESP(MESSFL,308,24,IGUAM)
C  Activate or deactivate the GUA file as appropriate
            IF(IGUAM.GT.1 .AND. IGUAUN.EQ.0) THEN
               CALL FINDUN(40,IGUAUN,'GUA')
               IFNUSE(IGUAUN)=IUNIT(40)
            ELSE IF(IGUAM.EQ.1 .AND. IGUAUN.GT.0) THEN
               IFNUSE(IGUAUN)=0
               IGUAUN=0
            END IF
            IF(IGUAM.EQ.3) THEN
C  Get non-uniform real-number ranges for zones
               DO 73 I=1,15
               IDUM(I)=I
73             CONTINUE
C
74             CALL Q2INIT(MESSFL,308,25)
               CALL Q2STIB(1,1,15,IDUM)
               CALL Q2STRB(1,1,15,GUAMIN)
               CALL Q2STRB(1,2,15,GUAMAX)
               CALL Q2EDIT(15,IRET)
               IF(IRET.EQ.-1) GO TO 74
               CALL Q2GTRB(1,1,15,GUAMIN)
               CALL Q2GTRB(1,2,15,GUAMAX)
            ELSE IF(IGUAM.EQ.4) THEN
C  Get uniform real-number ranges for zones
75             CALL Q1INIT(MESSFL,308,28)
               CALL IVLGET('IGUNMN',0,0,ITYPE,IGUNMN)
               IF(ITYPE.NE.0) IGUNMN=1
               CALL IVLGET('IGUNMX',0,0,ITYPE,IGUNMX)
               IF(ITYPE.NE.0) IGUNMX=15
               CALL VALGET('GUAVAL',0,0,ITYPE,GUAVAL)
               IF(ITYPE.NE.0) GUAVAL=1.
               CALL VALGET('GUASTR',0,0,ITYPE,GUASTR)
               IF(ITYPE.NE.0) GUASTR=0.
               CALL QSETIB(1,1,IGUNMN)
               CALL QSETIB(1,2,IGUNMX)
               CALL QSETRB(1,1,GUAVAL)
               CALL QSETRB(1,2,GUASTR)
               CALL Q1EDIT(IRET)
               IF(IRET.EQ.-1) GO TO 75
               CALL QGETRB(1,1,GUAVAL)
               CALL VALSAV('GUAVAL',0,0,GUAVAL)
               CALL QGETRB(1,2,GUASTR)
               CALL VALSAV('GUASTR',0,0,GUASTR)
               CALL QGETIB(1,1,IGUNMN)
               CALL QGETIB(1,2,IGUNMX)
               IF(IGUNMN.GT.IGUNMX) THEN
                  CALL PRNTXT(MESSFL,308,29)
                  GO TO 75
               END IF
               CALL IVLSAV('IGUNMN',0,0,IGUNMN)
               CALL IVLSAV('IGUNMX',0,0,IGUNMX)
               GUAMIN(IGUNMN)=GUASTR
               NG=0
               DO 775 I=1,15
               IF(I.LT.IGUNMN .OR. I.GT.IGUNMX) THEN
                  GUAMAX(I)=0.
                  GUAMIN(I)=0.
               ELSE
                  NG=NG+1
                  IF(I.NE.IGUNMN) GUAMIN(I)=GUAMAX(I-1)
                  GUAMAX(I)=REAL(NG)*GUAVAL+GUASTR
               END IF
775            CONTINUE
C
            ELSE IF(IGUAM.EQ.2) THEN
C  Get legend labels for integer zones
               DO 76 I=1,15
               IDUM(I)=I
76             CONTINUE
C
77             CALL Q2INIT(MESSFL,308,26)
               CALL Q2STIB(1,1,15,IDUM)
               CALL Q2SCTF(1,30,15,CLEGND)
               CALL Q2EDIT(15,IRET)
               IF(IRET.EQ.-1) GO TO 77
               CALL Q2GCTF(1,30,15,CLEGND)
            END IF
C
C  Get legend title when either ZONES or RANGES
            IF(IGUAM.EQ.2 .OR. IGUAM.EQ.3 .OR. IGUAM.EQ.4) THEN
78             CALL Q1INIT(MESSFL,308,27)
               CALL QSETCT(1,50,50,CLTITL)
               CALL Q1EDIT(IRET)
               IF(IRET.EQ.-1) GO TO 78
               CALL QGETCT(1,50,50,CLTITL)
            END IF
         ELSE IF(IGUAOP.EQ.2 .AND. IGUAM.EQ.1) THEN
C  Cannot edit GUA array if GUA is turned off
            IGUAOP=1
            GO TO 70
         ELSE IF(IGUAOP.EQ.2) THEN
C  Define GUA layer arrays
            ILAY=1
C  Prompt for layer number
79          IF(NLAY.GT.1) CALL ULAYIN('GUA',ILAY)
C  If layer 0 is returned, then done entering layers
            IF(ILAY.GT.0) THEN
C  Layer > 0, get control record
               IF(IGUAM.EQ.2) THEN
                  CALL U2DIN('Integer GUA','IGUA',ILAY,0,NCOL,NROW,
     1                  IUNIT(40))
               ELSE
                  CALL U2DIN('Real GUA','RGUA',ILAY,0,NCOL,NROW,
     1                  IUNIT(40))
               END IF
C  Now see if another layer is desired -- set default to layer+1
               ILAY=ILAY+1
               IF(ILAY.GT.NLAY) ILAY=1
               IF(NLAY.GT.1) GO TO 79
            END IF
C
         ELSE
C  Done with GUA
            GO TO 90
         END IF
C  Start GUA menu again
         IGUAOP=IGUAOP+1
         GO TO 70
C
      ELSE IF(IOPT.EQ.6) THEN
C  UNDEFINED data
         CALL MPSV(IUNDEF,-1)
C
      ELSE
         CALL MPSV(IUNDEF,1)
C  Switch back to MODFLOW's real units prior to returning.
         CALL MFIUMK
         MODOUT=MODSAV
         RETURN
      END IF
C
90    IOPT=IOPT+1
      GO TO 10
      END
      SUBROUTINE MPSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE MODPATH DATA
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
      COMMON /FLWCOM/LAYCON(200)
C  Common block for MODPATH
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15),NCON(200)
      PARAMETER (NSPEC=12)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
C  Common block for DRN Package
      COMMON /DRNCOM/DRNAUX(3)
      CHARACTER*16 DRNAUX
C  Common block for GHB Package
      COMMON /GHBCOM/GHBAUX(3)
      CHARACTER*16 GHBAUX
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
      CHARACTER*10 CPACK
      CHARACTER*11 CARRAY,CMIN,CMAX
      CHARACTER*80 OPTION
C     ------------------------------------------------------------------
C  Check for inactive.
      IF(IUNIT(40).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      NMISS=0
C
      MODSAV=MODOUT
      MODOUT=1
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(40)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(40))=IUNIT(40)
C
      IF(IUREAL(IUNIT(40)).EQ.0) CALL REALUN(IUNIT(40))
      NCBL=0
      DO 10 K=1,NLAY
      IF(NCON(K).NE.0) NCBL=NCBL+1
10    CONTINUE
C
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.MP',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(40)),UNIT=IFIL)
C
C  Write first record.
C  Make sure HDRY and HNOFLO have same precision as in BAS and BCF packages.
      IF(IWRFLG.GT.0) THEN
         IGRID=0
         CALL VALGET('HNOFLO',0,0,ITYPE,HNOFLO)
         IF(ITYPE.NE.0) HNOFLO=999.99
         CALL VALGET('HDRY',0,0,ITYPE,HDRY)
         IF(ITYPE.NE.0) HDRY=1.E30
         IF(ISS.NE.0) THEN
            NP=0
         ELSE
            NP=NPER
         END IF
         CALL IVLGET('MAXSIZ',0,0,ITYPE,MAXSIZ)
         IF(ITYPE.NE.0) MAXSIZ=0
         CALL IVLGET('NPART',0,0,ITYPE,NPART)
         IF(ITYPE.NE.0) NPART=0
         IF(ABS(HNOFLO).LE.999999. .AND. ABS(HNOFLO).GE.100.) THEN
            WRITE(IFIL,16) NCOL,NROW,NLAY,NCBL,IGRID,NP,MAXSIZ,HNOFLO,
     1                     HDRY,NPART
16          FORMAT(6I6,I10,F10.2,1P,E10.2,I10,
     1      '  NCOL,NROW,NLAY,NCBL,IGRID,NPER,MXSIZ,HNOFLO,HDRY,NPART')
         ELSE
            WRITE(IFIL,17) NCOL,NROW,NLAY,NCBL,IGRID,NP,MAXSIZ,HNOFLO,
     1                     HDRY,NPART
17          FORMAT(6I6,I10,1P,E11.3,E10.2,I10,
     1      '  NCOL,NROW,NLAY,NCBL,IGRID,NPER,MXSIZ,HNOFLO,HDRY,NPART')
         END IF
      END IF
C
C  Options record
      IF(IWRFLG.GT.0) THEN
         NOPT=0
         CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
         IF(IXSEC.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+9
            OPTION(N1:NOPT)=' XSECTION'
         END IF
         CALL IVLGET('MPCOMP',0,0,ITYPE,MPCOMP)
         IF(MPCOMP.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+9
            OPTION(N1:NOPT)=' COMPACT'
         END IF
         CALL IVLGET('MPBIN',0,0,ITYPE,MPBIN)
         IF(MPBIN.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+16
            OPTION(N1:NOPT)=' BINARY'
         END IF
         CALL IVLGET('MPMETR',0,0,ITYPE,MPMETR)
         IF(MPMETR.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+7
            OPTION(N1:NOPT)=' METERS'
         END IF
         CALL IVLGET('MPWTOF',0,0,ITYPE,MPWTOF)
         IF(MPWTOF.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+8
            OPTION(N1:NOPT)=' WT(OFF)'
         END IF
         CALL IVLGET('MPWTDO',0,0,ITYPE,MPWTDO)
         IF(MPWTDO.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+11
            OPTION(N1:NOPT)=' WT(DOTTED)'
         END IF
         CALL IVLGET('MPWTDA',0,0,ITYPE,MPWTDA)
         IF(MPWTDA.NE.0 .AND. ITYPE.EQ.0) THEN
            N1=NOPT+1
            NOPT=NOPT+11
            OPTION(N1:NOPT)=' WT(DASHED)'
         END IF
         IF(NOPT.GT.0) WRITE(IFIL,'(A)') OPTION(1:NOPT)
         IF(NOPT.LE.0) WRITE(IFIL,'(A)') 'OPTIONS RECORD'
      END IF
C
C  LAYCON
      IF(IWRFLG.GT.0) THEN
         WRITE(IFIL,'(40I2)') (LAYCON(K),K=1,NLAY)
      END IF
C
C  NCON -- confining bed codes
      IF(NCBL.GT.0 .AND. IWRFLG.GT.0) THEN
         WRITE(IFIL,'(40I2)') (NCON(K),K=1,NLAY)
      END IF
C
C  DELR and DELC
      CALL U1DRSV('DELR',IUNDEF,IFIL,IUNIT(1))
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A)') 'DELR       BCF                '
      END IF
      CALL U1DRSV('DELC',IUNDEF,IFIL,IUNIT(1))
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A)') 'DELC       BCF                '
      END IF
C
C  TOP and BOTTOM Elevations
      DO 20 K=1,NLAY
      KK=K
C  Tops
C
C  When saving data using the original MODFLOW format, make sure that all
C  external TOP files are type OPEN/CLOSE.  If the array is used by
C  MODFLOW and MODFLOW is using "original" output, then these files will
C  be type DATA.
         CALL VALGET('TOP',KK,0,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).GT.0) THEN
               N=IARRDA(1,NAR)
               IF(FILTYP(N).EQ.'DATA') THEN
                  FILTYP(N)='OPEN/CLOSE'
                  CALL RTRNUN(N)
                  IUREAL(N)=IUMISC
               END IF
               IF(FILTYP(N).EQ.'DATA(BINARY)') THEN
                  FILTYP(N)='OPEN/CLOSE(BINARY)'
                  CALL RTRNUN(N)
                  IUREAL(N)=IUMISC
               END IF
            END IF
         END IF
      IF(K.NE.1 .OR. LAYCON(K).NE.1) THEN
C  TOP array is needed for layer K.
         IF(LAYCON(K).EQ.2 .OR. LAYCON(K).EQ.3) THEN
            CARRAY='TOP'
            KKK=KK
            IPACK=IUNIT(1)
            CPACK='BCF'
            CALL U2DRSV('TOP',KKK,0,IUNDEF,IFIL,IPACK,'TOP',KK)
         ELSE
            IF(K.NE.1) THEN
               KKK=K-1
               IF(NCON(KKK).EQ.0) THEN
                  CARRAY='BOT'
                  IF(LAYCON(KKK).EQ.2 .OR. LAYCON(KKK).EQ.3) THEN
                     IPACK=IUNIT(1)
                     CPACK='BCF'
                     CALL U2DRSV('BOT',KKK,0,IUNDEF,IFIL,IPACK,'TOP',KK)
                  ELSE
                     IPACK=IUNIT(40)
                     CPACK='MODPATH'
                     CALL U2DRSV('BOT',KKK,0,IUNDEF,IFIL,IPACK,'TOP',KK)
                  END IF
               ELSE
                  CARRAY='TOP'
                  KKK=KK
                  IPACK=IUNIT(40)
                  CPACK='MODPATH'
                  CALL U2DRSV('TOP',KKK,0,IUNDEF,IFIL,IPACK,'TOP',KK)
               END IF
            ELSE
               CARRAY='TOP'
               KKK=KK
               IPACK=IUNIT(40)
               CPACK='MODPATH'
               CALL U2DRSV('TOP',KKK,0,IUNDEF,IFIL,IPACK,'TOP',KK)
            END IF
         END IF
C
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,A,I9)') CARRAY,CPACK,KKK
         END IF
      END IF
C  Bottoms
C
C  When saving data using the original MODFLOW format, make sure that all
C  external BOT files are type OPEN/CLOSE.  If the array is used by
C  MODFLOW and MODFLOW is using "original" output, then these files will
C  be type DATA.
         CALL VALGET('BOT',KK,0,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).GT.0) THEN
               N=IARRDA(1,NAR)
               IF(FILTYP(N).EQ.'DATA') THEN
                  FILTYP(N)='OPEN/CLOSE'
                  CALL RTRNUN(N)
                  IUREAL(N)=IUMISC
               END IF
               IF(FILTYP(N).EQ.'DATA(BINARY)') THEN
                  FILTYP(N)='OPEN/CLOSE(BINARY)'
                  CALL RTRNUN(N)
                  IUREAL(N)=IUMISC
               END IF
            END IF
         END IF
      IPACK=IUNIT(40)
      CPACK='MODPATH'
      IF(LAYCON(K).EQ.1 .OR. LAYCON(K).EQ.3) THEN
         IPACK=IUNIT(1)
         CPACK='BCF'
      END IF
      CALL U2DRSV('BOT',KK,0,IUNDEF,IFIL,IPACK,'BOT',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,A,I9)') 'BOT        ',CPACK,KK
      END IF
20    CONTINUE
C
C  IBOUND
      DO 30 K=1,NLAY
      KK=K
      CALL U2DISV('IBNDMP',KK,0,IUNDEF,IFIL,IUNIT(40))
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I9)') 'IBOUND-MP  MODPATH   ',KK
      END IF
30    CONTINUE
C
C  Porosity
      DO 40 K=1,NLAY
      KK=K
      CALL U2DRSV('POR',KK,0,IUNDEF,IFIL,IUNIT(40),'POR',KK)
      IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
         NMISS=NMISS+1
         IUNDEF=0
         WRITE(CTEXT(NMISS),'(A,I9)') 'POR        MODPATH   ',KK
      END IF
      IF(NCON(K).NE.0) THEN
         CALL U2DRSV('PORCB',KK,0,IUNDEF,IFIL,IUNIT(40),'PORCB',KK)
         IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            IUNDEF=0
            WRITE(CTEXT(NMISS),'(A,I9)') 'PORCB      MODPATH   ',KK
         END IF
      END IF
40    CONTINUE
C
C  Stress Period Data
C  Before looking at I/O frequency flags, reset the flags if OC is not
C  active.  This is necessary for situations in which OC was once active
C  and then deactivated -- the flags don't get reset by the deactivation.
      IF(IUNIT(12).LE.0) THEN
         IBUDSV=1
         IHEDSV=1
      END IF
C
      IF(ISS.NE.0) THEN
C  Steady state -- no data to output, but check for budget save
         IF(IBUDSV.EQ.1) THEN
C  No budget output, so MODPATH will not run.
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_FLOW  OUTPUT             '
            END IF
         ELSE IF(IBUDSV.EQ.5) THEN
            IF(IBDSV(1,1).NE.1 .OR. IBDSV(2,1).NE.1) THEN
C  List of times for flow data output is empty, so MODPATH will not run
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_FLOW  OUTPUT             '
               END IF
            END IF
         END IF
      ELSE
C  Transient -- output data and check if budget data are being saved
         CALL VALGET('TBEGIN',0,0,I,TBEGIN)
         IF(I.NE.0) TBEGIN=0.0
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,E10.3)') TBEGIN
         DO 45 N=1,NPER
         IF(IWRFLG.GT.0) WRITE(IFIL,'(1P,E10.3,I10,E10.3,A)')
     1     PERLEN(N),NSTP(N),TSMULT(N),'  PERLEN,NSTP,TSMULT'
45       CONTINUE
C  Write the time interval for budget data.
         CALL IVLGET('ITFULL',0,0,ITYPE,ITFULL)
         IF(ITYPE.NE.0) ITFULL=1
         CALL IVLGET('IBEGP',0,0,ITYPE,IBEGP)
         IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IBEGP=1
         CALL IVLGET('IBEGS',0,0,ITYPE,IBEGS)
         IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IBEGS=1
         CALL IVLGET('IENDP',0,0,ITYPE,IENDP)
         IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IENDP=NPER
         CALL IVLGET('IENDS',0,0,ITYPE,IENDS)
         IF(ITYPE.NE.0 .OR. ITFULL.NE.0) IENDS=NSTP(NPER)
C  make sure that MODFLOW simulation period/step changes don't make the
C  MODPATH begin/end times go out of range.
         IF(IENDP.GT.NPER) IENDP=NPER
         IF(IENDS.GT.NSTP(IENDP)) IENDS=NSTP(IENDP)
         IF(IBEGS.GT.NSTP(IBEGP)) IBEGS=NSTP(IBEGP)
         IF(IWRFLG.GT.0) WRITE(IFIL,46) IBEGP,IBEGS,IENDP,IENDS
46       FORMAT(4I10)
C
C  Check that Budget data are saved for the required time interval,
         IF(IBUDSV.EQ.5) THEN
C  Find the location at which the list of times for saving budget matches
C  the start time for saving budget.
            DO 110 I=1,MXSCRN
            IF(IBDSV(1,I).EQ.IBEGP .AND. IBDSV(2,I).EQ.IBEGS)
     1               GO TO 151
110         CONTINUE
C  The list of times for saving budget does not include the time at which
C  the saving of BUDGET data must start.
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_FLOW  OUTPUT             '
            END IF
            GO TO 191
C
C  See if each time step for which budget is required is in the list of times
C  for saving budget.
151         ILIST=I
            DO 190 I=IBEGP,IENDP
            J1=1
            IF(I.EQ.IBEGP) J1=IBEGS
            J2=NSTP(I)
            IF(I.EQ.IENDP) J2=IENDS
            DO 190 J=J1,J2
            IF(ILIST.GT.MXSCRN) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1                 'SAVE_FLOW  OUTPUT             '
               END IF
               GO TO 191
            END IF
            IF(I.NE.IBDSV(1,ILIST) .OR. J.NE.IBDSV(2,ILIST)) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1                 'SAVE_FLOW  OUTPUT             '
               END IF
               GO TO 191
            ELSE
               ILIST=ILIST+1
            END IF
190         CONTINUE
C  Each time step for which budget data are required is included
C  in the list of times for which budget is saved -- NO ERROR
191         CONTINUE
C
         ELSE IF(IBUDSV.EQ.1) THEN
C  No budget output, which must be an error
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_FLOW  OUTPUT             '
            END IF
         ELSE IF(IBUDSV.EQ.3) THEN
C  Save budget every stress period -- each stress period in budget
C  interval must consist of only 1 time step.
            DO 192 I=IBEGP,IENDP
            IF(NSTP(I).NE.1) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)') 
     1              'SAVE_FLOW  OUTPUT             '
               END IF
               GO TO 193
            END IF
192         CONTINUE
193         CONTINUE
         ELSE IF(IBUDSV.EQ.2) THEN
C  Save budget at end of simulation -- budget interval must be a single
C  time step, which is the final time step of the last stress period
            IF(IBEGP.NE.IENDP .OR. IBEGS.NE.IENDS .OR.
     1            IENDS.NE.NSTP(IENDP) .OR. IENDP.NE.NPER) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)') 
     1              'SAVE_FLOW  OUTPUT             '
               END IF
            END IF 
         END IF
      END IF
C  End of saving and checking budget interval
C
C  Check that the proper head data are being saved.  There is no data to
C  be written to the MODPATH data file, but the checking is used to
C  determine if data are complete.
      IH=0
      DO 200 K=1,NLAY
      IF(LAYCON(K).EQ.1 .OR. LAYCON(K).EQ.3) IH=1
200   CONTINUE
      IF(IH.NE.0) THEN
      IF(ISS.NE.0) THEN
C  Steady state
         IF(IHEDSV.EQ.1) THEN
C  HEAD is not being saved, so MODPATH will not run.
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_HEAD  OUTPUT             '
            END IF
         ELSE IF(IHEDSV.EQ.5) THEN
            IF(IHDSV(1,1).NE.1 .OR. IHDSV(2,1).NE.1) THEN
C  HEAD is not being saved for the first time step, so MODPATH will not run
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_HEAD  OUTPUT             '
               END IF
            END IF
         END IF
      ELSE
C  Transient --  Check if head data is saved for the time steps in which
C  MODPATH is used
         IF(IHEDSV.EQ.5) THEN
C  Find the location at which the list of times for saving heads matches
C  the start time for saving budget.
            DO 250 I=1,MXSCRN
            IF(IHDSV(1,I).EQ.IBEGP .AND. IHDSV(2,I).EQ.IBEGS)
     1               GO TO 251
250         CONTINUE
C  The list of times for saving head does not include the time at which
C  the saving of BUDGET data starts
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_HEAD  OUTPUT             '
            END IF
            GO TO 301
C
C  See if each time step for which budget is saved is in the list of times
C  for saving heads.
251         ILIST=I
            DO 300 I=IBEGP,IENDP
            J1=1
            IF(I.EQ.IBEGP) J1=IBEGS
            J2=NSTP(I)
            IF(I.EQ.IENDP) J2=IENDS
            DO 300 J=J1,J2
            IF(ILIST.GT.MXSCRN) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1                 'SAVE_HEAD  OUTPUT             '
               END IF
               GO TO 301
            END IF
            IF(I.NE.IHDSV(1,ILIST) .OR. J.NE.IHDSV(2,ILIST)) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)')
     1                 'SAVE_HEAD  OUTPUT             '
               END IF
               GO TO 301
            ELSE
               ILIST=ILIST+1
            END IF
300         CONTINUE
C  Each time step for which budget data are saved is included
C  in the list of times for which head is saved -- NO ERROR
301         CONTINUE
C
         ELSE IF(IHEDSV.EQ.1) THEN
C  No head output, which has to be an error.
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A)')
     1              'SAVE_HEAD  OUTPUT             '
            END IF
         ELSE IF(IHEDSV.EQ.3) THEN
C  Save head every stress period -- each stress period in budget
C  interval must consist of only 1 time step.
            DO 305 I=IBEGP,IENDP
            IF(NSTP(I).NE.1) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)') 
     1              'SAVE_HEAD  OUTPUT             '
               END IF
               GO TO 306
            END IF 
305         CONTINUE
306         CONTINUE
         ELSE IF(IHEDSV.EQ.2) THEN
C  Save head at end of simulation -- budget interval must be a single
C  time step, which is the final time step of the last stress period
            IF(IBEGP.NE.IENDP .OR. IBEGS.NE.IENDS .OR.
     1            IENDS.NE.NSTP(IENDP) .OR. IENDP.NE.NPER) THEN
               IUNDEF=1
               IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A)') 
     1              'SAVE_HEAD  OUTPUT             '
               END IF
            END IF 
         END IF
      END IF
      END IF
C  End of checking for head data
C
C  End of MAIN data file save -- close file
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
C
C  Save GUA file
      IF(IGUAUN.GT.0) THEN
         IFNUSE(IGUAUN)=IUNIT(40)
         IF(IUREAL(IGUAUN).EQ.0) CALL REALUN(IGUAUN)
         IF(IWRFLG.EQ.1) OPEN(FILE='MFI.GUA',UNIT=IFIL)
         IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IGUAUN),UNIT=IFIL)
C  If only checking for missing data, clear the undefined flag because
C  it is used as a defined/undefined flag for each array rather than
C  as a cumulative indicator.
         IF(IWRFLG.LT.0) IUNDEF=0
         IF(IGUAM.EQ.2) THEN
C  Write integer array and legend text.
            IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') 'ZONES'
            IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') CLTITL
            DO 500 K=1,NLAY
            KK=K
            CALL U2DISV('IGUA',KK,0,IUNDEF,IFIL,IGUAUN)
C  Change IFNUSE to MODPATH -- U2DISV set IFNUSE to IGUAUN
            CALL IVLGET('IGUA',KK,0,NAR,IDUM)
            IF(NAR.GT.0) THEN
               IF(IARRDA(1,NAR).GT.0) IFNUSE(IARRDA(1,NAR))=IUNIT(40)
            END IF
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I9)') 'GUA        MODPATH   ',KK
            END IF
500         CONTINUE
            IF(IWRFLG.GT.0) THEN
               DO 510 K=1,15
               IF(CLEGND(K).NE.' ') WRITE(IFIL,'(I5,1X,A)') K,CLEGND(K)
510            CONTINUE
            END IF
         ELSE
C  Write array of real numbers and ranges
            IF(IWRFLG.GT.0) WRITE(IFIL,'(A,I5)') 'RANGES'
            IF(IWRFLG.GT.0) WRITE(IFIL,'(A)') CLTITL
            DO 540 K=1,NLAY
            KK=K
            CALL U2DRSV('RGUA',KK,0,IUNDEF,IFIL,IGUAUN,'RGUA',KK)
C  Change IFNUSE to MODPATH -- U2DRSV set IFNUSE to IGUAUN
            CALL VALGET('RGUA',KK,0,NAR,DUM)
            IF(NAR.GT.0) THEN
               IF(IARRDA(1,NAR).GT.0) IFNUSE(IARRDA(1,NAR))=IUNIT(40)
            END IF
            IF(IUNDEF.NE.0 .AND. NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A,I9)') 'GUA        MODPATH   ',KK
            END IF
540         CONTINUE
            IF(IWRFLG.GT.0) THEN
               DO 560 K=1,15
               IF(GUAMIN(K).LT.GUAMAX(K)) THEN
                  IF(GUAMIN(K).EQ.-1.E30) THEN
                     CMIN=' <'
                  ELSE
                     WRITE(CMIN,'(1PE11.3)') GUAMIN(K)
                  END IF
                  IF(GUAMAX(K).EQ.1.E30) THEN
                     CMAX=' >'
                  ELSE
                     WRITE(CMAX,'(1PE11.3)') GUAMAX(K)
                  END IF
                  WRITE(IFIL,'(I5,2A)') K,CMIN,CMAX
               END IF
560            CONTINUE
            END IF
         END IF
         IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      END IF
C
C  Check if IFACE has been defined for point stress packages.
      IF(IUNIT(2).GT.0) THEN
         IF(WELAUX(1).NE.'IFACE') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'Well IFACE (WEL Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(3).GT.0) THEN
         IF(DRNAUX(1).NE.'IFACE') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'Drain IFACE (DRN Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(4).GT.0) THEN
         IF(RIVAUX(1).NE.'IFACE') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'River IFACE (RIV Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(7).GT.0) THEN
         IF(GHBAUX(1).NE.'IFACE') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'GHB IFACE (GHB Package)'
            END IF
         END IF
      END IF
      IF(IUNIT(18).GT.0) THEN
         IF(STRAUX(1).NE.'IFACE') THEN
            IUNDEF=1
            IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
               NMISS=NMISS+1
               IUNDEF=0
               WRITE(CTEXT(NMISS),'(A)')
     1                'Stream IFACE (STR Package)'
            END IF
         END IF
      END IF
C
C  Clean up and exit
      IF(IWRFLG.LT.0) THEN
         IF(NMISS.GT.0) THEN
            CALL DSPTXT(MESSFL,308,4,CTEXT,NMISS,30)
            IUNDEF=1
         ELSE
            CALL PRNTXT(MESSFL,308,5)
         END IF
      END IF
C
      CALL FNMRMV
      MODOUT=MODSAV
      RETURN
      END
      SUBROUTINE MPNMSV(IWRFLG)
C     ******************************************************************
C     SAVE MODPATH NAME FILE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      PARAMETER (NSPEC=12)
      COMMON /MPCOM/IGUAUN,IGUAM,GUAMIN(15),GUAMAX(15),NCON(200)
      COMMON /MPCCOM/MPNAME,MPTYPE,CLEGND(15),CLTITL
      CHARACTER*60 MPNAME(NSPEC)
      CHARACTER*16 MPTYPE(NSPEC)
      CHARACTER*30 CLEGND
      CHARACTER*50 CLTITL
C     ------------------------------------------------------------------
      IF(IWRFLG.LT.1) RETURN
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.MPN',UNIT=IUMISC)
      IF(IWRFLG.GT.1) OPEN(FILE=DSNAME(1:NDSNAM)//'.mpn',UNIT=IUMISC)
C
C  Write the name of the LIST data file if there is one -- it must
C  come first
      IF(MPNAME(11).NE.' ') THEN
         J=LENSTR(60,MPNAME(11))
         DO 3 N=1,MXUNIT
         IF(IUAVAI(N).NE.0) THEN
            WRITE(IUMISC,26) MPTYPE(11),IUAVAI(N),MPNAME(11)(1:J)
            IUAVAI(N)=0
            GO TO 4
         END IF
3        CONTINUE
         WRITE(IOUT,*) ' Not enough file units for MODPATH'
         STOP
      END IF
C
C  Write the name of the MAIN data file
4     INMP=IUNIT(40)
      IF(INMP.NE.0) THEN
         J=LENSTR(80,FILNAM(INMP))
         WRITE(IUMISC,25) 'MAIN              ',IUREAL(INMP),
     1             FILNAM(INMP)(1:J)
      END IF
C
C  Write the names of external files used for DELR and DELC
      CALL VALGET('DELR',0,0,NARDR,DUM)
      NUNDR=0
      IF(NARDR.GT.0) THEN
         IF(IARRDA(1,NARDR).GT.0) NUNDR=IARRDA(1,NARDR)
      END IF
      IF(NUNDR.GT.0) THEN
         IF(FILTYP(NUNDR)(1:4).EQ.'DATA') THEN
            J=LENSTR(80,FILNAM(NUNDR))
            IF(IUREAL(NUNDR).EQ.0) CALL REALUN(NUNDR)
            WRITE(IUMISC,25) FILTYP(NUNDR),IUREAL(NUNDR),
     1             FILNAM(NUNDR)(1:J)
         END IF
      END IF
      CALL VALGET('DELC',0,0,NARDC,DUM)
      NUNDC=0
      IF(NARDC.GT.0) THEN
         IF(IARRDA(1,NARDC).GT.0) NUNDC=IARRDA(1,NARDC)
      END IF
      IF(NUNDC.GT.0 .AND. NUNDC.NE.NUNDR) THEN
         IF(FILTYP(NUNDC)(1:4).EQ.'DATA') THEN
            J=LENSTR(80,FILNAM(NUNDC))
            IF(IUREAL(NUNDC).EQ.0) CALL REALUN(NUNDC)
            WRITE(IUMISC,25) FILTYP(NUNDC),IUREAL(NUNDC),
     1             FILNAM(NUNDC)(1:J)
         END IF
      END IF
C
C  Write the name of the GUA file
      IF(IGUAUN.GT.0) THEN
         J=LENSTR(80,FILNAM(IGUAUN))
         IF(IUREAL(IGUAUN).EQ.0) CALL REALUN(IGUAUN)
         WRITE(IUMISC,25) FILTYP(IGUAUN),IUREAL(IGUAUN),
     1             FILNAM(IGUAUN)(1:J)
      END IF
C
C  Write the names of external IBOUND, POROSITY, and GUA files.
         DO 5 I=1,MXFNAM
         IF(IFNUSE(I).EQ.IUNIT(40) .AND.
     1            FILTYP(I)(1:4).EQ.'DATA') THEN
            J=LENSTR(80,FILNAM(I))
            IF(IUREAL(I).EQ.0) CALL REALUN(I)
            WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
         END IF
5        CONTINUE
C
C  Write the names of all files associated with stress packages that
C  MODPATH reads
C  Wells
      IF(IUNIT(2).NE.0) THEN
         I=IUNIT(2)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  Drains
      IF(IUNIT(3).NE.0) THEN
         I=IUNIT(3)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  Rivers
      IF(IUNIT(4).NE.0) THEN
         I=IUNIT(4)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  GHB
      IF(IUNIT(7).NE.0) THEN
         I=IUNIT(7)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  Streams
      IF(IUNIT(18).NE.0) THEN
         I=IUNIT(18)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  Evapotranspiration
      IF(IUNIT(5).NE.0) THEN
         I=IUNIT(5)
         J=LENSTR(80,FILNAM(I))
         IF(IUREAL(I).EQ.0) CALL REALUN(I)
         WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
      END IF
C  Recharge
      IF(IUNIT(8).NE.0) THEN
         DO 10 I=1,MXFNAM
         IF(IFNUSE(I).EQ.IUNIT(8) .AND.
     1            FILTYP(I)(1:10).NE.'OPEN/CLOSE') THEN
            J=LENSTR(80,FILNAM(I))
            IF(IUREAL(I).EQ.0) CALL REALUN(I)
            WRITE(IUMISC,25) FILTYP(I),IUREAL(I),FILNAM(I)(1:J)
         END IF
10       CONTINUE
      END IF
C
C  Write the names of the HEAD and BUDGET files if they exist.
      IF(IHEDUN.GT.0) THEN
         J=LENSTR(80,FILNAM(IHEDUN))
         DO 12 N=1,MXUNIT
         IF(IUAVAI(N).NE.0) THEN
            IF(FILTYP(IHEDUN).EQ.'DATA') THEN
               WRITE(IUMISC,26) 'HEAD            ',
     1                   IUAVAI(N),FILNAM(IHEDUN)(1:J)
            ELSE
               WRITE(IUMISC,26) 'HEAD(BINARY)    ',
     1                   IUAVAI(N),FILNAM(IHEDUN)(1:J)
            END IF
            IUAVAI(N)=0
            GO TO 13
         END IF
12       CONTINUE
         WRITE(IOUT,*) ' Not enough file units for MODPATH'
         STOP
      END IF
C
13    IF(IBUDUN.GT.0) THEN
         NBD=IBUDUN
      ELSE
         NBD=0
         DO 14 N=1,39
         IF(IUNIT2(N).GT.0) NBD=IUNIT2(N)
14       CONTINUE
      END IF
      IF(NBD.GT.0) THEN
         J=LENSTR(80,FILNAM(NBD))
         DO 15 N=1,MXUNIT
         IF(IUAVAI(N).NE.0) THEN
            WRITE(IUMISC,26) 'BUDGET          ',
     1                   IUAVAI(N),FILNAM(NBD)(1:J)
            IUAVAI(N)=0
            GO TO 18
         END IF
15       CONTINUE
         WRITE(IOUT,*) ' Not enough file units for MODPATH'
         STOP
      END IF
C
C  Write the name of all the special MODPATH files, except LIST, which
C  has already been written.
18    IUPREV=1
      NN=NSPEC
      IF(ISS.NE.0) NN=NSPEC-1
      DO 20 I=1,NN
      IF(MPNAME(I).NE.' ' .AND. I.NE.11) THEN
         J=LENSTR(60,MPNAME(I))
         DO 19 N=IUPREV,MXUNIT
         IF(IUAVAI(N).NE.0) THEN
            WRITE(IUMISC,26) MPTYPE(I),IUAVAI(N),MPNAME(I)(1:J)
            IUPREV=N+1
            GO TO 20
         END IF
19       CONTINUE
         WRITE(IOUT,*) ' Not enough file units for MODPATH'
         STOP
      END IF
20    CONTINUE
C
      CLOSE(UNIT=IUMISC)
      RETURN
25    FORMAT(A,I5,1X,A)
26    FORMAT(A,I7,1X,A)
      END
      SUBROUTINE IBNDCK(K,IERR)
C     ******************************************************************
C     Check IBOUND for consistency between MODFLOW and MODPATH
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C
      IERR=0
C
      CALL VALGET('IBOUND',K,0,NIBND,DUM)
      CALL VALGET('IBNDMP',K,0,NIBMP,DUM)
      IF(NIBND.GT.0 .AND. NIBMP.GT.0) THEN
         IF(IARRDA(1,NIBND).EQ.0 .AND. IARRDA(1,NIBMP).EQ.0) THEN
             IBND=ARRCON(NIBND)
             IBMP=ARRCON(NIBMP)
             IF(IBND.GT.0 .AND. IBMP.LE.0) IERR=1
             IF(IBND.EQ.0 .AND. IBMP.NE.0) IERR=1
             IF(IBND.LT.0 .AND. IBMP.GE.0) IERR=1
         ELSE IF(IARRDA(1,NIBND).EQ.0 .AND. IARRDA(1,NIBMP).EQ.-1) THEN
             IBND=ARRCON(NIBND)
             IF(IARRDA(2,NIBMP).GT.0)
     1           CALL CPCN2D(NCOL,NROW,X(IARRDA(2,NIBMP)),IBND,IERR)
         ELSE IF(IARRDA(1,NIBMP).EQ.0 .AND. IARRDA(1,NIBND).EQ.-1) THEN
             IBMP=ARRCON(NIBMP)
             IF(IARRDA(2,NIBND).GT.0)
     1           CALL CPCN2D(NCOL,NROW,X(IARRDA(2,NIBND)),IBMP,IERR)
         ELSE IF(IARRDA(1,NIBND).EQ.-1 .AND. IARRDA(1,NIBMP).EQ.-1) THEN
             IF(IARRDA(2,NIBND).GT.0 .AND. IARRDA(2,NIBMP).GT.0)
     1              CALL CP2D2D(NCOL,NROW,X(IARRDA(2,NIBND)),
     2                X(IARRDA(2,NIBMP)),IERR)
         END IF
      ELSE IF(NIBND.GT.0) THEN
C  Could possibly create IBNDMP from IBOUND
      ELSE IF(NIBMP.GT.0) THEN
C  Could possibly create IBOUND from IBNDMP
      END IF

      RETURN
      END
      SUBROUTINE CPCN2D(JJ,II,IA,ICON,IERR)
C     ******************************************************************
C     Compare a constant IBOUND to a 2-D array
C     ******************************************************************
      DIMENSION IA(JJ,II)
C
      IERR=0
      IF(ICON.GT.0) THEN
         DO 100 I=1,II
         DO 100 J=1,JJ
         IF(IA(J,I).LE.0) IERR=IERR+1
  100    CONTINUE
C
      ELSE IF(ICON.EQ.0) THEN
         DO 200 I=1,II
         DO 200 J=1,JJ
         IF(IA(J,I).NE.0) IERR=IERR+1
  200    CONTINUE
C
      ELSE IF(ICON.LT.0) THEN
         DO 300 I=1,II
         DO 300 J=1,JJ
         IF(IA(J,I).GE.0) IERR=IERR+1
  300    CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE CP2D2D(JJ,II,IA,IB,IERR)
C     ******************************************************************
C     Compare 2 IBOUND arrays
C     ******************************************************************
      DIMENSION IA(JJ,II),IB(JJ,II)
C
      IERR=0
      DO 100 I=1,II
      DO 100 J=1,JJ
      IF(IB(J,I).GT.0 .AND. IA(J,I).LE.0) IERR=IERR+1
      IF(IB(J,I).EQ.0 .AND. IA(J,I).NE.0) IERR=IERR+1
      IF(IB(J,I).LT.0 .AND. IA(J,I).GE.0) IERR=IERR+1
  100 CONTINUE
C
      RETURN
      END
      SUBROUTINE CKARFL(IU,NAR)
C     ******************************************************************
C     Check how many arrays use the same file.  This is designed for
C     making sure that each TOP and BOT array is in a separate file is
C     in a single file.
C     IU is an existing file, and NAR is the count of how many arrays
C     use that file.  Thus when we want TOP and BOT in individual files,
C     NAR should be 1.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C
      NAR=0
C
      DO 100 N=1,NARRAY
      IF(IARRDA(1,N).EQ.IU) NAR=NAR+1
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE CKTPBT()
C     ******************************************************************
C     Check if there are any TOP and BOT arrays that are combined in a
C     single external file.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C
      DO 100 K=1,NLAY
      KK=K
      CALL VALGET('TOP',KK,0,N,DUM)
      IF(N.GT.0) THEN
         IF(IARRDA(1,N).GT.0) THEN
            CALL CKARFL(IARRDA(1,N),NAR)
            IF(NAR.GT.1) THEN
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A6,I5,A)') 'TOP',KK,
     1                  FILNAM(IARRDA(1,N))(1:67)
               END IF
            END IF
         END IF
      END IF
100   CONTINUE
C
      DO 200 K=1,NLAY
      KK=K
      CALL VALGET('BOT',KK,0,N,DUM)
      IF(N.GT.0) THEN
         IF(IARRDA(1,N).GT.0) THEN
            CALL CKARFL(IARRDA(1,N),NAR)
            IF(NAR.GT.1) THEN
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A6,I5,A)') 'BOT',KK,
     1                  FILNAM(IARRDA(1,N))(1:67)
               END IF
            END IF
         END IF
      END IF
200   CONTINUE
C
      RETURN
      END
      SUBROUTINE IBNDCP()
C     ******************************************************************
C     Copy IBOUND to IBNDMP if INTERNAL or CONSTANT
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C
      NL=NLAY
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.NE.0) IXSEC=0
      IF(IXSEC.NE.0) NL=1
      DO 100 K=1,NL
      KK=K
C
      CALL VALGET('IBOUND',K,0,NIBND,DUM)
      IF(NIBND.GT.0) THEN
C  IBOUND is a constant array.
         IF(IARRDA(1,NIBND).EQ.0) THEN
            CALL VALGET('IBNDMP',KK,0,NIBMP,DUM)
            IF(NIBMP.LT.0) THEN
               CALL ARRMAK('IBNDMP',KK,0,
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
               NIBMP=NARRAY
            END IF
            ARRCON(NIBMP)=ARRCON(NIBND)
            IARRDA(1,NIBMP)=0
         ELSE IF(IARRDA(1,NIBND).EQ.-1 .AND. IARRDA(2,NIBND).GT.0) THEN
C  IBOUND is a defined, INTERNAL array.
            CALL VALGET('IBNDMP',KK,0,NIBMP,DUM)
            IF(NIBMP.LT.0) THEN
               CALL ARRMAK('IBNDMP',KK,0,
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
               NIBMP=NARRAY
            END IF
            ARRCON(NIBMP)=ARRCON(NIBND)
            IF(IARRDA(2,NIBMP).EQ.0) CALL ARRALO(IARRDA(2,NIBMP),
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
            IARRDA(1,NIBMP)=-1
            CALL ARRCP(X(IARRDA(2,NIBND)),X(IARRDA(2,NIBMP)),
     1              IARRDA(3,NIBND),IARRDA(4,NIBND))
         END IF
      END IF
C
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE ARRCP(A,B,JJ,II)
      DIMENSION A(JJ,II),B(JJ,II)
      DO 100 I=1,II
      DO 100 J=1,JJ
      B(J,I)=A(J,I)
100   CONTINUE
      RETURN
      END
