      SUBROUTINE RCHAL(IBDSAM)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR RECHARGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(8)
C
C1------IDENTIFY PACKAGE.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'RCH -- RECHARGE PACKAGE,',
     1' INPUT READ FROM UNIT',I3)
C
C2------READ NRCHOP AND IRCHCB.
      IF(MODINP.EQ.0) THEN
         READ(IUREAL(IN),'(A)') LINE
         READ(LINE,'(2I10)') NRCHOP,IRCHCB
         LLOC=21
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IFARCH,R,-1,IN)
         IF(IFARCH.GT.1 .OR. IFARCH.LT.0) IFARCH=0
      ELSE
         READ(IUREAL(IN),'(A)') LINE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NRCHOP,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRCHCB,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IFARCH,R,-1,IN)
         IF(IFARCH.GT.1 .OR. IFARCH.LT.0) IFARCH=0
      END IF
C
C3------CHECK TO SEE THAT OPTION IS LEGAL.
      IF(NRCHOP.GE.1.AND.NRCHOP.LE.3)GO TO 200
C
C3A-----IF ILLEGAL PRINT A MESSAGE AND ABORT SIMULATION
      WRITE(IOUT,8)
    8 FORMAT(1X,'ILLEGAL OPTION CODE. SIMULATION ABORTING')
      CALL RDABRT
C
C4------IF OPTION IS LEGAL PRINT OPTION CODE.
  200 IF(NRCHOP.EQ.1) WRITE(IOUT,201)
  201 FORMAT(1X,'OPTION 1 -- RECHARGE TO TOP LAYER')
      IF(NRCHOP.EQ.2) WRITE(IOUT,202)
  202 FORMAT(1X,'OPTION 2 -- RECHARGE TO ONE SPECIFIED NODE IN EACH',
     1        ' VERTICAL COLUMN')
      IF(NRCHOP.EQ.3) WRITE(IOUT,203)
  203 FORMAT(1X,'OPTION 3 -- RECHARGE TO HIGHEST ACTIVE NODE IN EACH',
     1        ' VERTICAL COLUMN')
C
C5------IF CELL-BY-CELL FLOWS ARE TO BE SAVED, THEN PRINT UNIT NUMBER.
      IF(IRCHCB.GT.0) WRITE(IOUT,204) IRCHCB
  204 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
C
      CALL IVLSAV('NRCHOP',0,0,NRCHOP)
      CALL IVLSAV('IFARCH',0,0,IFARCH)
      IUNIT2(8)=IRCHCB
      IF(IRCHCB.LE.0) IUNIT2(8)=0
      IF(IRCHCB.GT.0) THEN
         IF(FILTYP(IRCHCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IRCHCB)=IUNIT(12)
         ELSE IF(FILTYP(IRCHCB).EQ.' ') THEN
            IUNIT2(8)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(8).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(8).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IRCHCB.NE.0) IBDSAM=IRCHCB
      ELSE
         IF(IBDSAM.NE.IRCHCB) IBDSAM=0
      END IF
C
C9------RETURN
      RETURN
      END
      SUBROUTINE RCHRP(KPER)
C     ******************************************************************
C     READ RECHARGE RATES
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME(2)
C
      DATA ANAME(1) /'    RECHARGE LAYER INDEX'/
      DATA ANAME(2) /'                RECHARGE'/
C     ------------------------------------------------------------------
      IN=IUNIT(8)
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
C
C1------READ FLAGS SHOWING WHETHER DATA IS TO BE REUSED.
      IF(NRCHOP.EQ.2) THEN
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(2I10)') INRECH,INIRCH
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INRECH,INIRCH
      ELSE
         IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') INRECH
         IF(MODINP.NE.0) READ(IUREAL(IN),*) INRECH
      END IF
C
C2------TEST INRECH TO SEE WHERE RECH IS COMING FROM.
      IF(INRECH.GE.0)GO TO 32
C
C2A-----IF INRECH<0 THEN REUSE RECHARGE ARRAY FROM LAST STRESS PERIOD
      WRITE(IOUT,3)
    3 FORMAT(1X,/1X,'REUSING RECH FROM LAST STRESS PERIOD')
      CALL VALGET('RECH',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED RECHARGE DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('RECH',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      GO TO 55
C
C3------IF INRECH=>0 THEN CALL U2DREL TO READ RECHARGE RATE.
32    CALL ARRMAK('RECH',0,KPER,NCOL,NROW)
      CALL U2DREL(ANAME(2),NROW,NCOL,0,IN,NARRAY,IN)
C
C5------IF NRCHOP=2 THEN A LAYER INDICATOR ARRAY IS NEEDED.
  55  IF (NRCHOP.NE.2) RETURN
C
C6------IF INIRCH<0 THEN REUSE LAYER INDICATOR ARRAY.
      IF(INIRCH.GE.0)GO TO 58
      WRITE(IOUT,2)
    2 FORMAT(1X,/1X,'REUSING IRCH FROM LAST STRESS PERIOD')
      CALL VALGET('IRCH',0,KPER-1,NAR,DUM)
      IF(NAR.LE.0) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED IRCH DATA'
         CALL RDABRT
      END IF
      CALL ARRMAK('IRCH',0,KPER,NCOL,NROW)
      ARRCON(NARRAY)=ARRCON(NAR)
      IARRDA(1,NARRAY)=-3
      IARRDA(5,NARRAY)=IARRDA(5,NAR)
      RETURN
C
C7------IF INIRCH=>0 CALL U2DINT TO READ LAYER IND ARRAY(IRCH)
58    CALL ARRMAK('IRCH',0,KPER,NCOL,NROW)
      CALL U2DINT(ANAME(1),NROW,NCOL,0,IN,NARRAY,IN)
      RETURN
C
      END
      SUBROUTINE RCHED
C  *********************************************************************
C  Input RCH Package data
C  *********************************************************************
C
      INCLUDE 'mfi.gbl'
C
      IF(IUNIT(8).EQ.0) THEN
         CALL FINDUN(18,IU,'RCH')
         IUNIT(8)=IU
         IUNIT2(8)=0
         CALL IVLSAV('IFARCH',0,0,1)
      END IF
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) THEN
         NRCHOP=1
         CALL IVLSAV('NRCHOP',0,0,NRCHOP)
      END IF
C
C  Main RCH menu
      IOPT=1
10    IF(IUNIT(40).LE.0) CALL QRESP(MESSFL,304,1,IOPT)
      IF(IUNIT(40).GT.0) CALL QRESP(MESSFL,304,4,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Edit recharge option
         CALL QRESP(MESSFL,304,2,NRCHOP)
         CALL IVLSAV('NRCHOP',0,0,NRCHOP)
C
      ELSE IF(IOPT.EQ.2) THEN
C  Edit Recharge arrays -- get stress period
         KPER=1
15       CALL UPERIN('Recharge Data',KPER)
C  If previous was selected, go to recharge menu
         IF(KPER.EQ.0) GO TO 90
C  Stress period is accepted
C  Edit RECH array, or RECH and IRCH
         IF(NRCHOP.NE.2) THEN
            CALL U2DIN('Recharge Flux (RECH)','RECH',0,KPER,NCOL,NROW,
     1            IUNIT(8))
         ELSE
C  Both arrays -- choose which one
            IAR=1
20          CALL QRESP(MESSFL,304,3,IAR)
C  If an array was selected, edit it and ask again
            IF(IAR.NE.3) THEN
               IF(IAR.EQ.1) THEN
                  CALL U2DIN('Recharge Flux (RECH)','RECH',0,KPER,
     1                  NCOL,NROW,IUNIT(8))
                  IAR=2
               ELSE
                  CALL U2DIN('Recharge Layers (IRCH)','IRCH',0,KPER,
     1                  NCOL,NROW,IUNIT(8))
                  IAR=3
               END IF
               GO TO 20
            END IF
         END IF
C  Get another stress period if there's more than one.
         KPER=KPER+1
         IF(KPER.GT.NPER) KPER=1
         IF(NPER.GT.1) GO TO 15
C
      ELSE IF(IOPT.EQ.3 .AND. IUNIT(40).GT.0) THEN
C  Recharge face
         CALL IVLGET('IFARCH',0,0,ITYPE,IFARCH)
         IF(ITYPE.NE.0) IFARCH=0
         ICH=IFARCH+1
         CALL QRESP(MESSFL,304,5,ICH)
         IFARCH=ICH-1
         CALL IVLSAV('IFARCH',0,0,IFARCH)
C
      ELSE
C  End of RCH data input
         CALL RCHSV(IUNDEF,1)
         RETURN
      END IF
C
90    IOPT=IOPT+1
      GO TO 10
C
      END
      SUBROUTINE RCHSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR RECHARGE PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C     ------------------------------------------------------------------
      IF(IUNIT(8).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IHEAD=0
      NM=0
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(8)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(8))=IUNIT(8)
C
      IF(IUREAL(IUNIT(8)).EQ.0) CALL REALUN(IUNIT(8))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.RCH',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(8)),UNIT=IFIL)
      CALL IVLGET('NRCHOP',0,0,ITYPE,NRCHOP)
      IF(ITYPE.NE.0) NRCHOP=1
      IRCHCB=IBUDUN
      IF(IBUDUN.EQ.0) IRCHCB=IUNIT2(8)
      ITMP=IRCHCB
      IF(ITMP.GT.0) THEN
         IF(IUREAL(ITMP).EQ.0) CALL REALUN(ITMP)
         ITMP=IUREAL(ITMP)
      END IF
      IF(IWRFLG.GT.0) THEN
         IF(IUNIT(40).LE.0) WRITE(IFIL,'(2I10,A)') NRCHOP,ITMP,
     1          ' NRCHOP IRCHCB'
         IF(IUNIT(40).GT.0) THEN
            CALL IVLGET('IFARCH',0,0,ITYPE,IFARCH)
            IF(ITYPE.NE.0) IFARCH=0
            WRITE(IFIL,'(3I10,A)') NRCHOP,ITMP,IFARCH,
     1          ' NRCHOP IRCHCB ITOP'
         END IF
      END IF
C  Write data for each stress period
      DO 100 KPER=1,NPER
      INRECH=0
      INIRCH=0
      CALL VALGET('RECH',0,KPER,NAR,DUM)
      IF(NAR.GT.0) THEN
         IF(IARRDA(1,NAR).EQ.-3) INRECH=-1
      END IF
      IF(NRCHOP.EQ.2) THEN
         CALL VALGET('IRCH',0,KPER,NAR,DUM)
         IF(NAR.GT.0) THEN
            IF(IARRDA(1,NAR).EQ.-3) INIRCH=-1
         END IF
      END IF
      IF(IWRFLG.GT.0) WRITE(IFIL,'(2I10,A)')
     1           INRECH,INIRCH,'  INRECH INIRCH'
      IF(INRECH.GE.0) THEN
         CALL U2DRSV('RECH',0,KPER,IUNDEF,IFIL,IUNIT(8),'RECH',0)
         IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
            IUNDEF=0
            NM=NM+1
            IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'RCH')
            IF(NMISS.LT.45) THEN
               NMISS=NMISS+1
               WRITE(CTEXT(NMISS),'(A,I4)') 'RECH            ',KPER
            END IF
         END IF
      END IF
      IF(NRCHOP.EQ.2) THEN
         IF(INIRCH.GE.0) THEN
            CALL U2DISV('IRCH',0,KPER,IUNDEF,IFIL,IUNIT(8))
            IF(IUNDEF.NE.0 .AND. IWRFLG.LT.0) THEN
               IUNDEF=0
               NM=NM+1
               IF(IHEAD.EQ.0) CALL STRHED(IHEAD,'RCH')
               IF(NMISS.LT.45) THEN
                  NMISS=NMISS+1
                  WRITE(CTEXT(NMISS),'(A,I4)') 'IRCH            ',KPER
               END IF
            END IF
         END IF
      END IF
100   CONTINUE
C
      IF(IWRFLG.GT.0) CLOSE(UNIT=IFIL)
      IF(NM.EQ.0 .AND. IWRFLG.LT.0 .AND. NMISS.LT.45) THEN
         NMISS=NMISS+1
         CTEXT(NMISS)='ALL DATA ARE DEFINED FOR RCH PACKAGE'
      END IF
      IF(NM.NE.0) IUNDEF=1
      CALL FNMRMV
      RETURN
      END
