      SUBROUTINE RIVAL(IBDSAM,INMP)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR RIVERS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      CHARACTER*90 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(4)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NRIVER.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'RIV -- RIVER PACKAGE,',
     1       ' INPUT READ FROM UNIT',I3)
C
C2------READ MAXIMUM NUMBER OF RIVER REACHES AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      READ(IUREAL(IN),'(A)') LINE
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXRIVR,IRIVCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXRIVR,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRIVCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXRIVR
    3 FORMAT(1H ,'MAXIMUM OF',I5,' RIVER REACHES')
      IF(IRIVCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IRIVCB.GT.0) WRITE(IOUT,8) IRIVCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(IRIVCB.LT.0) IRIVCB=-1
      IUNIT2(4)=IRIVCB
      IF(IRIVCB.GT.0) THEN
         IF(FILTYP(IRIVCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IRIVCB)=IUNIT(12)
         ELSE IF(FILTYP(IRIVCB).EQ.' ') THEN
            IUNIT2(4)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(4).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(4).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IRIVCB.NE.0) IBDSAM=IRIVCB
      ELSE
         IF(IBDSAM.NE.IRIVCB) IBDSAM=0
      END IF
C
C-------Process auxiliary parameters
      RIVAUX(1)=' '
      NAUX=0
20    CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1   LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.EQ.0) THEN
            NAUX=1
            IF(LINE(ISTART:ISTOP).EQ.'IFACE') THEN
               RIVAUX(1)='IFACE'
               WRITE(IOUT,22) RIVAUX(1)
            ELSE
               IF(INMP.EQ.0) THEN
                  NAUX=2
                  RIVAUX(NAUX)=LINE(ISTART:ISTOP)
                  WRITE(IOUT,22) RIVAUX(NAUX)
               ELSE
                  WRITE(IOUT,22) LINE(ISTART:ISTOP)
                  WRITE(IOUT,*) 'When MODPATH is used, the 1st',
     1                   ' AUXILIARY parameter must be "IFACE"'
                  CALL RDABRT
               END IF
            END IF
         ELSE IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            RIVAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,22) RIVAUX(NAUX)
22          FORMAT(1X,'AUXILIARY RIVER PARAMETER: ',A)
         ELSE
            WRITE(IOUT,*) ' Too many auxiliary parameters for MFI'
            CALL RDABRT
         END IF
         GO TO 20
      ELSE IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE') THEN
         GO TO 20
      END IF
C  Allow use of MODPATH without an explicit IFACE auxiliary parameter -- turn
C  the IFACE parameter on if MODPATH is active.
      IF(INMP.NE.0) RIVAUX(1)='IFACE'
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE RIVRP(KPER,IWARN)
C
C     ******************************************************************
C     READ RIVER HEAD, CONDUCTANCE AND BOTTOM ELEVATION
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      CHARACTER*10 CMAX
C     ------------------------------------------------------------------
      IN=IUNIT(4)
C
C1------READ ITMP (NUMBER OF RIVER REACHES OR FLAG TO REUSE DATA).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') ITMP
      IF(MODINP.NE.0) READ(IUREAL(IN),*)ITMP
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) ' Undefined river data for stress period'
         RETURN
      END IF
      CALL LSTMAK('RIVR',0,KPER,9)
      ARRCON(NARRAY)=1.
      IARRDA(1,NARRAY)=-2
C
C2------TEST ITMP.
      IF(ITMP.GE.0)GO TO 50
C
C2A-----IF ITMP <0 THEN REUSE DATA FROM LAST STRESS PERIOD.
      WRITE(IOUT,7)
    7 FORMAT(1X,/1X,'REUSING RIVER REACHES FROM LAST STRESS PERIOD')
      IF(KPER.EQ.1) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED RIVER DATA'
         CALL RDABRT
      END IF
      NRIVER=-1
      CALL IVLSAV('RIVR',0,KPER,NRIVER)
      RETURN
C
C3------IF ITMP=> ZERO THEN IT IS THE NUMBER OF RIVER REACHES.
   50 NRIVER=ITMP
      IF(ITMP.GT.MXLIST*10) THEN
         ITMP=MXLIST*10
         WRITE(CMAX,'(I10)') ITMP
         WRITE(IOUT,'(A)')
     1' WARNING -- Truncating river reaches -- maximum number is'//CMAX
         IWARN=IWARN+1
         IF(NMISS.LT.45) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)=
     1' WARNING -- Truncating river reaches -- maximum number is'//CMAX
         END IF
      END IF
      CALL IVLSAV('RIVR',0,KPER,ITMP)
C
C5------PRINT NUMBER OF RIVER REACHES IN THIS STRESS PERIOD.
  100 WRITE(IOUT,101)NRIVER
  101 FORMAT(1X,//1X,I5,' RIVER REACHES')
C
C6------IF THERE ARE NO RIVER REACHES THEN RETURN.
      IF(NRIVER.EQ.0) RETURN
C
C7------READ AND PRINT DATA FOR EACH RIVER REACH.
      CALL LSTRD(NRIVER,NARRAY,X(IARRDA(2,NARRAY)),IN,
     1'REACH NO. LAYER   ROW   COL     STAGE   CONDUCTANCE  BOT. ELEV.',
     2   RIVAUX,3)
C
C8------RETURN.
      RETURN
      END
      SUBROUTINE RIVED
C     ******************************************************************
C     Edit river data
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
      CHARACTER*8 LABEL(6,2)
      DATA LABEL/ ' ',    ' ',  ' ',     'RIVER','RIVERBED','RIVERBED',
     1            'LAYER','ROW','COLUMN','STAGE',   'COND.','BOT. EL.'/
C
C  Set IUNIT if not already set
      IF(IUNIT(4).EQ.0) THEN
         CALL FINDUN(14,IU,'RIV')
         IUNIT(4)=IU
         IUNIT2(4)=0
      END IF
C
C  Main RIV menu -- select the desired stress period -- default is 1
      KPER=1
10    CALL UPERIN('River Data',KPER)
C  Return if "previous" was selected
      IF(KPER.EQ.0) THEN
         CALL RIVSV(IUNDEF,1)
         RETURN
      END IF
C
C  Set up to get river data for a stress period.
C  If array does not already exist, create array.
      CALL IVLGET('RIVR',0,KPER,NAR,NRIVER)
      IF(NAR.LE.0) THEN
         CALL LSTMAK('RIVR',0,KPER,9)
         IARRDA(1,NARRAY)=-2
         ARRCON(NARRAY)=1.
         NRIVER=0
         NAR=NARRAY
      END IF
C
C  Get new data -- IMETH is the choice for editing data (1) or reusing
C  previous data (2)
      IMETH=1
      IF(KPER.GT.1) THEN
         IF(NRIVER.LT.0) IMETH=2
         CALL QRESP(MESSFL,307,4,IMETH)
      END IF
      IF(IMETH.EQ.1) THEN
         LOC=IARRDA(2,NAR)
C  Activate CONC as an AUX field if MOC is active
         IF(IUNIT(15).GT.0) THEN
            IF(RIVAUX(2).NE.'CONC' .AND. RIVAUX(2).NE.'CONCENTRATION'
     1              .AND. RIVAUX(3).NE.'CONC' .AND.
     2             RIVAUX(3).NE.'CONCENTRATION') THEN
               IF(RIVAUX(2).EQ.' ') THEN
                  RIVAUX(2)='CONC'
               ELSE IF(RIVAUX(3).EQ.' ') THEN
                  RIVAUX(3)='CONC'
               END IF
            END IF
         END IF
         CALL SSLST(X(LOC),NRIVER,LABEL,6,NAR,RIVAUX,3)
      ELSE
         NRIVER=-1
      END IF
      CALL IVLSAV('RIVR',0,KPER,NRIVER)
C
C  Ask for another stress period
      KPER=KPER+1
      IF(KPER.GT.NPER) KPER=1
      IF(NPER.GT.1) GO TO 10
C
C  End of RIVER data input
      CALL RIVSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE RIVSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR RIVER PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for RIV Package
      COMMON /RIVCOM/RIVAUX(3)
      CHARACTER*16 RIVAUX
C     ------------------------------------------------------------------
      IF(IUNIT(4).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IF(IUREAL(IUNIT(4)).EQ.0) CALL REALUN(IUNIT(4))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.RIV',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(4)),UNIT=IFIL)
C
C  Find undefined data and maximum number of rivers in all periods
      CALL LSTMAX('RIVR',IWRFLG,IUNDEF,MXRIVR,'RIV')
      IF(IWRFLG.LE.0) RETURN
C
C  Write the data
      IRIVCB=IBUDUN
      IF(IBUDUN.EQ.0) IRIVCB=IUNIT2(4)
      ITMPUN=IRIVCB
      IF(ITMPUN.GT.0) THEN
         IF(IUREAL(ITMPUN).EQ.0) CALL REALUN(ITMPUN)
         ITMPUN=IUREAL(ITMPUN)
      END IF
C
C  Write data for each stress period
      CALL LSTSAV('RIVR',IFIL,MXRIVR,ITMPUN,
     1                    RIVAUX,3,'    MXRIVR IRIVCB')
C
      CLOSE(UNIT=IFIL)
      RETURN
      END
