      SUBROUTINE UCOLNO(NLBL1,NLBL2,NSPACE,NCPL,NDIG,IOUT)
C
C
C-----VERSION 0934 22JUNE1992 UCOLNO
C     ******************************************************************
C     OUTPUT COLUMN NUMBERS ABOVE A MATRIX PRINTOUT
C        NLBL1 IS THE START COLUMN LABEL (NUMBER)
C        NLBL2 IS THE STOP COLUMN LABEL (NUMBER)
C        NSPACE IS NUMBER OF BLANK SPACES TO LEAVE AT START OF LINE
C        NCPL IS NUMBER OF COLUMN NUMBERS PER LINE
C        NDIG IS NUMBER OF CHARACTERS IN EACH COLUMN FIELD
C        IOUT IS OUTPUT CHANNEL
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*1 DOT,SPACE,DG,BF
      DIMENSION BF(130),DG(10)
C
      DATA DG(1),DG(2),DG(3),DG(4),DG(5),DG(6),DG(7),DG(8),DG(9),DG(10)/
     1         '0','1','2','3','4','5','6','7','8','9'/
      DATA DOT,SPACE/'.',' '/
C     ------------------------------------------------------------------
C
C1------CALCULATE # OF COLUMNS TO BE PRINTED (NLBL), WIDTH
C1------OF A LINE (NTOT), NUMBER OF LINES (NWRAP).
      WRITE(IOUT,1)
    1 FORMAT(1X)
      NLBL=NLBL2-NLBL1+1
      N=NLBL
      IF(NLBL.GT.NCPL) N=NCPL
      NTOT=NSPACE+N*NDIG
      IF(NTOT.GT.130) GO TO 50
      NWRAP=(NLBL-1)/NCPL + 1
      J1=NLBL1-NCPL
      J2=NLBL1-1
C
C2------BUILD AND PRINT EACH LINE
      DO 40 N=1,NWRAP
C
C3------CLEAR THE BUFFER (BF).
      DO 20 I=1,130
      BF(I)=SPACE
   20 CONTINUE
      NBF=NSPACE
C
C4------DETERMINE FIRST (J1) AND LAST (J2) COLUMN # FOR THIS LINE.
      J1=J1+NCPL
      J2=J2+NCPL
      IF(J2.GT.NLBL2) J2=NLBL2
C5------LOAD THE COLUMN #'S INTO THE BUFFER.
      DO 30 J=J1,J2
      NBF=NBF+NDIG
      I2=J/10
      I1=J-I2*10+1
      BF(NBF)=DG(I1)
      IF(I2.EQ.0) GO TO 30
      I3=I2/10
      I2=I2-I3*10+1
      BF(NBF-1)=DG(I2)
      IF(I3.EQ.0) GO TO 30
      BF(NBF-2)=DG(I3+1)
   30 CONTINUE
C
C6------PRINT THE CONTENTS OF THE BUFFER (I.E. PRINT THE LINE).
      WRITE(IOUT,31) (BF(I),I=1,NBF)
   31 FORMAT(1X,130A1)
C
   40 CONTINUE
C
C7------PRINT A LINE OF DOTS (FOR ESTHETIC PURPOSES ONLY).
   50 NTOT=NTOT
      IF(NTOT.GT.130) NTOT=130
      WRITE(IOUT,51) (DOT,I=1,NTOT)
   51 FORMAT(1X,130A1)
C
C8------RETURN
      RETURN
      END
      SUBROUTINE ULAPRW(BUF,TEXT,KSTP,KPER,NCOL,NROW,ILAY,IPRN,IOUT,CON)
C
C
C-----VERSION 1520 18SEPT1992 ULAPRW
C     ******************************************************************
C     PRINT 1 LAYER ARRAY
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*16 TEXT
      DIMENSION BUF(NCOL,NROW)
C     ------------------------------------------------------------------
C
C1------PRINT A HEADER DEPENDING ON ILAY
      IF(ILAY.GT.0) THEN
         WRITE(IOUT,1) TEXT,ILAY,KSTP,KPER
    1    FORMAT(1H1,1X,A,' IN LAYER',I3,' AT END OF TIME STEP',I3,
     1     ' IN STRESS PERIOD',I3/2X,71('-'))
      ELSE IF(ILAY.LT.0) THEN
         WRITE(IOUT,2) TEXT,KSTP,KPER
    2    FORMAT(1H1,1X,A,' FOR CROSS SECTION AT END OF TIME STEP',I3,
     1     ' IN STRESS PERIOD',I3/2X,77('-'))
      END IF
C
C2------MAKE SURE THE FORMAT CODE (IP OR IPRN) IS
C2------BETWEEN 1 AND 13.
    5 IP=IPRN
      IF(IP.LT.1 .OR. IP.GT.18) IP=12
C
C3------CALL THE UTILITY MODULE UCOLNO TO PRINT COLUMN NUMBERS.
      IF(IP.EQ.1) CALL UCOLNO(1,NCOL,0,11,11,IOUT)
      IF(IP.EQ.2) CALL UCOLNO(1,NCOL,0,9,14,IOUT)
      IF(IP.GT.2 .AND. IP.LT.7) CALL UCOLNO(1,NCOL,3,15,8,IOUT)
      IF(IP.GT.6 .AND. IP.LT.12) CALL UCOLNO(1,NCOL,3,20,6,IOUT)
      IF(IP.EQ.12) CALL UCOLNO(1,NCOL,0,10,12,IOUT)
      IF(IP.GE.13 .AND. IP.LE.18) CALL UCOLNO(1,NCOL,3,10,7,IOUT)
C
C4------LOOP THROUGH THE ROWS PRINTING EACH ONE IN ITS ENTIRETY.
      DO 1000 I=1,NROW
      GO TO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     1      180), IP
C
C------------ FORMAT 11G10.3
   10 WRITE(IOUT,11) I,(BUF(J,I)*CON,J=1,NCOL)
   11 FORMAT(1H0,I3,2X,1PG10.3,10(1X,G10.3):/(5X,11(1X,G10.3)))
      GO TO 1000
C
C------------ FORMAT 9G13.6
   20 WRITE(IOUT,21) I,(BUF(J,I)*CON,J=1,NCOL)
   21 FORMAT(1H0,I3,2X,1PG13.6,8(1X,G13.6):/(5X,9(1X,G13.6)))
      GO TO 1000
C
C------------ FORMAT 15F7.1
   30 WRITE(IOUT,31) I,(BUF(J,I)*CON,J=1,NCOL)
   31 FORMAT(1H0,I3,1X,15(1X,F7.1):/(5X,15(1X,F7.1)))
      GO TO 1000
C
C------------ FORMAT 15F7.2
   40 WRITE(IOUT,41) I,(BUF(J,I)*CON,J=1,NCOL)
   41 FORMAT(1H0,I3,1X,15(1X,F7.2):/(5X,15(1X,F7.2)))
      GO TO 1000
C
C------------ FORMAT 15F7.3
   50 WRITE(IOUT,51) I,(BUF(J,I)*CON,J=1,NCOL)
   51 FORMAT(1H0,I3,1X,15(1X,F7.3):/(5X,15(1X,F7.3)))
      GO TO 1000
C
C------------ FORMAT 15F7.4
   60 WRITE(IOUT,61) I,(BUF(J,I)*CON,J=1,NCOL)
   61 FORMAT(1H0,I3,1X,15(1X,F7.4):/(5X,15(1X,F7.4)))
      GO TO 1000
C
C------------ FORMAT 20F5.0
   70 WRITE(IOUT,71) I,(BUF(J,I)*CON,J=1,NCOL)
   71 FORMAT(1H0,I3,1X,20(1X,F5.0):/(5X,20(1X,F5.0)))
      GO TO 1000
C
C------------ FORMAT 20F5.1
   80 WRITE(IOUT,81) I,(BUF(J,I)*CON,J=1,NCOL)
   81 FORMAT(1H0,I3,1X,20(1X,F5.1):/(5X,20(1X,F5.1)))
      GO TO 1000
C
C------------ FORMAT 20F5.2
   90 WRITE(IOUT,91) I,(BUF(J,I)*CON,J=1,NCOL)
   91 FORMAT(1H0,I3,1X,20(1X,F5.2):/(5X,20(1X,F5.2)))
      GO TO 1000
C
C------------ FORMAT 20F5.3
  100 WRITE(IOUT,101) I,(BUF(J,I)*CON,J=1,NCOL)
  101 FORMAT(1H0,I3,1X,20(1X,F5.3):/(5X,20(1X,F5.3)))
      GO TO 1000
C
C------------ FORMAT 20F5.4
  110 WRITE(IOUT,111) I,(BUF(J,I)*CON,J=1,NCOL)
  111 FORMAT(1H0,I3,1X,20(1X,F5.4):/(5X,20(1X,F5.4)))
      GO TO 1000
C
C------------ FORMAT 10G11.4
  120 WRITE(IOUT,121) I,(BUF(J,I)*CON,J=1,NCOL)
  121 FORMAT(1H0,I3,2X,1PG11.4,9(1X,G11.4):/(5X,10(1X,G11.4)))
      GO TO 1000
C
C------------ FORMAT 10F6.0
  130 WRITE(IOUT,131) I,(BUF(J,I)*CON,J=1,NCOL)
  131 FORMAT(1H0,I3,1X,10(1X,F6.0):/(5X,10(1X,F6.0)))
      GO TO 1000
C
C------------ FORMAT 10F6.1
  140 WRITE(IOUT,141) I,(BUF(J,I)*CON,J=1,NCOL)
  141 FORMAT(1H0,I3,1X,10(1X,F6.1):/(5X,10(1X,F6.1)))
      GO TO 1000
C
C------------ FORMAT 10F6.2
  150 WRITE(IOUT,151) I,(BUF(J,I)*CON,J=1,NCOL)
  151 FORMAT(1H0,I3,1X,10(1X,F6.2):/(5X,10(1X,F6.2)))
      GO TO 1000
C
C------------ FORMAT 10F6.3
  160 WRITE(IOUT,161) I,(BUF(J,I)*CON,J=1,NCOL)
  161 FORMAT(1H0,I3,1X,10(1X,F6.3):/(5X,10(1X,F6.3)))
      GO TO 1000
C
C------------ FORMAT 10F6.4
  170 WRITE(IOUT,171) I,(BUF(J,I)*CON,J=1,NCOL)
  171 FORMAT(1H0,I3,1X,10(1X,F6.4):/(5X,10(1X,F6.4)))
      GO TO 1000
C
C------------ FORMAT 10F6.5
  180 WRITE(IOUT,181) I,(BUF(J,I)*CON,J=1,NCOL)
  181 FORMAT(1H0,I3,1X,10(1X,F6.5):/(5X,10(1X,F6.5)))
C
 1000 CONTINUE
C
C5------RETURN
      RETURN
      END
      SUBROUTINE U1DREL(ANAME,JJ,IN,NAR)
C
C
C-----VERSION 1740 18APRIL1993 U1DREL
C     ******************************************************************
C     ROUTINE TO INPUT 1-D REAL DATA MATRICES
C       ANAME IS 24 CHARACTER DESCRIPTION OF A
C       JJ IS NO. OF ELEMENTS
C       IN IS INPUT UNIT
C       IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME
      CHARACTER*20 FMTIN
      CHARACTER*80 CNTRL
      CHARACTER*80 FNAME
C     ------------------------------------------------------------------
C
C1------READ ARRAY CONTROL RECORD AS CHARACTER DATA.
      READ(IUREAL(IN),'(A)') CNTRL
C
C2------LOOK FOR ALPHABETIC WORD THAT INDICATES THAT THE RECORD IS FREE
C2------FORMAT.  SET A FLAG SPECIFYING IF FREE FORMAT OR FIXED FORMAT.
      ICLOSE=0
      IFREE=1
      ICOL=1
      CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF (CNTRL(ISTART:ISTOP).EQ.'CONSTANT') THEN
         LOCAT=0
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'INTERNAL') THEN
         LOCAT=IN
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'EXTERNAL') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,LOCAT,R,IOUT,IN)
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'OPEN/CLOSE') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,0,N,R,IOUT,IN)
         FNAME=CNTRL(ISTART:ISTOP)
         ICLOSE=1
         CALL FNAMSV(FNAME,LOCAT,'OPEN/CLOSE',IN)
         WRITE(IOUT,15) LOCAT,FNAME
   15    FORMAT(1X,/1X,'UNIT',I4,' USED FOR OPEN/CLOSE FILE:',/1X,A)
      ELSE
C
C2A-----DID NOT FIND A RECOGNIZED WORD, SO NOT USING FREE FORMAT.
C2A-----READ THE CONTROL RECORD THE ORIGINAL WAY.
         IFREE=0
         READ(CNTRL,1,ERR=500) LOCAT,CNSTNT,FMTIN,IPRN
    1    FORMAT(I10,F10.0,A20,I10)
      END IF
C
C3------FOR FREE FORMAT CONTROL RECORD, READ REMAINING FIELDS.
      IF(IFREE.NE.0) THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,3,N,CNSTNT,IOUT,IN)
         IF(LOCAT.GT.0) THEN
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
            FMTIN=CNTRL(ISTART:ISTOP)
            IF(INDEX(FMTIN,'FREE').GT.0) FMTIN='(FREE)'
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,IPRN,R,IOUT,IN)
         END IF
      END IF
C
C4------TEST LOCAT TO SEE HOW TO DEFINE ARRAY VALUES.
      IF(LOCAT.GT.0) GO TO 90
C
C4A-----IF LOCAT <0 OR =0; ALL ARRAY VALUES EQUAL TO CNSTNT. RETURN.
      WRITE(IOUT,3) ANAME,CNSTNT
    3 FORMAT(1X,/1X,A,' =',G15.7)
      IARRDA(1,NAR)=0
      ARRCON(NAR)=CNSTNT
      RETURN
C
C4B-----LOCAT>0; READ FORMATTED RECORDS USING FORMAT FMTIN.
90    WRITE(IOUT,5) ANAME,LOCAT,FMTIN
    5 FORMAT(1X,/11X,A,/
     1       1X,'READING ON UNIT',I4,' WITH FORMAT: ',A20)
      IF(LOCAT.EQ.IN) THEN
         IARRDA(1,NAR)=-1
         IF(IARRDA(2,NAR).EQ.0)
     1       CALL ARRAL2(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
         LOC=IARRDA(2,NAR)
         IF(FMTIN.EQ.'(FREE)') THEN
            READ(IUREAL(LOCAT),*) (X(J),J=LOC,LOC+JJ-1)
         ELSE
            READ(IUREAL(LOCAT),FMTIN) (X(J),J=LOC,LOC+JJ-1)
         END IF
      ELSE
         IF(ICLOSE.EQ.0) CALL FNAMCK(LOCAT,'DATA',IN)
         IARRDA(1,NAR)=LOCAT
         ARRFMT(NAR)=FMTIN
      END IF
C
C5------IF CNSTNT IS ZERO, SET EQUAL TO 1.0.
      ZERO=0.
      IF(CNSTNT.EQ.ZERO) CNSTNT=1.
      ARRCON(NAR)=CNSTNT
      IARRDA(5,NAR)=IPRN
C
C6------IF PRINT CODE (IPRN) =0 OR >0 THEN PRINT ARRAY VALUES.
      IF(IPRN.LT.0 .OR. IARRDA(1,NAR).NE.-1) RETURN
120   IF(IPRN.EQ.0) THEN
         WRITE(IOUT,1001) (X(J)*CNSTNT,J=LOC,LOC+JJ-1)
1001     FORMAT((1X,1PG12.5,9(1X,G12.5)))
      ELSE IF(IPRN.GT.0) THEN
         WRITE(IOUT,1002) (X(J)*CNSTNT,J=LOC,LOC+JJ-1)
1002     FORMAT((1X,1PG12.5,4(1X,G12.5)))
      END IF
C
C7------RETURN
      RETURN
C
C8------CONTROL RECORD ERROR.
500   WRITE(IOUT,502) ANAME
502   FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,':')
      WRITE(IOUT,'(1X,A)') CNTRL
C      STOP
      CALL RDABRT
      END
      SUBROUTINE U2DINT(ANAME,II,JJ,K,IN,NAR,IUPACK)
C
C
C-----VERSION 1703 22JUNE1993 U2DINT
C     ******************************************************************
C     ROUTINE TO INPUT 2-D INTEGER DATA MATRICES
C       ANAME IS 24 CHARACTER DESCRIPTION OF IA
C       II IS NO. OF ROWS
C       JJ IS NO. OF COLS
C       K IS LAYER NO. (USED WITH NAME TO TITLE PRINTOUT --
C              IF K=0, NO LAYER IS PRINTED
C              IF K<0, CROSS SECTION IS PRINTED)
C       IN IS INPUT UNIT
C       IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME
      CHARACTER*20 FMTIN
      CHARACTER*80 CNTRL
      CHARACTER*80 FNAME
C     ------------------------------------------------------------------
C
C1------READ ARRAY CONTROL RECORD AS CHARACTER DATA.
      READ(IUREAL(IN),'(A)') CNTRL
C
C2------LOOK FOR ALPHABETIC WORD THAT INDICATES THAT THE RECORD IS FREE
C2------FORMAT.  SET A FLAG SPECIFYING IF FREE FORMAT OR FIXED FORMAT.
      ICLOSE=0
      IFREE=1
      ICOL=1
      CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF (CNTRL(ISTART:ISTOP).EQ.'CONSTANT') THEN
         LOCAT=0
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'INTERNAL') THEN
         LOCAT=IN
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'EXTERNAL') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,LOCAT,R,IOUT,IN)
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'OPEN/CLOSE') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,0,N,R,IOUT,IN)
         FNAME=CNTRL(ISTART:ISTOP)
         ICLOSE=1
         LOCAT=IUMISC
      ELSE
C
C2A-----DID NOT FIND A RECOGNIZED WORD, SO NOT USING FREE FORMAT.
C2A-----READ THE CONTROL RECORD THE ORIGINAL WAY.
         IFREE=0
         READ(CNTRL,1,ERR=600) LOCAT,ICONST,FMTIN,IPRN
    1    FORMAT(I10,I10,A20,I10)
      END IF
C
C3------FOR FREE FORMAT CONTROL RECORD, READ REMAINING FIELDS.
      IF(IFREE.NE.0) THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,ICONST,R,IOUT,IN)
         IF(LOCAT.NE.0) THEN
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
            FMTIN=CNTRL(ISTART:ISTOP)
            IF(INDEX(FMTIN,'BINARY').GT.0) FMTIN='(BINARY)'
            IF(INDEX(FMTIN,'FREE').GT.0) FMTIN='(FREE)'
            IF(ICLOSE.NE.0) THEN
               IF(FMTIN.EQ.'(BINARY)') THEN
                  CALL FNAMSV(FNAME,LOCAT,'OPEN/CLOSE(BINARY)',IUPACK)
               ELSE
                  CALL FNAMSV(FNAME,LOCAT,'OPEN/CLOSE',IUPACK)
               END IF
               WRITE(IOUT,15) LOCAT,FNAME
   15        FORMAT(1X,/1X,'UNIT',I4,' USED FOR OPEN/CLOSE FILE:',/1X,A)
            END IF
            IF(LOCAT.GT.0 .AND. FMTIN.EQ.'(BINARY)') LOCAT=-LOCAT
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,IPRN,R,IOUT,IN)
         END IF
      END IF
C
C4------TEST LOCAT TO SEE HOW TO DEFINE ARRAY VALUES.
      IF(LOCAT) 200,50,90
C
C4A-----LOCAT=0; ALL ARRAY VALUES EQUAL TO ICONST. RETURN.
   50 IF(K.GT.0) WRITE(IOUT,82) ANAME,ICONST,K
   82 FORMAT(1X,/1X,A,' =',I15,' FOR LAYER',I3)
      IF(K.LE.0) WRITE(IOUT,83) ANAME,ICONST
   83 FORMAT(1X,/1X,A,' =',I15)
      IARRDA(1,NAR)=0
      V=ICONST
      ARRCON(NAR)=V
      RETURN
C
C4B-----LOCAT>0; READ FORMATTED RECORDS USING FORMAT FMTIN.
   90 IF(K.GT.0) THEN
         WRITE(IOUT,94) ANAME,K,LOCAT,FMTIN
   94    FORMAT(1X,/11X,A,' FOR LAYER',I3,/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,95) ANAME,LOCAT,FMTIN
   95    FORMAT(1X,/11X,A,/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      ELSE
         WRITE(IOUT,96) ANAME,LOCAT,FMTIN
   96    FORMAT(1X,/11X,A,' FOR CROSS SECTION',/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      END IF
      IF(LOCAT.EQ.IN) THEN
         IARRDA(1,NAR)=-1
         IF(IARRDA(2,NAR).EQ.0)
     1       CALL ARRAL2(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
         LOC=IARRDA(2,NAR)
         CALL U2DIRD(JJ,II,X(LOC),FMTIN,IUREAL(LOCAT))
      ELSE
         IF(ICLOSE.EQ.0) CALL FNAMCK(LOCAT,'DATA',IUPACK)
         IARRDA(1,NAR)=LOCAT
         ARRFMT(NAR)=FMTIN
      END IF
      GO TO 300
C
C4C-----LOCAT<0; READ UNFORMATTED RECORD CONTAINING ARRAY VALUES.
  200 LOCAT=-LOCAT
      IF(K.GT.0) THEN
         WRITE(IOUT,201) ANAME,K,LOCAT
  201    FORMAT(1X,/11X,A,' FOR LAYER',I4,/
     1    1X,'READING BINARY ON UNIT',I4)
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,202) ANAME,LOCAT
  202    FORMAT(1X,/11X,A,/
     1    1X,'READING BINARY ON UNIT',I4)
      ELSE
         WRITE(IOUT,203) ANAME,LOCAT
  203    FORMAT(1X,/11X,A,' FOR CROSS SECTION',/
     1    1X,'READING BINARY ON UNIT',I4)
      END IF
      IF(ICLOSE.EQ.0) CALL FNAMCK(LOCAT,'DATA(BINARY)',IUPACK)
      IARRDA(1,NAR)=LOCAT
      ARRFMT(NAR)='(BINARY)'
C
C5------IF ICONST IS 0, SET TO 1.
  300 IF(ICONST.EQ.0) ICONST=1
      V=ICONST
      ARRCON(NAR)=V
      IARRDA(5,NAR)=IPRN
C
C6------PRINT VALUES IF DESIRED.
      IF(IPRN.GE.0 .AND. IARRDA(1,NAR).EQ.-1)
     1                CALL U2DIPR(JJ,II,X(LOC),IOUT,IPRN,ICONST)
      RETURN
C
C10-----CONTROL RECORD ERROR.
  600 IF(K.GT.0) THEN
         WRITE(IOUT,601) ANAME,K
  601    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,
     1     ' FOR LAYER',I4,':')
      ELSE
         WRITE(IOUT,602) ANAME
  602    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,':')
      END IF
      WRITE(IOUT,'(1X,A)') CNTRL
C      STOP
      CALL RDABRT
      END
      SUBROUTINE U2DIPR(JJ,II,IA,IOUT,IPRN,ICON)
C     ******************************************************************
C     Print a 2-D integer array
C     ******************************************************************
      DIMENSION IA(JJ,II)
C
C7------PRINT COLUMN NUMBERS AT TOP OF PAGE.
      IF(IPRN.GT.9 .OR. IPRN.EQ.0) IPRN=6
      GO TO(401,402,403,404,405,406,407,408,409), IPRN
401   CALL UCOLNO(1,JJ,4,60,2,IOUT)
      GO TO 500
402   CALL UCOLNO(1,JJ,4,40,3,IOUT)
      GO TO 500
403   CALL UCOLNO(1,JJ,4,30,4,IOUT)
      GO TO 500
404   CALL UCOLNO(1,JJ,4,25,5,IOUT)
      GO TO 500
405   CALL UCOLNO(1,JJ,4,20,6,IOUT)
      GO TO 500
406   CALL UCOLNO(1,JJ,4,10,12,IOUT)
      GO TO 500
407   CALL UCOLNO(1,JJ,4,25,3,IOUT)
      GO TO 500
408   CALL UCOLNO(1,JJ,4,15,5,IOUT)
      GO TO 500
409   CALL UCOLNO(1,JJ,4,10,7,IOUT)
C
C8------PRINT EACH ROW IN THE ARRAY.
500   DO 510 I=1,II
      GO TO(501,502,503,504,505,506,507,508,509), IPRN
C
C----------------FORMAT 60I1
  501 WRITE(IOUT,551) I,(IA(J,I)*ICON,J=1,JJ)
  551 FORMAT(1H0,I3,1X,60(1X,I1):/(5X,60(1X,I1)))
      GO TO 510
C
C----------------FORMAT 40I2
  502 WRITE(IOUT,552) I,(IA(J,I)*ICON,J=1,JJ)
  552 FORMAT(1H0,I3,1X,40(1X,I2):/(5X,40(1X,I2)))
      GO TO 510
C
C----------------FORMAT 30I3
  503 WRITE(IOUT,553) I,(IA(J,I)*ICON,J=1,JJ)
  553 FORMAT(1H0,I3,1X,30(1X,I3):/(5X,30(1X,I3)))
      GO TO 510
C
C----------------FORMAT 25I4
  504 WRITE(IOUT,554) I,(IA(J,I)*ICON,J=1,JJ)
  554 FORMAT(1H0,I3,1X,25(1X,I4):/(5X,25(1X,I4)))
      GO TO 510
C
C----------------FORMAT 20I5
  505 WRITE(IOUT,555) I,(IA(J,I)*ICON,J=1,JJ)
  555 FORMAT(1H0,I3,1X,20(1X,I5):/(5X,20(1X,I5)))
      GO TO 510
C
C----------------FORMAT 10I11
  506 WRITE(IOUT,556) I,(IA(J,I)*ICON,J=1,JJ)
  556 FORMAT(1H0,I3,1X,10(1X,I11):/(5X,10(1X,I11)))
      GO TO 510
C
C----------------FORMAT 25I2
  507 WRITE(IOUT,557) I,(IA(J,I)*ICON,J=1,JJ)
  557 FORMAT(1H0,I3,1X,25(1X,I2):/(5X,25(1X,I2)))
      GO TO 510
C
C----------------FORMAT 15I4
  508 WRITE(IOUT,558) I,(IA(J,I)*ICON,J=1,JJ)
  558 FORMAT(1H0,I3,1X,15(1X,I4):/(5X,10(1X,I4)))
      GO TO 510
C
C----------------FORMAT 10I6
  509 WRITE(IOUT,559) I,(IA(J,I)*ICON,J=1,JJ)
  559 FORMAT(1H0,I3,1X,10(1X,I6):/(5X,10(1X,I6)))
C
  510 CONTINUE
C
C9------RETURN
      RETURN
      END
      SUBROUTINE U2DIRD(JJ,II,IA,FMTIN,IU)
C     ******************************************************************
C     Read a 2-D integer array
C     ******************************************************************
      DIMENSION IA(JJ,II)
      CHARACTER*20 FMTIN
C
      DO 100 I=1,II
      IF(FMTIN.EQ.'(FREE)') THEN
         READ(IU,*) (IA(J,I),J=1,JJ)
      ELSE
         READ(IU,FMTIN) (IA(J,I),J=1,JJ)
      END IF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE U2DRRD(JJ,II,A,FMTIN,IU)
C     ******************************************************************
C     Read a 2-D real array
C     ******************************************************************
      DIMENSION A(JJ,II)
      CHARACTER*20 FMTIN
C
      DO 100 I=1,II
      IF(FMTIN.EQ.'(FREE)') THEN
         READ(IU,*) (A(J,I),J=1,JJ)
      ELSE
         READ(IU,FMTIN) (A(J,I),J=1,JJ)
      END IF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE U2DREL(ANAME,II,JJ,K,IN,NAR,IUPACK)
C
C
C-----VERSION 1539 22JUNE1993 U2DREL
C     ******************************************************************
C     ROUTINE TO INPUT 2-D REAL DATA MATRICES
C       ANAME IS 24 CHARACTER DESCRIPTION OF A
C       II IS NO. OF ROWS
C       JJ IS NO. OF COLS
C       K IS LAYER NO. (USED WITH NAME TO TITLE PRINTOUT --)
C              IF K=0, NO LAYER IS PRINTED
C              IF K<0, CROSS SECTION IS PRINTED)
C       IN IS INPUT UNIT
C       IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME
      CHARACTER*20 FMTIN
      CHARACTER*80 CNTRL
      CHARACTER*80 FNAME
C     ------------------------------------------------------------------
C
C1------READ ARRAY CONTROL RECORD AS CHARACTER DATA.
      READ(IUREAL(IN),'(A)') CNTRL
C
C2------LOOK FOR ALPHABETIC WORD THAT INDICATES THAT THE RECORD IS FREE
C2------FORMAT.  SET A FLAG SPECIFYING IF FREE FORMAT OR FIXED FORMAT.
      ICLOSE=0
      IFREE=1
      ICOL=1
      CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF (CNTRL(ISTART:ISTOP).EQ.'CONSTANT') THEN
         LOCAT=0
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'INTERNAL') THEN
         LOCAT=IN
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'EXTERNAL') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,LOCAT,R,IOUT,IN)
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'OPEN/CLOSE') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,0,N,R,IOUT,IN)
         FNAME=CNTRL(ISTART:ISTOP)
         ICLOSE=1
         LOCAT=IUMISC
      ELSE
C
C2A-----DID NOT FIND A RECOGNIZED WORD, SO NOT USING FREE FORMAT.
C2A-----READ THE CONTROL RECORD THE ORIGINAL WAY.
         IFREE=0
         READ(CNTRL,1,ERR=500) LOCAT,CNSTNT,FMTIN,IPRN
    1    FORMAT(I10,F10.0,A20,I10)
      END IF
C
C3------FOR FREE FORMAT CONTROL RECORD, READ REMAINING FIELDS.
      IF(IFREE.NE.0) THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,3,N,CNSTNT,IOUT,IN)
         IF(LOCAT.NE.0) THEN
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
            FMTIN=CNTRL(ISTART:ISTOP)
            IF(INDEX(FMTIN,'BINARY').GT.0) FMTIN='(BINARY)'
            IF(INDEX(FMTIN,'FREE').GT.0) FMTIN='(FREE)'
            IF(ICLOSE.NE.0) THEN
               IF(FMTIN.EQ.'(BINARY)') THEN
                  CALL FNAMSV(FNAME,LOCAT,'OPEN/CLOSE(BINARY)',IUPACK)
               ELSE
                  CALL FNAMSV(FNAME,LOCAT,'OPEN/CLOSE',IUPACK)
               END IF
               WRITE(IOUT,15) LOCAT,FNAME
   15        FORMAT(1X,/1X,'UNIT',I4,' USED FOR OPEN/CLOSE FILE:',/1X,A)
            END IF
            IF(LOCAT.GT.0 .AND. FMTIN.EQ.'(BINARY)') LOCAT=-LOCAT
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,IPRN,R,IOUT,IN)
         END IF
      END IF
C
C4------TEST LOCAT TO SEE HOW TO DEFINE ARRAY VALUES.
      IF(LOCAT) 200,50,90
C
C4A-----LOCAT=0; ALL ARRAY VALUES EQUAL TO CNSTNT. RETURN.
   50 IF(K.GT.0) WRITE(IOUT,2) ANAME,CNSTNT,K
    2 FORMAT(1X,/1X,A,' =',G15.7,' FOR LAYER',I3)
      IF(K.LE.0) WRITE(IOUT,3) ANAME,CNSTNT
    3 FORMAT(1X,/1X,A,' =',G15.7)
      IARRDA(1,NAR)=0
      ARRCON(NAR)=CNSTNT
      RETURN
C
C4B-----LOCAT>0; READ FORMATTED RECORDS USING FORMAT FMTIN.
   90 IF(K.GT.0) THEN
         WRITE(IOUT,94) ANAME,K,LOCAT,FMTIN
   94    FORMAT(1X,/11X,A,' FOR LAYER',I3,/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,95) ANAME,LOCAT,FMTIN
   95    FORMAT(1X,/11X,A,/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      ELSE
         WRITE(IOUT,96) ANAME,LOCAT,FMTIN
   96    FORMAT(1X,/11X,A,' FOR CROSS SECTION',/
     1       1X,'READING ON UNIT',I3,' WITH FORMAT: ',A)
      END IF
      IF(LOCAT.EQ.IN) THEN
         IARRDA(1,NAR)=-1
         IF(IARRDA(2,NAR).EQ.0)
     1       CALL ARRAL2(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
         LOC=IARRDA(2,NAR)
         CALL U2DRRD(JJ,II,X(LOC),FMTIN,IUREAL(LOCAT))
      ELSE
         IF(ICLOSE.EQ.0) CALL FNAMCK(LOCAT,'DATA',IUPACK)
         IARRDA(1,NAR)=LOCAT
         ARRFMT(NAR)=FMTIN
      END IF
      GO TO 300
C
C4C-----LOCAT<0; READ UNFORMATTED ARRAY VALUES.
  200 LOCAT=-LOCAT
      IF(K.GT.0) THEN
         WRITE(IOUT,201) ANAME,K,LOCAT
  201    FORMAT(1X,/11X,A,' FOR LAYER',I4,/
     1    1X,'READING BINARY ON UNIT',I4)
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,202) ANAME,LOCAT
  202    FORMAT(1X,/1X,A,/
     1    1X,'READING BINARY ON UNIT',I4)
      ELSE
         WRITE(IOUT,203) ANAME,LOCAT
  203    FORMAT(1X,/1X,A,' FOR CROSS SECTION',/
     1    1X,'READING BINARY ON UNIT',I4)
      END IF
      IARRDA(1,NAR)=LOCAT
      IF(ICLOSE.EQ.0) CALL FNAMCK(LOCAT,'DATA(BINARY)',IUPACK)
      ARRFMT(NAR)='(BINARY)'
C
C5------IF CNSTNT ZERO THEN SET EQUAL TO 1.0.
  300 ZERO=0.
      IF(CNSTNT.EQ.ZERO) CNSTNT=1.0
      ARRCON(NAR)=CNSTNT
      IARRDA(5,NAR)=IPRN
C
C6------IF PRINT CODE (IPRN) >0 OR =0 THEN PRINT ARRAY VALUES.
      IF(IPRN.GE.0 .AND. IARRDA(1,NAR).EQ.-1)
     1      CALL ULAPRW(X(LOC),ANAME,0,0,JJ,II,0,IPRN,IOUT,CNSTNT)
C
C7------RETURN
      RETURN
C
C8------CONTROL RECORD ERROR.
  500 IF(K.GT.0) THEN
         WRITE(IOUT,501) ANAME,K
  501    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,
     1     ' FOR LAYER',I4,':')
      ELSE
         WRITE(IOUT,502) ANAME
  502    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,':')
      END IF
      WRITE(IOUT,'(1X,A)') CNTRL
C      STOP
      CALL RDABRT
      END
      SUBROUTINE URWORD(LINE,ICOL,ISTART,ISTOP,NCODE,N,R,IOUT,IN)
C
C
C-----VERSION 1003 05AUG1992 URWORD
C     ******************************************************************
C     ROUTINE TO EXTRACT A WORD FROM A LINE OF TEXT, AND OPTIONALLY
C     CONVERT THE WORD TO A NUMBER.
C        ISTART AND ISTOP WILL BE RETURNED WITH THE STARTING AND
C          ENDING CHARACTER POSITIONS OF THE WORD.
C        THE LAST CHARACTER IN THE LINE IS SET TO BLANK SO THAT IF ANY
C          PROBLEMS OCCUR WITH FINDING A WORD, ISTART AND ISTOP WILL
C          POINT TO THIS BLANK CHARACTER.  THUS, A WORD WILL ALWAYS BE
C          RETURNED UNLESS THERE IS A NUMERIC CONVERSION ERROR.  BE SURE
C          THAT THE LAST CHARACTER IN LINE IS NOT AN IMPORTANT CHARACTER
C          BECAUSE IT WILL ALWAYS BE SET TO BLANK.
C        A WORD STARTS WITH THE FIRST CHARACTER THAT IS NOT A SPACE OR
C          COMMA, AND ENDS WHEN A SUBSEQUENT CHARACTER THAT IS A SPACE
C          OR COMMA.  NOTE THAT THESE PARSING RULES DO NOT TREAT TWO
C          COMMAS SEPARATED BY ONE OR MORE SPACES AS A NULL WORD.
C        FOR A WORD THAT BEGINS WITH "'", THE WORD STARTS WITH THE
C          CHARACTER AFTER THE QUOTE AND ENDS WITH THE CHARACTER
C          PRECEDING A SUBSEQUENT QUOTE.  THUS, A QUOTED WORD CAN
C          INCLUDE SPACES AND COMMAS.  THE QUOTED WORD CANNOT CONTAIN
C          A QUOTE CHARACTER.
C        IF NCODE IS 1, THE WORD IS CONVERTED TO UPPER CASE.
C        IF NCODE IS 2, THE WORD IS CONVERTED TO AN INTEGER.
C        IF NCODE IS 3, THE WORD IS CONVERTED TO A REAL NUMBER.
C        NUMBER CONVERSION ERROR IS WRITTEN TO UNIT IOUT IF IOUT IS
C          POSITIVE; ERROR IS WRITTEN TO DEFAULT OUTPUT IF IOUT IS 0;
C          NO ERROR MESSAGE IS WRITTEN IF IOUT IS NEGATIVE.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*(*) LINE
      CHARACTER*20 RW,STRING
C     ------------------------------------------------------------------
C
C1------Set last char in LINE to blank and set ISTART and ISTOP to point
C1------to this blank as a default situation when no word is found.  If
C1------starting location in LINE is out of bounds, do not look for a
C1------word.
      LINLEN=LEN(LINE)
      LINE(LINLEN:LINLEN)=' '
      ISTART=LINLEN
      ISTOP=LINLEN
      LINLEN=LINLEN-1
      IF(ICOL.LT.1 .OR. ICOL.GT.LINLEN) GO TO 100
C
C2------Find start of word, which is indicated by first character that
C2------is not a blank and not a comma.
      DO 10 I=ICOL,LINLEN
      IF(LINE(I:I).NE.' ' .AND. LINE(I:I).NE.',') GO TO 20
10    CONTINUE
      ICOL=LINLEN+1
      GO TO 100
C
C3------Found start of word.  Look for end.
C3A-----When word is quoted, only a quote can terminate it.
20    IF(LINE(I:I).EQ.'''') THEN
         I=I+1
         IF(I.LE.LINLEN) THEN
            DO 25 J=I,LINLEN
            IF(LINE(J:J).EQ.'''') GO TO 40
25          CONTINUE
         END IF
C
C3B-----When word is not quoted, space or comma will terminate.
      ELSE
         DO 30 J=I,LINLEN
         IF(LINE(J:J).EQ.' ' .OR. LINE(J:J).EQ.',') GO TO 40
30       CONTINUE
      END IF
C
C3C-----End of line without finding end of word; set end of word to
C3C-----end of line.
      J=LINLEN+1
C
C4------Found end of word; set J to point to last character in WORD and
C-------set ICOL to point to location for scanning for another word.
40    ICOL=J+1
      J=J-1
      IF(J.LT.I) GO TO 100
      ISTART=I
      ISTOP=J
C
C5------Convert word to upper case and RETURN if NCODE is 1.
      IF(NCODE.EQ.1) THEN
         IDIFF=ICHAR('a')-ICHAR('A')
         DO 50 K=ISTART,ISTOP
            IF(LINE(K:K).GE.'a' .AND. LINE(K:K).LE.'z')
     1             LINE(K:K)=CHAR(ICHAR(LINE(K:K))-IDIFF)
50       CONTINUE
         RETURN
      END IF
C
C6------Convert word to a number if requested.
100   IF(NCODE.EQ.2 .OR. NCODE.EQ.3) THEN
         RW=' '
         L=20-ISTOP+ISTART
         IF(L.LT.1) GO TO 200
         RW(L:20)=LINE(ISTART:ISTOP)
         IF(NCODE.EQ.2) READ(RW,'(I20)',ERR=200) N
         IF(NCODE.EQ.3) READ(RW,'(F20.0)',ERR=200) R
      END IF
      RETURN
C
C7------Number conversion error.
200   IF(NCODE.EQ.3) THEN
         STRING= 'A REAL NUMBER'
         L=13
      ELSE
         STRING= 'AN INTEGER'
         L=10
      END IF
C
C7A-----If output unit is negative, set last character of string to 'E'.
      IF(IOUT.LT.0) THEN
         N=0
         R=0.
         LINE(LINLEN+1:LINLEN+1)='E'
         RETURN
C
C7B-----If output unit is positive; write a message to output unit.
      ELSE IF(IOUT.GT.0) THEN
         IF(IN.GT.0) THEN
            WRITE(IOUT,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(IOUT,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
201      FORMAT(1X,/1X,'FILE UNIT',I4,' : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
202      FORMAT(1X,/1X,'KEYBOARD INPUT : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
C
C7C-----If output unit is 0; write a message to default output.
      ELSE
         IF(IN.GT.0) THEN
            WRITE(*,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(*,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
      END IF
C
C7D-----STOP after writing message.
C      STOP
      CALL RDABRT
      END
      SUBROUTINE ULAYIN(LABEL,ILAY)
C     ******************************************************************
C     Prompt user to enter a layer number
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) LABEL
      CHARACTER*78 CLINE
C     ------------------------------------------------------------------
C
C  Prepare a label for layer number screen
20    WRITE(CLINE,'(A)') LABEL
      CALL ZBLDWR(78,CLINE,1,-1,ISTAT)
      CALL ZMNSST
C  Initialize layer number screen
      CALL Q1INIT(MESSFL,300,7)
C  Set default layer
      CALL QSETI(1,ILAY)
C  Turn on "previous screen" option
      CALL ZSTCMA(4,1)
C  Activate user input
      CALL Q1EDIT(IRET)
C  Turn off "previous screen" option
      CALL ZSTCMA(4,0)
      IF(IRET.EQ.-1) GO TO 20
      IF(IRET.EQ.1) THEN
C  Layer number is accepted -- get number and check for validity
         CALL QGETI(1,ILAY)
         IF(ILAY.GT.NLAY) THEN
C  Invalid layer -- notify user and try again
            CALL PMXTXI(MESSFL,300,6,2,1,0,1,NLAY)
            ILAY=1
            GO TO 20
         END IF
      ELSE
C  No layer number -- go to previous menu
         ILAY=0
      END IF
C
C  Return with valid layer number or 0 to indicate previous screen
      RETURN
      END
      SUBROUTINE UPERIN(LABEL,IPER)
C     ******************************************************************
C     Prompt user to enter a stress period number
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) LABEL
      CHARACTER*78 CLINE
C     ------------------------------------------------------------------
      IF(NPER.EQ.1) THEN
         IPER=1
         RETURN
      END IF
C
C  Prepare a label for stress period screen
20    WRITE(CLINE,'(A)') LABEL
      CALL ZBLDWR(78,CLINE,1,-1,ISTAT)
      CALL ZMNSST
C  Initialize stress period screen
      CALL Q1INIT(MESSFL,300,19)
C  Set default layer
      CALL QSETI(1,IPER)
C  Turn on "previous screen" option
      CALL ZSTCMA(4,1)
C  Activate user input
      CALL Q1EDIT(IRET)
C  Turn off "previous screen" option
      CALL ZSTCMA(4,0)
      IF(IRET.EQ.-1) GO TO 20
      IF(IRET.EQ.1) THEN
C  stress period is accepted -- get number and check for validity
         CALL QGETI(1,IPER)
         IF(IPER.GT.NPER) THEN
C  Invalid stress period -- notify user and try again
            CALL PMXTXI(MESSFL,300,20,2,1,0,1,NPER)
            IPER=1
            GO TO 20
         END IF
      ELSE
C  No stress period number -- go to previous menu
         IPER=0
      END IF
C
C  Return with valid stress period or 0 to indicate previous screen
      RETURN
      END
      SUBROUTINE U2DIN(LABEL,ARRNAM,ILAY,IPER,NCC,NR,IUPACK)
C     ******************************************************************
C     Prompt user for a 2-D array -- real or integer
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) LABEL
      CHARACTER*(*) ARRNAM
      CHARACTER*78 CLINE
      CHARACTER*20 FMT
C     ------------------------------------------------------------------
      NC=NCC
      IF(NCC.LT.0) NC=-NCC
      IREAL=1
      IF(ARRNAM(1:1).EQ.'I') IREAL=0
C  Prepare a label for control record screen
10    IF(ILAY.GT.0) THEN
         WRITE(CLINE,'(A,A,A,I4)')
     1   'Choose method for specifying ',LABEL,' for layer',ILAY
      ELSE IF(IPER.GT.0) THEN
         WRITE(CLINE,'(A,A,A,I4)')
     1   'Choose method for specifying ',LABEL,' for period',IPER
      ELSE
         WRITE(CLINE,'(A,A)')
     1   'Choose method for specifying ',LABEL
      END IF
      CALL ZBLDWR(78,CLINE,1,-1,ISTAT)
      CALL ZMNSST
C  Initialize control record screen
      IF(IPER.LE.1) CALL Q1INIT(MESSFL,300,5)
      IF(IPER.GT.1) CALL Q1INIT(MESSFL,300,26)
C  Find array -- create if it doesn't already exist
      CALL VALGET(ARRNAM,ILAY,IPER,NAR,V)
      IF(NAR.LE.0) THEN
         CALL ARRMAK(ARRNAM,ILAY,IPER,NC,NR)
         NAR=NARRAY
         IF(IREAL.EQ.0) IARRDA(5,NAR)=4
      END IF
C  Define defaults
      NOP=1
      CON1=0.
      CON2=1.
      FMT='(10F8.0)'
      IF(IREAL.EQ.0) FMT='(20I4)'
      CLINE(1:67)=' '
      IPRN=0
      IF(IREAL.EQ.0) IPRN=4
      LOCAT=IARRDA(1,NAR)
      IF(LOCAT.EQ.0) THEN
         IF(IREAL.EQ.0) THEN
            ITMP=ARRCON(NAR)
            IF(ITMP.NE.IMISS) CON1=ARRCON(NAR)
         ELSE
            IF(ARRCON(NAR) .NE. RMISS) CON1=ARRCON(NAR)
         END IF
      ELSE IF(LOCAT.EQ.-1) THEN
         NOP=2
         CON2=ARRCON(NAR)
      ELSE IF(LOCAT.GT.0) THEN
         NOP=3
         CON2=ARRCON(NAR)
         FMT=ARRFMT(NAR)
         CLINE(1:67)=FILNAM(LOCAT)
         IPRN=IARRDA(5,NAR)
      ELSE IF(LOCAT.EQ.-3) THEN
         NOP=4
      END IF
C  Set defaults in screen
      CALL QSETOP(1,1,1,1,NOP)
      CALL QSETRB(1,1,CON1)
      CALL QSETRB(1,2,CON2)
      CALL QSTCTF(1,67,CLINE)
      CALL QSTCTF(2,20,FMT)
      CALL QSETI(1,IPRN)
C  Acitivate user input
      CALL Q1EDIT(IRET)
      IF(IRET.EQ.-1) GO TO 10
C  Store values
      CALL QGETOP(1,NOP)
      IF(NOP.EQ.1) THEN
         IARRDA(1,NAR)=0
         CALL QGETR(1,ARRCON(NAR))
      ELSE IF(NOP.EQ.2) THEN
C  PACKAGE array -- call SS to edit unless NCC<0, which means the caller
C    will use another way of defining the array elements
         IARRDA(1,NAR)=-1
         CALL QGETRB(1,2,ARRCON(NAR))
         IF(IARRDA(2,NAR).EQ.0) THEN
            CALL ARRALO(IARRDA(2,NAR),IARRDA(3,NAR),IARRDA(4,NAR))
            LOC=IARRDA(2,NAR)
            IF(IREAL.NE.0) THEN
               CALL ZIPR(NC*NR,0.,X(LOC))
               IF(NCC.GT.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM)
            ELSE
               CALL ZIPI(NC*NR,1,X(LOC))
               IF(NCC.GT.0) CALL SS2DI(X(LOC),NC,NR,ARRNAM)
            END IF
         ELSE IF(NCC.GT.0) THEN
            LOC=IARRDA(2,NAR)
            I=1
            CALL QRESP(MESSFL,300,8,I)
            IF(I.EQ.1) THEN
               IF(IREAL.NE.0) CALL SS2DR(X(LOC),NC,NR,ARRNAM)
               IF(IREAL.EQ.0) CALL SS2DI(X(LOC),NC,NR,ARRNAM)
            END IF
         END IF
      ELSE IF(NOP.EQ.3) THEN
         CALL QGETRB(1,2,ARRCON(NAR))
         CALL QGETI(1,IARRDA(5,NAR))
         CALL QGTCTF(1,67,CLINE)
         CALL USTLFT(CLINE,67)
         IF(IUCASE.NE.0) CALL USTRUC(CLINE,67)
         CALL QGTCTF(2,20,FMT)
         CALL FMTCHK(FMT,IERR)
         IF(IERR.NE.0) GO TO 10
         ARRFMT(NAR)=FMT
         IF(FMT.EQ.'(BINARY)') THEN
            CALL FNMSV2(CLINE(1:67),IU,0,IUPACK,NAR)
         ELSE
            CALL FNMSV2(CLINE(1:67),IU,1,IUPACK,NAR)
         END IF
         IF(IU.LE.0) GO TO 10
         IARRDA(1,NAR)=IU
      ELSE
         IARRDA(1,NAR)=-3
      END IF
C
      RETURN
      END
      SUBROUTINE U1DRSV(ARRAY,IUNDEF,IFIL,IPACK)
C     ******************************************************************
C     Write a control record for a 1-D real array and if the array is
C     an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY
C
C  Choose between original control records and new
      IF(MODOUT.EQ.0) THEN
         CALL V1DRSV(ARRAY,IUNDEF,IFIL,IPACK)
         RETURN
      END IF
C
C  New control record
      CALL VALGET(ARRAY,0,0,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(IFIL.GT.0) WRITE(IFIL,11) RMISS,ARRAY
11       FORMAT('CONSTANT ',1PE11.3,2X,A)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),ARRAY
         IF(ARRCON(NAR).EQ.RMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(IFIL.GT.0) WRITE(IFIL,11) RMISS,ARRAY
            RETURN
         END IF
         NELEM=IARRDA(3,NAR)
         IF(NELEM.EQ.1) NELEM=IARRDA(4,NAR)
         IF(IFIL.GT.0) WRITE(IFIL,
     1        '(''INTERNAL '',1PE11.3,1X,A,I5,2X,A)')
     2         ARRCON(NAR),'(10F10.0)',IARRDA(5,NAR),ARRAY
         IF(IFIL.GT.0) CALL U1DRWR(X(LOC),NELEM,IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
         IF(IFIL.GT.0) THEN
            LS=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            WRITE(IFIL,20) FILNAM(LOCAT)(1:LS),ARRCON(NAR),
     1                 ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
20          FORMAT('OPEN/CLOSE ',A,1PE11.3,' ''',A,'''',I5,2X,A)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         IF(IFIL.GT.0) THEN
            LF=LENSTR(20,ARRFMT(NAR))
            IF(IUREAL(LOCAT).EQ.0) CALL REALUN(LOCAT)
            WRITE(IFIL,21)
     1   IUREAL(LOCAT),ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
21          FORMAT('EXTERNAL ',I5,1PE11.3,' ''',A,'''',I5,2X,A)
         END IF
         IFNUSE(LOCAT)=IPACK
      END IF
C
      RETURN
      END
      SUBROUTINE V1DRSV(ARRAY,IUNDEF,IFIL,IPACK)
C     ******************************************************************
C     ORIGINAL CONTROL RECORD.
C     Write a control record for a 1-D real array and if the array is
C     an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY
C
      CALL VALGET(ARRAY,0,0,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(IFIL.GT.0) WRITE(IFIL,11) RMISS,ARRAY
11       FORMAT('         0',1PE10.3,32X,A)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),ARRAY
         IF(ARRCON(NAR).EQ.RMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(IFIL.GT.0) WRITE(IFIL,11) RMISS,ARRAY
            RETURN
         END IF
         NELEM=IARRDA(3,NAR)
         IF(NELEM.EQ.1) NELEM=IARRDA(4,NAR)
         IF(IFIL.GT.0) WRITE(IFIL,'(I10,1PE10.3,A20,I10,2X,A)')
     1       IUREAL(IPACK),ARRCON(NAR),' (10F10.0)',IARRDA(5,NAR),ARRAY
         IF(IFIL.GT.0) CALL U1DRWR(X(LOC),NELEM,IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
C  An open/close file is being used even though the original modflow cannot
C  deal with such files.  Go ahead and write an open/close control record,
C  which will cause modflow to abort; but mfi will still be able to
C  read the dataset.
         IF(IFIL.GT.0) THEN
            LS=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            WRITE(IFIL,20) FILNAM(LOCAT)(1:LS),ARRCON(NAR),
     1                 ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
20          FORMAT('OPEN/CLOSE ',A,1PE11.3,' ''',A,'''',I5,2X,A)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         IF(IFIL.GT.0) THEN
            IF(IUREAL(LOCAT).EQ.0) CALL REALUN(LOCAT)
            WRITE(IFIL,21)
     1   IUREAL(LOCAT),ARRCON(NAR),ARRFMT(NAR),IARRDA(5,NAR),ARRAY
21          FORMAT(I10,1PE10.3,A,I10,2X,A)
         END IF
         IFNUSE(LOCAT)=IPACK
      END IF
C
      RETURN
      END
      SUBROUTINE U2DRSV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK,LABARR,LABLAY)
C     ******************************************************************
C     Write a control record for a 2-D real array and if the array is
C     an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY,LABARR
C  Choose between original control records and new
      IF(MODOUT.EQ.0) THEN
         CALL V2DRSV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK,LABARR,LABLAY)
         RETURN
      END IF
C
C  New control record
      CALL VALGET(ARRAY,KK,KPER,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR,
     1              LABLAY
11       FORMAT('CONSTANT ',1PE11.3,2X,A,:,' layer',I3)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),
     1              LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),
     1              LABARR,LABLAY
         IF(ARRCON(NAR).EQ.RMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR
            IF(LABLAY.GT.0 .AND. IFIL.GT.0)
     1                 WRITE(IFIL,11) RMISS,ARRAY,LABLAY
            RETURN
         END IF
         IF(LABLAY.LE.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) ARRCON(NAR),'(10F10.0)',IARRDA(5,NAR),LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) ARRCON(NAR),'(10F10.0)',IARRDA(5,NAR),LABARR,
     2             LABLAY
21       FORMAT('INTERNAL ',1PE11.3,1X,A,I5,2X,A,:,' layer',I3)
         IF(IFIL.GT.0)
     1           CALL U2DRWR(X(LOC),IARRDA(3,NAR),IARRDA(4,NAR),IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
         IF(IFIL.GT.0) THEN
            LS=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            IF(LABLAY.LE.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LS),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR
            IF(LABLAY.GT.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LS),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR,LABLAY
25          FORMAT
     1   ('OPEN/CLOSE ',A,1PE11.3,' ''',A,'''',I5,2X,A,:,' layer',I3)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         LF=LENSTR(20,ARRFMT(NAR))
         IF(IUREAL(LOCAT).EQ.0 .AND. IFIL.GT.0) CALL REALUN(LOCAT)
         IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,31) IUREAL(LOCAT),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,31) IUREAL(LOCAT),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR,LABLAY
31       FORMAT
     1   ('EXTERNAL ',I5,1PE11.3,' ''',A,'''',I5,2X,A,:,' layer',I3)
         IFNUSE(LOCAT)=IPACK
      END IF
      RETURN
      END
      SUBROUTINE V2DRSV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK,LABARR,LABLAY)
C     ******************************************************************
C     FOR ORIGINAL MODEL CONTROL RECORDS.
C     Write a control record for a 2-D real array and if the array is
C     an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY,LABARR
C
      CALL VALGET(ARRAY,KK,KPER,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR,
     1             LABLAY
11       FORMAT('         0',1PE10.3,32X,A,:,' layer',I3)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),
     1             LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ARRCON(NAR),
     1             LABARR,LABLAY
         IF(ARRCON(NAR).EQ.RMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) RMISS,LABARR
            IF(LABLAY.GT.0 .AND. IFIL.GT.0)
     1                 WRITE(IFIL,11) RMISS,LABARR,LABLAY
            RETURN
         END IF
         IF(LABLAY.LE.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) IUREAL(IPACK),ARRCON(NAR),IARRDA(5,NAR),LABARR
         IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,21) IUREAL(IPACK),
     1                         ARRCON(NAR),IARRDA(5,NAR),LABARR,LABLAY
21       FORMAT(I10,1PE10.3,' (10F10.0)          ',I10,2X,A,
     1                   :,' layer',I3)
         IF(IFIL.GT.0)
     1           CALL U2DRWR(X(LOC),IARRDA(3,NAR),IARRDA(4,NAR),IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
C  An open/close file is being used even though the original modflow cannot
C  deal with such files.  Go ahead and write an open/close control record,
C  which will cause modflow to abort; but mfi will still be able to
C  read the dataset.
         IF(IFIL.GT.0) THEN
            LS=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            IF(LABLAY.LE.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LS),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR
            IF(LABLAY.GT.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LS),
     1        ARRCON(NAR),ARRFMT(NAR)(1:LF),IARRDA(5,NAR),LABARR,LABLAY
25          FORMAT
     1   ('OPEN/CLOSE ',A,1PE11.3,' ''',A,'''',I5,2X,A,:,' layer',I3)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         IF(IUREAL(LOCAT).EQ.0 .AND. IFIL.GT.0) CALL REALUN(LOCAT)
         IF(ARRFMT(NAR).EQ.'(BINARY)') THEN
            IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,31)
     1        -IUREAL(LOCAT),ARRCON(NAR),IARRDA(5,NAR),LABARR
            IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,31)
     1        -IUREAL(LOCAT),ARRCON(NAR),IARRDA(5,NAR),LABARR,LABLAY
         ELSE
            IF(LABLAY.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,32)
     1        IUREAL(LOCAT),ARRCON(NAR),ARRFMT(NAR),IARRDA(5,NAR),LABARR
            IF(LABLAY.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,32)
     1        IUREAL(LOCAT),ARRCON(NAR),ARRFMT(NAR),IARRDA(5,NAR),
     2        LABARR,LABLAY
         END IF
31       FORMAT(I10,1PE10.3,20X,I10,2X,A,:,' layer',I3)
32       FORMAT(I10,1PE10.3,A,I10,2X,A,:,' layer',I3)
         IFNUSE(LOCAT)=IPACK
      END IF
      RETURN
      END
      SUBROUTINE U2DISV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK)
C     ******************************************************************
C     Write a control record for a 2-D integer array and if the array
C     is an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY
C
C  Choose between original control record and new
      IF(MODOUT.EQ.0) THEN
         CALL V2DISV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK)
         RETURN
      END IF
C
C  New control record
      CALL VALGET(ARRAY,KK,KPER,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY,KK
11       FORMAT('CONSTANT ',I10,2X,A,:,' layer',I3)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
      ICON=ARRCON(NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ICON,ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ICON,ARRAY,KK
         IF(ICON.EQ.IMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY
            IF(KK.GT.0 .AND. IFIL.GT.0)
     1                  WRITE(IFIL,11) IMISS,ARRAY,KK
            RETURN
         END IF
         IF(KK.LE.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) ICON,'(20I4)',IARRDA(5,NAR),ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) ICON,'(20I4)',IARRDA(5,NAR),ARRAY,KK
21       FORMAT('INTERNAL ',I10,1X,A,I5,2X,A,:,' layer',I3)
         IF(IFIL.GT.0)
     1           CALL U2DIWR(X(LOC),IARRDA(3,NAR),IARRDA(4,NAR),IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
         IF(IFIL.GT.0) THEN
            LN=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            IF(KK.LE.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LN),
     1        ICON,ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
            IF(KK.GT.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LN),
     1        ICON,ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY,KK
25       FORMAT('OPEN/CLOSE ',A,I10,' ''',A,'''',I5,2X,A,:,' layer',I3)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         LF=LENSTR(20,ARRFMT(NAR))
         IF(IUREAL(LOCAT).EQ.0 .AND. IFIL.GT.0) CALL REALUN(LOCAT)
         IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,31) IUREAL(LOCAT),ICON,
     1        ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,31) IUREAL(LOCAT),ICON,
     1        ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY,KK
31       FORMAT('EXTERNAL ',I5,I10,' ''',A,'''',I5,2X,A,:,' layer',I3)
         IFNUSE(LOCAT)=IPACK
      END IF
      RETURN
      END
      SUBROUTINE V2DISV(ARRAY,KK,KPER,IUNDEF,IFIL,IPACK)
C     ******************************************************************
C     ORIGINAL CONTROL RECORD
C     Write a control record for a 2-D integer array and if the array
C     is an INTERNAL array, write the array.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) ARRAY
C
      CALL VALGET(ARRAY,KK,KPER,NAR,DUM)
      IF(NAR.LE.0) THEN
         IUNDEF=1
         IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY,KK
11       FORMAT('         0',I10,32X,A,:,' layer',I3)
         RETURN
      END IF
      LOC=IARRDA(2,NAR)
      LOCAT=IARRDA(1,NAR)
      ICON=ARRCON(NAR)
C
      IF(LOCAT.EQ.0) THEN
         IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ICON,ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,11) ICON,ARRAY,KK
         IF(ICON.EQ.IMISS) IUNDEF=1
      ELSE IF(LOCAT.EQ.-1) THEN
         IF(IARRDA(2,NAR).EQ.0) THEN
            IUNDEF=1
            IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,11) IMISS,ARRAY
            IF(KK.GT.0 .AND. IFIL.GT.0)
     1                  WRITE(IFIL,11) IMISS,ARRAY,KK
            RETURN
         END IF
         IF(KK.LE.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) IUREAL(IPACK),ICON,4,ARRAY
         IF(KK.GT.0 .AND. IFIL.GT.0)
     1     WRITE(IFIL,21) IUREAL(IPACK),ICON,4,ARRAY,KK
21       FORMAT(I10,I10,' (20I4)             ',I10,2X,A,:,' layer',I3)
         IF(IFIL.GT.0)
     1           CALL U2DIWR(X(LOC),IARRDA(3,NAR),IARRDA(4,NAR),IFIL)
      ELSE IF(FILTYP(LOCAT)(1:10).EQ.'OPEN/CLOSE') THEN
C  An open/close file is being used even though the original modflow cannot
C  deal with such files.  Go ahead and write an open/close control record,
C  which will cause modflow to abort; but mfi will still be able to
C  read the dataset.
         IF(IFIL.GT.0) THEN
            LN=LENSTR(80,FILNAM(LOCAT))
            LF=LENSTR(20,ARRFMT(NAR))
            IF(KK.LE.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LN),
     1        ICON,ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY
            IF(KK.GT.0) WRITE(IFIL,25) FILNAM(LOCAT)(1:LN),
     1        ICON,ARRFMT(NAR)(1:LF),IARRDA(5,NAR),ARRAY,KK
25       FORMAT('OPEN/CLOSE ',A,I10,' ''',A,'''',I5,2X,A,:,' layer',I3)
         END IF
         IFNUSE(LOCAT)=IPACK
      ELSE
         IF(IUREAL(LOCAT).EQ.0 .AND. IFIL.GT.0) CALL REALUN(LOCAT)
         IF(ARRFMT(NAR).EQ.'(BINARY)') THEN
            IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,31)
     1          -IUREAL(LOCAT),ICON,IARRDA(5,NAR),ARRAY
            IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,31)
     1          -IUREAL(LOCAT),ICON,IARRDA(5,NAR),ARRAY,KK
         ELSE
            IF(KK.LE.0 .AND. IFIL.GT.0) WRITE(IFIL,32)
     1           IUREAL(LOCAT),ICON,ARRFMT(NAR),IARRDA(5,NAR),ARRAY
            IF(KK.GT.0 .AND. IFIL.GT.0) WRITE(IFIL,32)
     1           IUREAL(LOCAT),ICON,ARRFMT(NAR),IARRDA(5,NAR),ARRAY,KK
         END IF
31       FORMAT(I10,I10,20X,I10,2X,A,:,' layer',I3)
32       FORMAT(I10,I10,A,I10,2X,A,:,' layer',I3)
         IFNUSE(LOCAT)=IPACK
      END IF
      RETURN
      END
      SUBROUTINE U1DRWR(A,JJ,IFIL)
C     ******************************************************************
C     Write a formatted 1-D real array
C     ******************************************************************
      DIMENSION A(JJ)
C
      WRITE(IFIL,'(1P,10E10.3)') (A(J),J=1,JJ)
      RETURN
      END
      SUBROUTINE U2DRWR(A,JJ,II,IFIL)
C     ******************************************************************
C     Write a formatted 2-D real array
C     ******************************************************************
      DIMENSION A(JJ,II)
C
      DO 10 I=1,II
      WRITE(IFIL,'(1P,10E10.3)') (A(J,I),J=1,JJ)
10    CONTINUE
      RETURN
      END
      SUBROUTINE U2DIWR(IA,JJ,II,IFIL)
C     ******************************************************************
C     Write a formatted 2-D integer array
C     ******************************************************************
      DIMENSION IA(JJ,II)
C
      DO 10 I=1,II
      DO 10 J=1,JJ
      IF(IA(J,I).GT.9999) IA(J,I)=9999
      IF(IA(J,I).LT.-999) IA(J,I)=-999
10    CONTINUE
C
      DO 20 I=1,II
      WRITE(IFIL,'(20I4)') (IA(J,I),J=1,JJ)
20    CONTINUE
      RETURN
      END
      SUBROUTINE USTLFT(C,NC)
C     ******************************************************************
C     Left justify a string and remove intervening blanks.
C     ******************************************************************
      CHARACTER*1 C(NC)
C
      IMV=0
      DO 10 I=1,NC
      IF(C(I).NE.' ') THEN
         IMV=IMV+1
         IF(IMV.NE.I) THEN
            C(IMV)=C(I)
            C(I)=' '
         END IF
      END IF
10    CONTINUE
      RETURN
      END
      SUBROUTINE USTRUC(C,NC)
C     ******************************************************************
C     Convert a string to upper case.
C     ******************************************************************
      CHARACTER*1 C(NC)
C
      IDIFF=ICHAR('a')-ICHAR('A')
      DO 10 I=1,NC
      IF(C(I).GE.'a' .AND. C(I).LE.'z') C(I)=CHAR(ICHAR(C(I))-IDIFF)
10    CONTINUE
      RETURN
      END
      SUBROUTINE USTRLC(C,NC)
C     ******************************************************************
C     Convert a string to lower case.
C     ******************************************************************
      CHARACTER*1 C(NC)
C
      IDIFF=ICHAR('a')-ICHAR('A')
      DO 10 I=1,NC
      IF(C(I).GE.'A' .AND. C(I).LE.'Z') C(I)=CHAR(ICHAR(C(I))+IDIFF)
10    CONTINUE
      RETURN
      END
      SUBROUTINE DSPTXT(MESFL,ISCLU,ISGRP,CTXT,NTEXT,IC)
C     ******************************************************************
C     This routine prints text from a message file and from the
C     argument CTXT to a terminal.
C     ******************************************************************
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*(*) CTXT(45)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESFL - Fortran unit number for WDM file
C     ISCLU  - screen cluster number on WDM-message file
C     ISGRP  - screen group number in cluster
C     CTXT  - Text to be added to screen
C     NTXT  - Number of strings in CTXT
C     IC    - Number of characters in each string of CTXT
C
      CHARACTER*78 TXT
C     + + + END SPECIFICATIONS + + +
C
      NTXT=NTEXT
C
C  Initialize the menu for a list of missing data
      LINIT= 1
      LWRT= -1
      CALL ZTXINI
      INITFG= 1
C
C  Loop that displays lines from message file
C  Get a line
10      IOLEN=78
        CALL WMSGTT (MESFL,ISCLU,ISGRP,INITFG,
     M               IOLEN,
     O               TXT,ICONT)
        INITFG= 0
C
C Display the line
        I= LENSTR (78,TXT)
        IF (I.EQ.0) I= 1
        CALL ZBLDWR (I,TXT,LINIT,LWRT,
     O               IDFLG)
        LINIT= 0
C  Repeat if not the last line
      IF (ICONT.EQ.1) GO TO 10
C
C  Done with text from message file -- Add text from CTXT if it exists
      IF(NTXT.GT.0) THEN
         IF(NTXT.GT.45) NTXT=45
         IF(NTXT.GT.1) THEN
            DO 200 I=1,NTXT-1
            CALL ZBLDWR(IC,CTXT(I),LINIT,LWRT,IDFLG)
200         CONTINUE
         END IF
         LWRT=0
         CALL ZBLDWR(IC,CTXT(NTXT),LINIT,LWRT,IDFLG)
C
C  Finish displaying the screen when there is no text in CTXT
      ELSE
         LWRT=0
         CALL ZBLDWR(1,' ',LINIT,LWRT,IDFLG)
      END IF
C
      RETURN
      END
      SUBROUTINE LSTSAV(CARRAY,IFIL,MXLST,ITMPUN,CAUX,NCAUX,COMMNT)
C     ******************************************************************
C     Write a list with auxiliary data values -- reuse previous
C     values if possible.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) CARRAY
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*(*) COMMNT
      DIMENSION IX(LENX)
      EQUIVALENCE (X,IX)
      CHARACTER*10 FIELD
      CHARACTER*90 RECORD
      CHARACTER*70 AUX
C     ------------------------------------------------------------------
C
C  Write first record (containing the maximum number of entries in any list)
      AUX(1:1)=' '
      NAUX=1
      IF(IUNIT(40).GT.0) THEN
         NAUX=16
         AUX(1:NAUX)=' AUXILIARY IFACE'
      END IF
      IF(CAUX(2).NE.' ') THEN
         NA1=NAUX+1
         NAUX=NA1+26
         AUX(NA1:NAUX)=' AUXILIARY '//CAUX(2)
      END IF
      IF(CAUX(3).NE.' ') THEN
         NA1=NAUX+1
         NAUX=NA1+26
         AUX(NA1:NAUX)=' AUXILIARY '//CAUX(3)
      END IF
      IF(IUNIT(15).GT.0) THEN
         WRITE(IFIL,'(2I10,3A)') MXLST,ITMPUN,AUX(1:NAUX),' CBC',COMMNT
      ELSE
         WRITE(IFIL,'(2I10,2A)') MXLST,ITMPUN,AUX(1:NAUX),COMMNT
      END IF
C
C  Write a list for each stress period
      DO 100 KPER=1,NPER
      CALL IVLGET(CARRAY,0,KPER,NAR,NLIST)
      IF(NAR.GT.0) THEN
C  Data are defined --  Ready to write list -- start with ITMP
         LSTDIM=IARRDA(3,NAR)
         NMFLOW=LSTDIM-NCAUX
         WRITE(IFIL,'(I10,A,I4)')
     1       NLIST,'           ITMP -- Stress Period',KPER
         IF(NLIST.GT.0) THEN
            LOC=IARRDA(2,NAR)
            DO 50 M=1,NLIST
            IGROUP=(M-1)/MXLIST + 1
            L=IX(LOC+IGROUP-1) + (M-1 - (IGROUP-1)*MXLIST)*LSTDIM
C  Get layer, row, column values
            K=X(L)
            I=X(L+1)
            J=X(L+2)
            WRITE(RECORD,'(3I10)') K,I,J
            NREC=30
C  Get real values preceding IFACE
            DO 40 N=3,NMFLOW-1
            CALL UWRFLD(X(L+N),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
40          CONTINUE
C  Get IFACE if appropriate
            IF(IUNIT(40).GT.0) THEN
               IFACE=X(L+NMFLOW)
               WRITE(FIELD,'(I10)') IFACE
               N1=NREC+1
               NREC=NREC+10
               RECORD(N1:NREC)=FIELD
            END IF
C  Get auxiliary parameters after IFACE
            DO 45 N=2,NCAUX
            IF(CAUX(N).NE.' ') THEN
            CALL UWRFLD(X(L+NMFLOW+N-1),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
            END IF
45          CONTINUE
C  Write record
            WRITE(IFIL,'(A)') RECORD(1:NREC)
50          CONTINUE
         END IF
      ELSE
C  Missing data
         WRITE(IFIL,'(I10,A,I4)')
     1        IMISS,'           ITMP -- Stress Period',KPER
      END IF
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE UWRFLD(X,FIELD)
C     ******************************************************************
C     Write a real number as a 9-digit value plus a leading space.
C     Attempt to get 4 significant digits.  This is possible if the
C     value is positive, has only a 1-digit exponent, or the exponent
C     is positive.
C     ******************************************************************
      CHARACTER*10 FIELD,FTMP
C
C  Try 4 significant digits first.
      WRITE(FTMP,'(1PE10.3)') X
C  If it is a positive number, it will already have a leading space, so
C  it can be used as is.
      IF(FTMP(1:1).EQ.' ') THEN
         FIELD=FTMP
         RETURN
C  If it has an exponent less than 10, the tens digit will be 0, which
C  can be eliminated.
      ELSE IF(FTMP(9:9).EQ.'0') THEN
         FIELD(1:1)=' '
         FIELD(2:9)=FTMP(1:8)
         FIELD(10:10)=FTMP(10:10)
         RETURN
C  If the exponent is positive, the exponent sign can be eliminated.
      ELSE IF(FTMP(8:8).EQ.'+') THEN
         FIELD(1:1)=' '
         FIELD(2:8)=FTMP(1:7)
         FIELD(9:10)=FTMP(9:10)
         RETURN
      END IF
C
C  Use 3 significant digits
      WRITE(FIELD,'(1PE10.2)') X
      RETURN
      END
      SUBROUTINE LSTMAX(CNLIST,IWRFLG,IUNDEF,MXLST,CPACK)
C     ******************************************************************
C     Find undefined data and maximum number of rivers in all periods
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) CNLIST,CPACK
C
      IHEAD=0
      MXLST=1
      DO 10 KPER=1,NPER
      CALL IVLGET(CNLIST,0,KPER,ITYPE,NLIST)
      IF(ITYPE.GE.0) THEN
         IF(NLIST.GT.MXLST) MXLST=NLIST
      ELSE
         IUNDEF=1
         IF(IWRFLG.LT.0 .AND. NMISS.LT.45 .AND.IHEAD.EQ.0) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)='Stress periods in which '//CPACK//
     1            ' data are missing:'
            IHEAD=1
         END IF
         IF(NMISS.LT.45 .AND. IWRFLG.LT.0) THEN
            NMISS=NMISS+1
            WRITE(CTEXT(NMISS),'(I30,20X)') KPER
         END IF
      END IF
10    CONTINUE
      IF(IUNDEF.EQ.0 .AND. IWRFLG.LT.0 .AND. NMISS.LT.45) THEN
         NMISS=NMISS+1
         CTEXT(NMISS)='ALL DATA ARE DEFINED FOR '//CPACK//' PACKAGE'
      END IF
C
      RETURN
      END
      SUBROUTINE LSTRD(NLIST,NAR,IXLOC,IN,LABEL,CAUX,NCAUX)
C     ******************************************************************
C     Read and print a list.  NCAUX of the values in the list are
C     optional -- auxiliary data.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) LABEL
      DIMENSION IXLOC(10)
      CHARACTER*16 CAUX(NCAUX)
      DIMENSION VAL(10)
      CHARACTER*100 LINE
      CHARACTER*120 BUF
      CHARACTER*16 CTMP
      CHARACTER*1 DASH(120)
      DATA DASH/120*'-'/
C
      NGROUP=(NLIST-1)/MXLIST + 1
      CALL LSTAL2(NAR,NGROUP)
      NWIDTH=IARRDA(3,NAR)
      NMFLOW=NWIDTH-NCAUX
C
      NVAL=NMFLOW+NCAUX
C  If IFACE is not a parameter, initialize its value to 0.
      VAL(NMFLOW+1)=0.
      BUF=LABEL
      NBUF=LEN(LABEL)+3
      DO 10 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
         N1=NBUF+1
         NBUF=NBUF+16
         BUF(N1:NBUF)=CAUX(I)
      END IF
10    CONTINUE
      WRITE(IOUT,103) BUF(1:NBUF)
      WRITE(IOUT,104) (DASH(J),J=1,NBUF)
  103 FORMAT('0',A)
  104 FORMAT(1X,120A)
C
      DO 250 II=1,NLIST
      IGROUP=(II-1)/MXLIST + 1
      LOC=IXLOC(IGROUP) + (II-1-(IGROUP-1)*MXLIST)*NWIDTH - 1
C  Read a line into a buffer
      READ(IUREAL(IN),'(A)') LINE
C  Start by reading NMFLOW values
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(3I10,9F10.0)') K,I,J,(VAL(JJ),JJ=4,NMFLOW)
         LLOC=NMFLOW*10+1
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,K,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,I,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,J,R,IOUT,IN)
         DO 200 N=4,NMFLOW
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,VAL(N),IOUT,IN)
200      CONTINUE
      END IF
      WRITE(BUF,205) II,K,I,J,(VAL(JJ),JJ=4,NMFLOW)
205   FORMAT(1X,I6,I7,I7,I6,3G13.4)
      NBUF=27+(NMFLOW-3)*13
C
C  Read any optional parameters
      DO 225 KK=1,NCAUX
      IF(CAUX(KK).NE.' ') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,AUX,-1,IN)
         VAL(NMFLOW+KK)=AUX
         WRITE(CTMP,'(G16.4)') AUX
         N1=NBUF+1
         NBUF=NBUF+16
         BUF(N1:NBUF)=CTMP
      END IF
225   CONTINUE
C  Write the values that were read
      WRITE(IOUT,'(A)') BUF(1:NBUF)
C
C  Check for illegal grid location
      IF(K.LT.1 .OR. K.GT.NLAY) THEN
         WRITE(IOUT,*) ' Layer number is outside of the grid'
         CALL RDABRT
      END IF
      IF(I.LT.1 .OR. I.GT.NROW) THEN
         WRITE(IOUT,*) ' Row number is outside of the grid'
         CALL RDABRT
      END IF
      IF(J.LT.1 .OR. J.GT.NCOL) THEN
         WRITE(IOUT,*) ' Column number is outside of the grid'
         CALL RDABRT
      END IF
C
C  Move the values into storage
      IF(II.GT.MXLIST*10) GO TO 250
      VAL(1)=K
      VAL(2)=I
      VAL(3)=J
      DO 240 KK=1,NVAL
      X(LOC+KK)=VAL(KK)
  240 CONTINUE
  250 CONTINUE
C
      RETURN
      END
      SUBROUTINE FMTCHK(FMT,IERR)
C     ******************************************************************
C     Check a format statement for validity.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) FMT
      CHARACTER*80 TMP
C
C  Convert to uppercase and left justify.
      IERR=0
      LENFMT=LEN(FMT)
      CALL USTLFT(FMT,LENFMT)
      CALL USTRUC(FMT,LENFMT)
C
C  Look for special case of BINARY (unformatted).
      IF(FMT.EQ.' ' .OR. INDEX(FMT,'BINARY').GT.0) FMT='(BINARY)'
C
C  Look for special case of FREE (list-directed).
      IF(INDEX(FMT,'FREE').GT.0) FMT='(FREE)'
C
C  Check for starting and ending parentheses -- add missing values if
C  there is room.
      DO 10 I=LENFMT,1,-1
      IF(FMT(I:I).NE.' ') GO TO 15
10    CONTINUE
15    NC=I
C
      IF(FMT(1:1).NE.'(') THEN
         IF(NC.LT.LENFMT) THEN
            TMP=FMT
            FMT(1:1)='('
            NC=NC+1
            FMT(2:NC)=TMP
         ELSE
            CALL PRNTXT(MESSFL,300,30)
            IERR=1
            RETURN
         END IF
      END IF
C
      IF(FMT(NC:NC).NE.')') THEN
         IF(NC.LT.LENFMT) THEN
            NC=NC+1
            FMT(NC:NC)=')'
         ELSE
            CALL PRNTXT(MESSFL,300,30)
            IERR=1
            RETURN
         END IF
      END IF
C
C  Check for unbalanced parentheses
      NLFT=0
      NRGHT=0
      DO 20 I=1,NC
      IF(FMT(I:I).EQ.'(') NLFT=NLFT+1
      IF(FMT(I:I).EQ.')') NRGHT=NRGHT+1
20    CONTINUE
      IF(NRGHT.EQ.NLFT) RETURN
      CALL PRNTXT(MESSFL,300,31)
      IERR=1
      RETURN
C
      END
      SUBROUTINE U2DRDM(ANAME,II,JJ,K,IN)
C
C-----DUMMY VERSION of U2DREL for reading an array and throwing away
C     the data
C     ******************************************************************
C     ROUTINE TO INPUT 2-D REAL DATA MATRICES
C       ANAME IS 24 CHARACTER DESCRIPTION OF A
C       II IS NO. OF ROWS
C       JJ IS NO. OF COLS
C       K IS LAYER NO. (USED WITH NAME TO TITLE PRINTOUT --)
C              IF K=0, NO LAYER IS PRINTED
C              IF K<0, CROSS SECTION IS PRINTED)
C       IN IS INPUT UNIT
C       IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      CHARACTER*24 ANAME
      CHARACTER*20 FMTIN
      CHARACTER*80 CNTRL
      CHARACTER*80 FNAME
C     ------------------------------------------------------------------
C
C1------READ ARRAY CONTROL RECORD AS CHARACTER DATA.
      READ(IUREAL(IN),'(A)') CNTRL
C
C2------LOOK FOR ALPHABETIC WORD THAT INDICATES THAT THE RECORD IS FREE
C2------FORMAT.  SET A FLAG SPECIFYING IF FREE FORMAT OR FIXED FORMAT.
      IFREE=1
      ICOL=1
      CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF (CNTRL(ISTART:ISTOP).EQ.'CONSTANT') THEN
         LOCAT=0
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'INTERNAL') THEN
         LOCAT=IN
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'EXTERNAL') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,LOCAT,R,IOUT,IN)
      ELSE IF(CNTRL(ISTART:ISTOP).EQ.'OPEN/CLOSE') THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,0,N,R,IOUT,IN)
         LOCAT=IUMISC
         FNAME=CNTRL(ISTART:ISTOP)
         WRITE(IOUT,15) LOCAT,FNAME
   15    FORMAT(1X,/1X,'UNIT',I4,' USED FOR OPEN/CLOSE FILE:',/1X,A)
      ELSE
C
C2A-----DID NOT FIND A RECOGNIZED WORD, SO NOT USING FREE FORMAT.
C2A-----READ THE CONTROL RECORD THE ORIGINAL WAY.
         IFREE=0
         READ(CNTRL,1,ERR=500) LOCAT,CNSTNT,FMTIN,IPRN
    1    FORMAT(I10,F10.0,A20,I10)
      END IF
C
C3------FOR FREE FORMAT CONTROL RECORD, READ REMAINING FIELDS.
      IF(IFREE.NE.0) THEN
         CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,3,N,CNSTNT,IOUT,IN)
         IF(LOCAT.NE.0) THEN
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,1,N,R,IOUT,IN)
            FMTIN=CNTRL(ISTART:ISTOP)
            IF(INDEX(FMTIN,'BINARY').GT.0) FMTIN='(BINARY)'
            IF(INDEX(FMTIN,'FREE').GT.0) FMTIN='(FREE)'
            IF(LOCAT.GT.0 .AND. FMTIN.EQ.'(BINARY)') LOCAT=-LOCAT
            CALL URWORD(CNTRL,ICOL,ISTART,ISTOP,2,IPRN,R,IOUT,IN)
         END IF
      END IF
C
C4------TEST LOCAT TO SEE HOW TO DEFINE ARRAY VALUES.
      IF(LOCAT) 200,50,90
C
C4A-----LOCAT=0; ALL ARRAY VALUES EQUAL TO CNSTNT. RETURN.
   50 IF(K.GT.0) WRITE(IOUT,2) ANAME,CNSTNT,K
    2 FORMAT(1X,/1X,A,' =',G15.7,' FOR LAYER',I3,' -- IGNORED ARRAY')
      IF(K.LE.0) WRITE(IOUT,3) ANAME,CNSTNT
    3 FORMAT(1X,/1X,A,' =',G15.7,' -- IGNORED ARRAY')
      RETURN
C
C4B-----LOCAT>0; READ FORMATTED RECORDS USING FORMAT FMTIN.
   90 IF(K.GT.0) THEN
         WRITE(IOUT,94) ANAME,K,LOCAT,FMTIN
   94    FORMAT(1X,/11X,A,' FOR LAYER',I3,/
     1   1X,'READING ON UNIT',I3,' WITH FORMAT: ',A,' -- IGNORED ARRAY')
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,95) ANAME,LOCAT,FMTIN
   95    FORMAT(1X,/11X,A,/
     1   1X,'READING ON UNIT',I3,' WITH FORMAT: ',A,' -- IGNORED ARRAY')
      ELSE
         WRITE(IOUT,96) ANAME,LOCAT,FMTIN
   96    FORMAT(1X,/11X,A,' FOR CROSS SECTION',/
     1   1X,'READING ON UNIT',I3,' WITH FORMAT: ',A,' -- IGNORED ARRAY')
      END IF
      IF(LOCAT.EQ.IN) THEN
         DO 100 I=1,II
         READ(IUREAL(LOCAT),FMTIN) (DUMMY,J=1,JJ)
100      CONTINUE
      END IF
      GO TO 300
C
C4C-----LOCAT<0; READ UNFORMATTED ARRAY VALUES.
  200 LOCAT=-LOCAT
      IF(K.GT.0) THEN
         WRITE(IOUT,201) ANAME,K,LOCAT
  201    FORMAT(1X,/11X,A,' FOR LAYER',I4,/
     1    1X,'READING BINARY ON UNIT',I4,' -- IGNORED ARRAY')
      ELSE IF(K.EQ.0) THEN
         WRITE(IOUT,202) ANAME,LOCAT
  202    FORMAT(1X,/1X,A,/
     1    1X,'READING BINARY ON UNIT',I4,' -- IGNORED ARRAY')
      ELSE
         WRITE(IOUT,203) ANAME,LOCAT
  203    FORMAT(1X,/1X,A,' FOR CROSS SECTION',/
     1    1X,'READING BINARY ON UNIT',I4,' -- IGNORED ARRAY')
      END IF
C
C7------RETURN
  300 RETURN
C
C8------CONTROL RECORD ERROR.
  500 IF(K.GT.0) THEN
         WRITE(IOUT,501) ANAME,K
  501    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,
     1     ' FOR LAYER',I4,':')
      ELSE
         WRITE(IOUT,502) ANAME
  502    FORMAT(1X,/1X,'ERROR READING ARRAY CONTROL RECORD FOR ',A,':')
      END IF
      WRITE(IOUT,'(1X,A)') CNTRL
C      STOP
      CALL RDABRT
      END
      SUBROUTINE STRHED(IHEAD,CPACK)
C     ******************************************************************
C     Write a missing data header for areal stress packages
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*(*) CPACK
C
      IF(NMISS.LT.45) THEN
          NMISS=NMISS+1
          CTEXT(NMISS)='     Missing '//CPACK//' data:'
      END IF
      IF(NMISS.LT.43) THEN
          NMISS=NMISS+1
          CTEXT(NMISS)='MISSING        STRESS'
          NMISS=NMISS+1
          CTEXT(NMISS)='PARAMETER      PERIOD'
          NMISS=NMISS+1
          CTEXT(NMISS)='---------------------'
      END IF
C
      IHEAD=1
      RETURN
      END
