      SUBROUTINE WELAL(IBDSAM,INMP)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR WELLS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      CHARACTER*90 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(2)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NWELLS.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'WEL -- WELL PACKAGE,',
     1       ' INPUT READ FROM UNIT',I3)
C
C2------READ MAXIMUM NUMBER OF WELLS AND UNIT OR FLAG FOR
C2------CELL-BY-CELL FLOW TERMS.
      READ(IUREAL(IN),'(A)') LINE
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(2I10)') MXWELL,IWELCB
         LLOC=21
      ELSE
         LLOC=1
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXWELL,R,IOUT,IN)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IWELCB,R,IOUT,IN)
      END IF
      WRITE(IOUT,3) MXWELL
    3 FORMAT(1H ,'MAXIMUM OF',I5,' WELLS')
      IF(IWELCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(IWELCB.GT.0) WRITE(IOUT,8) IWELCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(IWELCB.LT.0) IWELCB=-1
      IUNIT2(2)=IWELCB
      IF(IWELCB.GT.0) THEN
         IF(FILTYP(IWELCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(IWELCB)=IUNIT(12)
         ELSE IF(FILTYP(IWELCB).EQ.' ') THEN
            IUNIT2(2)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(2).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(2).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(IWELCB.NE.0) IBDSAM=IWELCB
      ELSE
         IF(IBDSAM.NE.IWELCB) IBDSAM=0
      END IF
C
C-------Process auxiliary parameters
      WELAUX(1)=' '
      NAUX=0
20    CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1   LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.EQ.0) THEN
            NAUX=1
            IF(LINE(ISTART:ISTOP).EQ.'IFACE') THEN
               WELAUX(1)='IFACE'
               WRITE(IOUT,22) WELAUX(1)
            ELSE
               IF(INMP.EQ.0) THEN
                  NAUX=2
                  WELAUX(NAUX)=LINE(ISTART:ISTOP)
                  WRITE(IOUT,22) WELAUX(NAUX)
               ELSE
                  WRITE(IOUT,22) LINE(ISTART:ISTOP)
                  WRITE(IOUT,*) 'When MODPATH is used, the 1st',
     1                   ' AUXILIARY parameter must be "IFACE"'
                  CALL RDABRT
               END IF
            END IF
         ELSE IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            WELAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,22) WELAUX(NAUX)
22          FORMAT(1X,'AUXILIARY WELL PARAMETER: ',A)
         ELSE
            WRITE(IOUT,*) ' Too many auxiliary parameters for MFI'
            CALL RDABRT
         END IF
         GO TO 20
      ELSE IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE') THEN
         GO TO 20
      END IF
C  Allow use of MODPATH without an explicit IFACE auxiliary parameter -- turn
C  the IFACE parameter on if MODPATH is active.
      IF(INMP.NE.0) WELAUX(1)='IFACE'
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE WELRP(KPER,IWARN)
C     ******************************************************************
C     READ WELL DATA
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      CHARACTER*10 CMAX
C     ------------------------------------------------------------------
      IN=IUNIT(2)
C
C1------READ ITMP (NUMBER OF WELLS OR FLAG TO REUSE DATA).
      IF(MODINP.EQ.0) READ(IUREAL(IN),'(I10)') ITMP
      IF(MODINP.NE.0) READ(IUREAL(IN),*) ITMP
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) ' Undefined well data for stress period'
         RETURN
      END IF
      CALL LSTMAK('WELL',0,KPER,7)
      ARRCON(NARRAY)=1.
      IARRDA(1,NARRAY)=-2
C
C2------TEST ITMP.
      IF(ITMP.GE.0)GO TO 50
C
C2A-----IF ITMP <0 THEN REUSE DATA FROM LAST STRESS PERIOD.
      WRITE(IOUT,7)
    7 FORMAT(1X,/1X,'REUSING WELLS FROM LAST STRESS PERIOD')
      IF(KPER.EQ.1) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED WELL DATA'
         CALL RDABRT
      END IF
      NWELLS=-1
      CALL IVLSAV('WELL',0,KPER,NWELLS)
      RETURN
C
C3------IF ITMP=> ZERO THEN IT IS THE NUMBER OF WELLS.
   50 NWELLS=ITMP
      IF(ITMP.GT.MXLIST*10) THEN
         ITMP=MXLIST*10
         WRITE(CMAX,'(I10)') ITMP
         WRITE(IOUT,'(A)')
     1' WARNING -- Truncating wells -- maximum number is'//CMAX
         IWARN=IWARN+1
         IF(NMISS.LT.45) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)=
     1      ' WARNING -- Truncating wells -- maximum number is'//CMAX
         END IF
      END IF
      CALL IVLSAV('WELL',0,KPER,ITMP)
C
C5------PRINT NUMBER OF WELLS IN THIS STRESS PERIOD.
  100 WRITE(IOUT,101)NWELLS
  101 FORMAT(1X,//1X,I5,' WELLS')
C
C6------IF THERE ARE NO WELLS THEN RETURN.
      IF(NWELLS.EQ.0) RETURN
C
C7------READ AND PRINT DATA FOR EACH WELL.
      CALL LSTRD(NWELLS,NARRAY,X(IARRDA(2,NARRAY)),IN,
     1   'WELL NO.  LAYER   ROW   COL  RECHARGE RATE',WELAUX,3)
C
C8------RETURN.
      RETURN
      END
      SUBROUTINE WELED
C     ******************************************************************
C     Edit well data
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
      CHARACTER*8 LABEL(4,2)
      DATA LABEL/' ',    ' ',  ' ',     'WELL',
     1           'LAYER','ROW','COLUMN','RECHARGE'/
C     ------------------------------------------------------------------
C
C  Set IUNIT if not already set
      IF(IUNIT(2).EQ.0) THEN
         CALL FINDUN(12,IU,'WEL')
         IUNIT(2)=IU
         IUNIT2(2)=0
      END IF
C
C  Main WEL menu -- select the desired stress period -- default is 1
      KPER=1
10    CALL UPERIN('Well Data',KPER)
C  Return if "previous" was selected
      IF(KPER.EQ.0) THEN
         CALL WELSV(IUNDEF,1)
         RETURN
      END IF
C
C  Set up to get well data for a stress period.
C  If array does not already exist, create array.
      CALL IVLGET('WELL',0,KPER,NAR,NWELLS)
      IF(NAR.LE.0) THEN
         CALL LSTMAK('WELL',0,KPER,7)
         IARRDA(1,NARRAY)=-2
         ARRCON(NARRAY)=1.
         NWELLS=0
         NAR=NARRAY
      END IF
C
C  Get new data
      IMETH=1
      IF(KPER.GT.1) THEN
         IF(NWELLS.LT.0) IMETH=2
         CALL QRESP(MESSFL,307,4,IMETH)
      END IF
      IF(IMETH.EQ.1) THEN
         LOC=IARRDA(2,NAR)
C  Activate CONC as an AUX field if MOC is active
         IF(IUNIT(15).GT.0) THEN
            IF(WELAUX(2).NE.'CONC' .AND. WELAUX(2).NE.'CONCENTRATION'
     1              .AND. WELAUX(3).NE.'CONC' .AND.
     2             WELAUX(3).NE.'CONCENTRATION') THEN
               IF(WELAUX(2).EQ.' ') THEN
                  WELAUX(2)='CONC'
               ELSE IF(WELAUX(3).EQ.' ') THEN
                  WELAUX(3)='CONC'
               END IF
            END IF
         END IF
         CALL SSLST(X(LOC),NWELLS,LABEL,4,NAR,WELAUX,3)
      ELSE
         NWELLS=-1
      END IF
      CALL IVLSAV('WELL',0,KPER,NWELLS)
C
C  Ask for another stress period
      KPER=KPER+1
      IF(KPER.GT.NPER) KPER=1
      IF(NPER.GT.1) GO TO 10
C
C  End of WELL data input
      CALL WELSV(IUNDEF,1)
      RETURN
C
      END
      SUBROUTINE WELSV(IUNDEF,IWRFLG)
C
C     ******************************************************************
C     SAVE DATA FOR WELL PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for WEL Package
      COMMON /WELCOM/WELAUX(3)
      CHARACTER*16 WELAUX
C     ------------------------------------------------------------------
      IF(IUNIT(2).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      IF(IUREAL(IUNIT(2)).EQ.0) CALL REALUN(IUNIT(2))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.WEL',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(2)),UNIT=IFIL)
C
C  Find undefined data and maximum number of wells in all periods
      CALL LSTMAX('WELL',IWRFLG,IUNDEF,MXWELL,'WEL')
      IF(IWRFLG.LE.0) RETURN
C
C  Write the data
      IWELCB=IBUDUN
      IF(IBUDUN.EQ.0) IWELCB=IUNIT2(2)
      ITMPUN=IWELCB
      IF(ITMPUN.GT.0) THEN
         IF(IUREAL(ITMPUN).EQ.0) CALL REALUN(ITMPUN)
         ITMPUN=IUREAL(ITMPUN)
      END IF
C
C  Write data for each stress period
      CALL LSTSAV('WELL',IFIL,MXWELL,ITMPUN,
     1                    WELAUX,3,'    MXWELL IWELCB')
C
      CLOSE(UNIT=IFIL)
      RETURN
      END
