      SUBROUTINE SSLST(IXLOC,NLIST,LABEL,NMFLOW,NAR,CAUX,NCAUX)
C     ******************************************************************
C     Interface for editing a list using 123
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IXLOC(10)
      CHARACTER*(*) LABEL(NMFLOW,2)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*8 LABEL2(3,2)
      DIMENSION ISSCOL(20),MFICOL(20)
C
C  Tell user to wait until spreadsheet is done.
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
C  Generate ISSCOL (spreadsheet column for each item in a row of data
C  as stored in MODFLOW) and MFICOL (MODFLOW column for each item in a
C  row as stored the spreadsheet).
      DO 2 I=1,NMFLOW
      ISSCOL(I)=I
      MFICOL(I)=I
2     CONTINUE
      DO 3 I=1,3
      LABEL2(I,1)=' '
      LABEL2(I,2)=' '
      ISSCOL(NMFLOW+I)=0
3     CONTINUE
C
      NV=NMFLOW
      LSTDIM=IARRDA(3,NAR)
C
C  Activate IFACE as first AUX field if MODPATH is active
      IF(IUNIT(40).GT.0) THEN
         CAUX(1)='IFACE'
      END IF
C
C  Create spread sheet labels for AUX fields
      DO 5 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
C  Note that only non-blank labels will be displayed as columns in the
C  spread sheet
         LABEL2(I,2)=CAUX(I)
         NV=NV+1
         ISSCOL(NMFLOW+I)=NV
         MFICOL(NV)=NMFLOW+I
      END IF
5     CONTINUE
C
C  Create the spread sheet file
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      CALL SSLAWR(IUMISC,LABEL(1,1),NMFLOW,LABEL2(1,1),3,1)
      CALL SSLAWR(IUMISC,LABEL(1,2),NMFLOW,LABEL2(1,2),3,2)
C  Write existing values into spreadsheet file.
      IF(NLIST.GT.0) THEN
         DO 15 N=1,NLIST
         IGROUP=(N-1)/MXLIST + 1
         IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
         DO 10 L=1,LSTDIM
         IF(ISSCOL(L).GT.0) CALL SSWR(IUMISC,ISSCOL(L),N+2,X(IOFF + L))
10       CONTINUE
15       CONTINUE
      END IF
      CALL SSCLWR(IUMISC)
C
C  Activate the spreadsheet program.
      CALL SYSCAL('MFISS')
C
C  Read the edited values from the spreadsheet file.
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
C  Set old values to 0 before reading new values so that the old values
C  cannot be inadvertantly reused if the user leaves some fields in the
C  spreadsheet blank.  Most spreadsheets do not write out blank fields;
C  therefore, if values were not set to, blank fields in the spreadsheet
C  would result in reusing the former values in that field.  This would
C  be misleading because the user would not see this unless the values
C  were reedited in the spreadsheet.  Thus, setting all values to 0 avoids
C  this problem.
      DO 17 N=1,NLIST
      IGROUP=(N-1)/MXLIST + 1
      IOFF=IXLOC(IGROUP)+ (N-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
      DO 16 L=1,LSTDIM
      X(IOFF + L)=0.
16    CONTINUE
17    CONTINUE
C
      MXN=0
C  Read one value
20    CALL SSRD(IUMISC,L,N,R)
      IF(L.EQ.0) GO TO 30
      N=N-2
      IF(L.LE.NV .AND. N.GT.0 .AND. N.LE.MXLIST*10) THEN
         IF(N.GT.MXN) MXN=N
         IGROUP=(N-1)/MXLIST + 1
         IF(IGROUP.GT.IARRDA(4,NAR)) CALL LSTALO(NAR,IGROUP)
         IOFF=(N-1-(IGROUP-1)*MXLIST)*LSTDIM + MFICOL(L) - 1
         X(IXLOC(IGROUP)+IOFF)=R
      END IF
      GO TO 20
C
C  Entire spreadsheet file has been read.  Count the valid rows in
C  the list, and throw out invalid rows by moving the following rows
C  forward in the list.
30    NLIST=0
      DO 40 N=1,MXN
      IGROUP=(N-1)/MXLIST + 1
      IOFF=(N-1-(IGROUP-1)*MXLIST)*LSTDIM
      IL=X(IXLOC(IGROUP)+IOFF)
      IR=X(IXLOC(IGROUP)+IOFF+1)
      IC=X(IXLOC(IGROUP)+IOFF+2)
      IF(IC.LT.1    .OR. IR.LT.1    .OR. IL.LT.1 .OR.
     1   IC.GT.NCOL .OR. IR.GT.NROW .OR. IL.GT.NLAY) GO TO 40
      NLIST=NLIST+1
      IF(NLIST.NE.N) THEN
         IGRP2=(NLIST-1)/MXLIST + 1
         IOFF2=(NLIST-1-(IGRP2-1)*MXLIST)*LSTDIM
         DO 35 L=1,LSTDIM
         X(IXLOC(IGRP2)+IOFF2+L-1)=X(IXLOC(IGROUP)+IOFF+L-1)
         X(IXLOC(IGROUP)+IOFF+L-1)=0.
35       CONTINUE
      END IF
40    CONTINUE
C
C  Tell the user how many rows were accepted.
      CALL PMXTXI(MESSFL,300,11,10,1,0,1,NLIST)
C
      RETURN
      END
      SUBROUTINE SS2DR(XX,NCC,NR,LABEL)
C     ******************************************************************
C     Interface for editing a 2-D real array using 123
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION XX(NCC,NR)
      CHARACTER*(*) LABEL
C
      NC=NCC
      IF(NC.GT.256) NC=256
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      CALL SSSPLT(IUMISC,NC,NR)
      DO 11 J=1,NC
      DO 10 I=1,NR
      CALL SSWR(IUMISC,J,I,XX(J,I))
10    CONTINUE
      R=J
      IF(NC.GT.2) CALL SSWR(IUMISC,J,NR+2,R)
11    CONTINUE
      CALL SSCLWR(IUMISC)
C
      CALL SYSCAL('MFISS')
C
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      N=0
20    CALL SSRD(IUMISC,IC,IR,R)
      IF(IC.EQ.0) THEN
         NBAD=NC*NR-N
         IF(NBAD.NE.0) CALL PMXTXI(MESSFL,300,12,10,1,0,1,NBAD)
         RETURN
      END IF
      IF(IC.LE.NC .AND. IR.LE.NR .AND. IC.GT.0) THEN
         N=N+1
         XX(IC,IR)=R
      END IF
      GO TO 20
C
      END
      SUBROUTINE SS2DI(IX,NCC,NR,LABEL)
C     ******************************************************************
C     Interface for editing a 2-D integer array using 123
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IX(NCC,NR)
      CHARACTER*(*) LABEL
C
      NC=NCC
      IF(NC.GT.256) NC=256
      CALL PMXCNW(MESSFL,300,9,50,1,1,I)
C
      CALL SSOPWR(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      CALL SSSPLT(IUMISC,NC,NR)
      DO 11 J=1,NC
      DO 10 I=1,NR
      R=IX(J,I)
      CALL SSWR(IUMISC,J,I,R)
10    CONTINUE
      R=J
      IF(NC.GT.2) CALL SSWR(IUMISC,J,NR+2,R)
11    CONTINUE
      CALL SSCLWR(IUMISC)
C
      CALL SYSCAL('MFISS')
C
      CALL SSOPRD(IUMISC,IERR)
      IF(IERR.NE.0) RETURN
      N=0
20    CALL SSRD(IUMISC,IC,IR,R)
      IF(IC.EQ.0) THEN
         NBAD=NC*NR-N
         IF(NBAD.NE.0) CALL PMXTXI(MESSFL,300,12,10,1,0,1,NBAD)
         RETURN
      END IF
      IF(IC.LE.NC .AND. IR.LE.NR .AND. IC.GT.0) THEN
         N=N+1
         IX(IC,IR)=R
      END IF
      GO TO 20
C
      END
      SUBROUTINE SSSPLT(IU,NC,NR)
      INTEGER*2 ICODE,NREC,IWIN(16)
C     ******************************************************************
C     Split spreadsheet window to show numeric column numbers.
C     The first window, which also must be the top window, is the main
C     window.  It does not work to make the top window the column
C     number window because the cursor starts in the first window.  This
C     would force the user to change windows manually.
C     ******************************************************************
C  Do not split the window unless there are more than 18 rows
      IF(NR.LE.18) RETURN
C
C  Horizontal split, synchronized window
      ICODE=4
      NREC=1
      WRITE(IU) ICODE,NREC,CHAR(255)
      ICODE=5
      WRITE(IU) ICODE,NREC,CHAR(255)
C  Window 1
      ICODE=7
      NREC=32
      IWIN(1)=0
C  Cursor row
      IWIN(2)=0
C  Data format --  127 for default, 113 for general
      IWIN(3)=113
      IWIN(4)=9
      IWIN(5)=8
C  # of rows on screen
      IWIN(6)=18
      IWIN(7)=0
C  top row
      IWIN(8)=0
      IWIN(9)=0
      IWIN(10)=0
      IWIN(11)=0
      IWIN(12)=0
      IWIN(13)=4
C  Top-left position of 1st row of window (screen character coordinates)
      IWIN(14)=4
      IWIN(15)=72
      IWIN(16)=0
      WRITE(IU) ICODE,NREC,IWIN
C  Window 2
      ICODE=9
C  Cursor row
      IWIN(2)=NR+1
C  # of rows on screen
      IWIN(6)=1
C  top row
      IWIN(8)=NR+1
C  Top-left position of 1st row of window (screen character coordinates)
      IWIN(14)=23
      WRITE(IU) ICODE,NREC,IWIN
      RETURN
      END
      SUBROUTINE SSOPWR(IU,IERR)
C     ******************************************************************
C     Open spreadsheet file for writing
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      INTEGER*2 ICODE,NREC,IREV
      OPEN(UNIT=IU,FILE='AUTO123.WK1',ACCESS='TRANSPARENT',ERR=100)
C  Beginning of file
      ICODE=0
      NREC=2
      IREV=1030
      WRITE(IU) ICODE,NREC,IREV
      IERR=0
      RETURN
C
100   CALL PRNTXT(MESSFL,300,46)
      IERR=1
      RETURN
      END
      SUBROUTINE SSLAWR(IU,LABEL,NMFLOW,LABEL2,NCAUX,IR)
C     ******************************************************************
C     Write labels into a spreadsheet file
C     ******************************************************************
      CHARACTER*(*) LABEL(NMFLOW),LABEL2(NCAUX)
      INTEGER*2 ILABEL,NREC,ICOL,IROW
C
      ILABEL=15
      IROW=IR-1
C  Write MODFLOW's labels
      MXCHR=LEN(LABEL(1))
      DO 10 J=1,NMFLOW
      DO 5 I=MXCHR,1,-1
      IF(LABEL(J)(I:I).NE.' ') GO TO 6
5     CONTINUE
      I=1
6     NCHR=I
      NREC=7+NCHR
      ICOL=J-1
      WRITE(IU,ERR=100) ILABEL,NREC,
     1           CHAR(255),ICOL,IROW,'"',LABEL(J)(1:NCHR),CHAR(0)
10    CONTINUE
C  Write auxiliary labels
      MXCHR=LEN(LABEL2(1))
      ICOL=NMFLOW-1
      DO 20 J=1,NCAUX
      DO 15 I=MXCHR,1,-1
      IF(LABEL2(J)(I:I).NE.' ') GO TO 16
15    CONTINUE
      I=1
16    NCHR=I
      NREC=7+NCHR
      IF(LABEL2(J).NE.' ') THEN
         ICOL=ICOL+1
         WRITE(IU,ERR=100) ILABEL,NREC,
     1           CHAR(255),ICOL,IROW,'"',LABEL2(J)(1:NCHR),CHAR(0)
      END IF
20    CONTINUE
C
      RETURN
C
100   WRITE(*,*) ' Error writing spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSWR(IU,J,I,X)
C     ******************************************************************
C     Write value for 1 spreadsheet cell
C     ******************************************************************
      INTEGER*2 INUMB,NREC,ICOL,IROW
      DOUBLE PRECISION XX
C
      INUMB=14
      NREC=13
      ICOL=J-1
      IROW=I-1
      XX=X
      WRITE(IU,ERR=100) INUMB,NREC,CHAR(255),ICOL,IROW,XX
      RETURN
C
100   WRITE(*,*) ' Error writing spreadsheet file'
      CALL SAVALL(1,IERR)
      STOP
      END
      SUBROUTINE SSCLWR(IU)
C     ******************************************************************
C     Close spreadsheet file after writing
C     ******************************************************************
      INTEGER*2 IEND,NREC
      IEND=01
      NREC=0
      WRITE(IU) IEND,NREC
      CLOSE(UNIT=IU)
      RETURN
      END
      SUBROUTINE SSOPRD(IU,IERR)
C     ******************************************************************
C     Open the spreadsheet file for reading
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      INTEGER*2 IBEG,NREC,IREV
C
10    OPEN(UNIT=IU,FILE='AUTO123.WK1',ACCESS='TRANSPARENT',ERR=100)
      READ(IU,ERR=100) IBEG,NREC,IREV
      IF(IBEG.NE.0 .OR. NREC.NE.2 .OR. IREV.GT.1030 .OR. IREV.LT.1028)
     1                                 GO TO 200
      IERR=0
      RETURN
C
100   CALL QRESP(MESSFL,300,47,IRSP)
      IF(IRSP.EQ.1) GO TO 10
      IERR=1
      RETURN
200   CLOSE(UNIT=IU)
      CALL QRESP(MESSFL,300,48,IRSP)
      IF(IRSP.EQ.1) GO TO 10
      IERR=1
      RETURN
      END
      SUBROUTINE SSRD(IU,IC,IR,R)
C     ******************************************************************
C     Read a numeric value from spreadsheet file
C     ******************************************************************
      CHARACTER*1000 CREC
      INTEGER*2 ICODE,NREC,IDUM
      DOUBLE PRECISION RRDUM
      CHARACTER*2 CDUM
      CHARACTER*8 DDUM
      EQUIVALENCE (IDUM,CDUM)
      EQUIVALENCE (RRDUM,DDUM)
C
30    READ(IU,END=100,ERR=200) ICODE,NREC,(CREC(I:I),I=1,NREC)
      IF(ICODE.EQ.1) GO TO 100
C
      IF(ICODE.EQ.13) THEN
C  Integer
         CDUM=CREC(2:3)
         IC=IDUM+1
         CDUM=CREC(4:5)
         IR=IDUM+1
         CDUM=CREC(6:7)
         R=IDUM
         RETURN
      ELSE IF(ICODE.EQ.14 .OR. ICODE.EQ.16) THEN
C  Real Number with or without formula
         CDUM=CREC(2:3)
         IC=IDUM+1
         CDUM=CREC(4:5)
         IR=IDUM+1
         DDUM=CREC(6:13)
         IF(ABS(RRDUM).LT.1.18E-38) RRDUM=0.D0
         R=RRDUM
         RETURN
      END IF
C
C  No value in this record -- read next record
      GO TO 30
C
100   CLOSE(UNIT=IU,STATUS='DELETE')
      IC=0
      RETURN
C
200   GO TO 30
      END
